#include <vector>  
#include <list>  
#include <map>  
#include <set>  
#include <queue>  
#include <deque>  
#include <stack>  
#include <bitset>  
#include <algorithm>  
#include <functional>  
#include <numeric>  
#include <utility>  
#include <sstream>  
#include <iostream>  
#include <iomanip>  
#include <cstdio>  
#include <cmath>  
#include <cstdlib>  
#include <ctime>  
#include <fstream>  
#include <cstring>  
using namespace std;  
  
typedef long long ll;  
typedef vector<int> vi;  
typedef pair<int, int> ii;  
typedef vector<ii> vii;  
typedef set<int> si;  
typedef map<string, int> msi;  
  
#define FOR(i, a, b) for (int i = a; i < b; i++)   
#define REP(i, n) FOR(i,0,n)  
#define GI ({int t;scanf("%d",&t);t;})  
#define GL ({LL t;scanf("%lld",&t);t;})  
#define GD ({double t;scanf("%lf",&t);t;})  
#define TRvi(c, it) for (vi::iterator it = (c).begin(); it != (c).end(); it++)  
#define TRvii(c, it) for (vii::iterator it = (c).begin(); it != (c).end(); it++)  
#define TRmsi(c, it) for (msi::iterator it = (c).begin(); it != (c).end(); it++)  
#define flush(x) memset(x,0,sizeof(x))  
#define MAXN 510  
#define INF 1<<25  
#define MOD 1000000007  
  
int AdjMat[MAXN][MAXN];  
vi RemList[MAXN];  
  
int dist[MAXN],ways[MAXN],minnodes[MAXN];  
  
struct node  
{  
    int x, cost;  
    node(int x,int cost)  
    {  
        this->x=x;  
        this->cost=cost;  
    }  
};  
  
bool operator<(node x, node y)  
{  
    if(x.cost!=y.cost)  
        return x.cost>y.cost;  
    else  
        return x.x>y.x;  
          
}  
  
  
void dijkstra1(int x,int d)  
{  
    REP(i,MAXN+1) dist[i]=INF;  
    priority_queue<node> q;  
    dist[x]=0;  
    q.push(node(x,dist[x]));  
    while(!q.empty())  
    {  
        int u=q.top().x;  
        int cost=q.top().cost;  
        q.pop();  
        if(u==d)  
            break;  
        if(cost==dist[u])  
        {  
            FOR(i,1,MAXN+1)  
            if(AdjMat[u][i])  
            {  
                if(dist[u]+AdjMat[u][i]==dist[i])  
                    RemList[i].push_back(u);                  
                else if(dist[u]+AdjMat[u][i]<dist[i])  
                {  
                    dist[i]=dist[u]+AdjMat[u][i];  
                    RemList[i].clear();  
                    q.push(node(i,dist[i]));  
                    RemList[i].push_back(u);  
                }  
            }  
        }  
    }  
    queue<int> remq;  
    remq.push(d);  
    while(!remq.empty())  
    {  
        int u=remq.front();        
        remq.pop();  
        TRvi(RemList[u],v)  
        {  
            remq.push(*v);  
            AdjMat[*v][u]=0;  
        }  
    }  
}  
  
void dijkstra2(int x,int d)  
{  
    REP(i,MAXN+1) dist[i]=INF;  
    flush(ways);  
    REP(i,MAXN+1) minnodes[i]=INF;  
    priority_queue<node> q;  
    dist[x]=0;  
    ways[x]=1;  
    minnodes[x]=1;  
    q.push(node(x,dist[x]));  
    while(!q.empty())  
    {  
        int u=q.top().x;  
        int cost=q.top().cost;  
        q.pop();  
        if(u==d)  
            break;  
        if(cost==dist[u])  
        {  
            FOR(i,1,MAXN+1)  
            if(AdjMat[u][i])  
            {  
                if(dist[u]+AdjMat[u][i]==dist[i])  
                {  
                    if(minnodes[i]==minnodes[u]+1)  
                        (ways[i]+=ways[u])%=MOD;          
                    else if(minnodes[i]>minnodes[u]+1)  
                    {  
                        ways[i]=ways[u];  
                        minnodes[i]=minnodes[u]+1;  
                    }  
                }  
                else if(dist[u]+AdjMat[u][i]<dist[i])  
                {  
                    dist[i]=dist[u]+AdjMat[u][i];  
                    q.push(node(i,dist[i]));  
                    ways[i]=ways[u];  
                    minnodes[i]=minnodes[u]+1;  
                }  
            }  
        }  
    }  
}  
  
int main()  
{  
    int t;  
    t = GI;  
    while(t--)  
    {  
        flush(AdjMat);  
        int n,m;  
        n = GI;  
        m = GI;  
        REP(i,m)  
        {  
            int x,y,c;  
            x = GI;  
            y = GI;  
            c = GI;  
            AdjMat[x][y]=c;  
        }  
        int s,d;  
        s = GI;  
        d = GI;  
        dijkstra1(s,d);  
        dijkstra2(s,d);  
        if(dist[d]==INF)  
            printf("-1\n");  
        else  
            printf("%d %d %d\n",dist[d],minnodes[d],ways[d]);  
    }  
}  
