import java.io.InputStreamReader;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskA solver = new TaskA();
		solver.solve(1, in, out);
		out.close();
	}
}

class TaskA {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int R = in.nextInt();
        int r = in.nextInt();
        if (n == 1) {
            if (R >= r)
                out.println("YES");
            else
                out.println("NO");
        } else {
            if (R >= 2 * r) {
                double alpha = Math.asin(r / (double) (R - r));
                if (alpha * n <= Math.PI + 1e-10) {
                    out.println("YES");
                } else {
                    out.println("NO");
                }
            } else {
                out.println("NO");
            }
        }
	}
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    }

----

import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Arrays;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		solver.solve(1, in, out);
		out.close();
	}
}

class TaskB {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int[][] pref = new int[n][n];
        int[][] prefRev = new int[n][n];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                pref[i][j] = in.nextInt() - 1;
                prefRev[i][pref[i][j]] = j;
            }
        }
        int[] alex = new int[n];
        int[] alexRev = new int[n];
        for (int i = 0; i < n; ++i) {
            alex[i] = in.nextInt() - 1;
            alexRev[alex[i]] = i;
        }
        int[] willSend = new int[n];
        Arrays.fill(willSend, n);
        int[] at = new int[n];
        Arrays.fill(at, -1);
        int best = n;
        int secondBest = n;
        for (int i = 0; i < n; ++i) {
            int cur = alexRev[i];
            if (cur < best) {
                secondBest = best;
                best = cur;
            } else if (cur < secondBest) {
                secondBest = cur;
            }
            int bestWho = best == n ? n : alex[best];
            int secondBestWho = secondBest == n ? n : alex[secondBest];
            for (int j = 0; j < n; ++j) {
                if (j != bestWho) {
                    if (bestWho != n) {
                        int gets = prefRev[j][bestWho];
                        if (gets < willSend[j]) {
                            willSend[j] = gets;
                            at[j] = i;
                        }
                    }
                } else {
                    if (secondBestWho != n) {
                        int gets = prefRev[j][secondBestWho];
                        if (gets < willSend[j]) {
                            willSend[j] = gets;
                            at[j] = i;
                        }
                    }
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (i > 0) out.print(" ");
            out.print(at[i] + 1);
        }
        out.println();
	}
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    }

----

import java.util.List;
import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.ArrayList;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskC solver = new TaskC();
		solver.solve(1, in, out);
		out.close();
	}
}

class TaskC {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int[] r = new int[n];
        for (int i = 0; i < n; ++i) {
            r[i] = in.nextInt();
        }
        Arrays.sort(r);
        int[] what = new int[n];
        int[] count = new int[n];
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (i == 0 || r[i] != r[i - 1]) {
                what[cnt] = r[i];
                count[cnt] = 1;
                ++cnt;
            } else ++count[cnt - 1];
        }
        int[] next = new int[n + n + 1];
        int[] prev = new int[n + n + 1];
        for (int i = 0; i <= n; ++i) {
            next[i + n] = i + n;
            prev[i + n] = i + n;
        }
        for (int i = 0; i < cnt; ++i) {
            prev[i] = count[i] + n;
            next[i] = next[count[i] + n];
            prev[next[i]] = i;
            next[prev[i]] = i;
        }
        int[] nextNonEmpty = new int[n + 2];
        int[] prevNonEmpty = new int[n + 2];
        nextNonEmpty[n + 1] = n + 1;
        prevNonEmpty[n + 1] = n + 1;
        for (int i = 0; i <= n; ++i)
            if (next[i + n] != i + n) {
                prevNonEmpty[i] = n + 1;
                nextNonEmpty[i] = nextNonEmpty[n + 1];
                prevNonEmpty[nextNonEmpty[i]] = i;
                nextNonEmpty[prevNonEmpty[i]] = i;
            }
        List<String> res = new ArrayList<String>();
        int[] cur = new int[3];
        while (true) {
            int tmp = nextNonEmpty[n + 1];
            boolean ok = true;
            int tmpPos = tmp + n;
            for (int i = 0; i < 3; ++i) {
                if (tmp == 0 || tmp == n + 1) {
                    ok = false;
                    break;
                }
                tmpPos = next[tmpPos];
                if (tmpPos == tmp + n) {
                    tmp = nextNonEmpty[tmp];
                    if (tmp == 0 || tmp == n + 1) {
                        ok = false;
                        break;
                    }
                    tmpPos = next[tmp + n];
                    if (tmpPos == tmp + n) throw new RuntimeException();
                }
                cur[i] = tmpPos;
            }
            if (!ok) break;
            Arrays.sort(cur);
            res.add((what[cur[2]]) + " " + (what[cur[1]]) + " " + (what[cur[0]]));
            for (int i = 0; i < 3; ++i) {
                int x = cur[i];
                int y = count[x];
                next[prev[x]] = next[x];
                prev[next[x]] = prev[x];
                next[x] = next[y - 1 + n];
                prev[x] = y - 1 + n;
                next[prev[x]] = x;
                prev[next[x]] = x;
                if (next[x] == prev[x]) {
                    nextNonEmpty[y - 1] = nextNonEmpty[y];
                    prevNonEmpty[y - 1] = y;
                    nextNonEmpty[prevNonEmpty[y - 1]] = y - 1;
                    prevNonEmpty[nextNonEmpty[y - 1]] = y - 1;
                }
                if (next[y + n] == y + n) {
                    nextNonEmpty[prevNonEmpty[y]] = nextNonEmpty[y];
                    prevNonEmpty[nextNonEmpty[y]] = prevNonEmpty[y];
                }
                count[x] = y - 1;
            }
        }
        out.println(res.size());
        for (String x : res) {
            out.println(x);
        }
	}
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    }

----

import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Arrays;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskD solver = new TaskD();
		solver.solve(1, in, out);
		out.close();
	}
}

class TaskD {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; ++i) {
            a[i] = in.nextInt();
        }
        Arrays.sort(a);
        int score = 0;
        int time = 0;
        int curTime = 10;
        int totalTime = 720;
        for (int x : a) {
            curTime += x;
            if (curTime > totalTime) break;
            score += 1;
            time += Math.max(0, curTime - 360);
        }
        out.println(score + " " + time);
	}
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    }

----

import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Arrays;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.math.BigInteger;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskE solver = new TaskE();
		solver.solve(1, in, out);
		out.close();
	}
}

class TaskE {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        long m = in.nextLong();
        long p = in.nextLong();
        long[] primes = new long[100];
        int numPrimes = 0;
        long tmp = p;
        for (int i = 2; i * i <= tmp; ++i) {
            if (tmp % i == 0) {
                primes[numPrimes++] = i;
                while (tmp % i == 0) tmp /= i; 
            }
        }
        if (tmp > 1) {
            primes[numPrimes++] = tmp;
        }
        int[] l = new int[n + 1];
        int maxL = 0;
        for (int i = 0; i < n; ++i) {
            l[i + 1] = in.nextInt();
            maxL = Math.max(maxL, l[i + 1]);
        }
        long[] comb = new long[maxL + 1];
        int[] pow = new int[numPrimes];
        long prod = 1;
        comb[0] = 1;
        for (int i = 1; i <= maxL; ++i) {
            long mulBy = m - i + 1;
            if (mulBy <= 0) {
                comb[i] = 0;
                continue;
            }
            for (int j = 0; j < numPrimes; ++j)
                while (mulBy % primes[j] == 0) {
                    mulBy /= primes[j];
                    ++pow[j];
                }
            long divBy = i;
            for (int j = 0; j < numPrimes; ++j) {
                while (divBy % primes[j] == 0) {
                    divBy /= primes[j];
                    --pow[j];
                }
            }
            prod = prod * mulBy % p;
            prod = prod * BigInteger.valueOf(divBy).modInverse(BigInteger.valueOf(p)).longValue() % p;
            long val = prod;
            for (int j = 0; j < numPrimes; ++j) {
                val = val * pow(primes[j], pow[j], p) % p;
            }
            comb[i] = val;
        }
        ++n;
        long[] ways = new long[maxL + 1];
        long[] nways = new long[maxL + 1];
        int[][] lineWays = new int[maxL + 1][maxL + 1];
        lineWays[1][1] = 1;
        for (int lineLen = 2; lineLen <= maxL; ++lineLen) {
            for (int numColors = 2; numColors <= lineLen; ++numColors) {
                lineWays[lineLen][numColors] = (int) ((lineWays[lineLen - 1][numColors] * (long) (numColors - 1) + lineWays[lineLen - 1][numColors - 1] * (long) numColors) % p);
            }
        }
        ways[0] = 1;
        for (int i = 1; i < n; ++i) {
            int curL = l[i];
            int prevL = l[i - 1];
            Arrays.fill(nways, 0, curL + 1, 0);
            int[] clWays = lineWays[curL];
            long sum = 0;
            for (int j = 0; j <= prevL; ++j) {
                sum += comb[j] * ways[j];
                sum %= p;
            }
            for (int j = 0; j <= curL; ++j) {
                if (j <= prevL) {
                    nways[j] = ((sum + p - ways[j]) * clWays[j]) % p;
                } else {
                    nways[j] = sum * clWays[j] % p;
                }
            }
            long[] tmpA = ways;
            ways = nways;
            nways = tmpA;
        }
        long total = 0;
        for (int i = 0; i <= l[n - 1]; ++i) {
            total = (total + ways[i] * comb[i]) % p;
        }
        out.println(total);
	}

    private long pow(long a, int k, long p) {
        if (k == 0) {
            return 1;
        }
        if (k % 2 == 0) {
            return pow(a * a % p, k / 2, p);
        }
        return a * pow(a, k - 1, p) % p;
    }
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public long nextLong() {
        return Long.parseLong(next());
    }

    }

----

import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Arrays;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskF solver = new TaskF();
		solver.solve(1, in, out);
		out.close();
	}
}

class TaskF {
    static class Point implements Comparable<Point> {
        int x;
        int y;

        public int compareTo(Point point) {
            if (x != point.x) return x - point.x; else return y - point.y;
        }

        Point(int x, int y) {
            this.x = x;
            this.y = y;
        }
        
        Point() {
        }
    }
    
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int k = in.nextInt();
        Point[] p = new Point[n];
        for (int i = 0; i < n; ++i) {
            p[i] = new Point();
            p[i].x = in.nextInt();
            p[i].y = in.nextInt();
            //p[i].x = 57;
            //p[i].y = 43;
        }
        Arrays.sort(p);
        if (k >= n) {
            out.println(-1);
            return;
        }
        Point[] res = new Point[100];
        int numRes = 0;
        for (int first = 0; first <= k; ++first)
            for (int second = 0; second + first <= k; ++second) {
                int sx = p[first].x + p[n - 1 - second].x;
                int sy = p[first].y + p[n - 1 - second].y;
                int p1 = first;
                int p2 = n - 1 - second;
                int skipped = first + second;
                while (skipped <= k && p1 <= p2) {
                    int cx = p[p1].x + p[p2].x;
                    int cy = p[p1].y + p[p2].y;
                    if (cx < sx) {
                        ++p1;
                        ++skipped;
                    } else if (cx > sx) {
                        --p2;
                        ++skipped;
                    } else if (cy < sy) {
                        ++p1;
                        ++skipped;
                    } else if (cy > sy) {
                        --p2;
                        ++skipped;
                    } else {
                        ++p1;
                        --p2;
                    }
                }
                if (skipped <= k) {
                    res[numRes++] = new Point(sx, sy);
                }
            }
        Arrays.sort(res, 0, numRes);
        int cnt = 0;
        for (int i = 0; i < numRes; ++i) {
            if (i == 0 || res[i].compareTo(res[i - 1]) != 0) {
                res[cnt++] = res[i];
            }
        }
        out.println(cnt);
        for (int i = 0; i < cnt; ++i) {
            out.println(res[i].x / 2.0 + " " + res[i].y / 2.0);
        }
	}
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    }