// Authored by dolphinigle
// Codeforces #107
// 17 February 2011
// Author: GlebsHP and SergeiFedorov

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <assert.h>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))

#define SZ(Z) ((int)(Z).size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;

vector< ll > GetDivisors(long long number) {
	vector<ll> ret;
	for (ll i = 1; i <= ceil(sqrt(number)); ++i) {
		if (number % i == 0) {
			ret.PB(i);
			ret.PB(number / i);
		}
	}
	sort(ALL(ret));
	ret.erase(unique(ALL(ret)), ret.end());
	return ret;
}
//vector<ll> divs = GetDivisors(6); {1,2,3,6} O(sqrt(N))

vector< pair<ll,ll> > Factorize(ll number) {
  vector< pair<ll, ll> > ret;
  vector<ll> divisors = GetDivisors(number);
  FORN(i,SZ(divisors)) if (divisors[i] > 1) {
    ll cnt = 0;
    for(;number % divisors[i] == 0LL;++cnt) {
      number /= divisors[i];
    }
    if (cnt) ret.PB(MP(divisors[i], cnt));
  }
  return ret;
}

int IsPrime(ll number) {
  if (number <= 1LL) return 0;
	for (ll i = 2LL;i * i <= number;i = (i == 2LL ? 3LL : i + 2LL)) {
		if (number % i == 0LL) return 0;
		}
	return 1;
	}
//IsPrime(1) == 0

int main() {
  
  ll n;
  cin >> n;
  
  if (n == 1LL || IsPrime(n)) {
    cout << 1 << endl << 0 << endl;
    return 0;
  }
  
  vector< pair<ll, ll> > ff = Factorize(n);
  
  vector<ll> factors;
  FORN(i, SZ(ff)) FORN(j, ff[i].B) factors.PB(ff[i].A);
  if (SZ(factors) >= 3) {
    cout << 1 << endl << factors[0] * factors[1] << endl;
  } else {
    cout << 2 << endl;
  }
  
}

----

// Authored by dolphinigle
// Codeforces #107
// 17 February 2011
// Author: GlebsHP and SergeiFedorov

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <assert.h>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))

#define SZ(Z) ((int)(Z).size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;

class DisjointSet {
  public:
  	explicit DisjointSet(int n) {
  		whichset_ = vector<int>(n);
  		height_ = vector<int>(n, 1);
  		for (int i = 0; i < n; ++i) whichset_[i] = i;
  	}

  	int Find(int node) {
  		if (whichset_[node] == node) return node;
  		return (whichset_[node] = Find(whichset_[node]));
  	}

  	void Merge(int first_node, int second_node) {
  		//cek siapa mo jadi bokapnya?
  		int h1 = height_[Find(first_node)];
  		int h2 = height_[Find(second_node)];
  		if (h1 < h2) {
	  		whichset_[Find(first_node)] = Find(second_node);
	  		return;
	  	}
	  	whichset_[Find(second_node)] = Find(first_node);
	  	if (h2 < h1) return;
	  	++height_[Find(second_node)];
  	}

  private:
  	vector<int> whichset_;
  	vector<int> height_;
};

//DisjointSet ds(jumlah_node);
//ds.Merge(0,1);
//ds.Find(1) //return 0 ato 1

ll MODU = 1000000007LL;

int main() {
  int n, m, k;
  cin >> n >> m >> k;
  
  DisjointSet ds(n);
  FORN(i, n) {
    if (i+k <= n) {
      FORN(j, k) ds.Merge(i+j, i+k-j-1);
    }
  }
  
  set<int> s;
  FORN(i, n) s.insert(ds.Find(i));
  
  ll ret = 1LL;
  FORN(i, SZ(s)) {
    ret *= (ll) m;
    ret %= MODU;
  }
  
  cout << ret << endl;
}

----

// Authored by dolphinigle
// Codeforces #107
// 17 February 2011
// Author: GlebsHP and SergeiFedorov

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <assert.h>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))

#define SZ(Z) ((int)(Z).size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;

int loc[400000];
ll sumlen[400000];
db profit[400000];

int a[400000];
int b[400000];

db hit[200000];

class MaxSubstringSum {
 public:
  // 0..n-1, initially 0
  MaxSubstringSum(int n) {
    int real_n = 1;
    while (real_n < n) {
      real_n *= 2;
    }
    lb_ = new int[2 * real_n + 1];
    ub_ = new int[2 * real_n + 1];
    max_value_ = new db[2 * real_n + 1];
    max_left_ = new db[2 * real_n + 1];
    max_right_ = new db[2 * real_n + 1];
    sum_all_ = new db[2 * real_n + 1];
    
    FORN(i, 2 * real_n + 1) {
      lb_[i] = ub_[i] = 0;
      max_value_[i] = max_left_[i] = max_right_[i] = sum_all_[i] = 0.0;
    }
    
    for (int i = 0; i < real_n; ++i) {
      lb_[real_n + i] = i;
      ub_[real_n + i] = i;
    }
    for (int i = real_n - 1; i >= 1; --i) {
      lb_[i] = lb_[i * 2];
      ub_[i] = ub_[i * 2 + 1];
    }
  }
  
  void Build(int node) {
    if (lb_[node] == ub_[node]) {
      // at leaf
      max_value_[node] = max_left_[node] = max_right_[node] = max(0.0, profit[lb_[node]]);
      sum_all_[node] = profit[lb_[node]];
    } else {
      Build(node*2);
      Build(node*2+1);
      
      sum_all_[node] = sum_all_[node*2] + sum_all_[node*2+1];
      max_left_[node] = max(max_left_[node*2], sum_all_[node*2] + max_left_[node*2+1]);
      max_right_[node] = max(max_right_[node*2+1], sum_all_[node*2+1] + max_right_[node*2]);
      max_value_[node] = max(max_value_[node*2], max(max_value_[node*2+1], max_right_[node*2] + max_left_[node*2+1]));
    }
  }
  
  db GetLMax(int low, int hi, int node = 1) {
    if (lb_[node] >= low && ub_[node] <= hi) {
      return max_left_[node];
    }
    
    if (lb_[node] > hi || ub_[node] < low) return 0.0;
    
    db ret = GetLMax(low, hi, node*2);
    if (lb_[node*2] >= low && ub_[node*2] <= hi) {
      MX(ret, GetLMax(low, hi, node*2+1) + sum_all_[node*2]);
    }
    return ret;
  }
  
  db GetRMax(int low, int hi, int node = 1) {
    if (lb_[node] >= low && ub_[node] <= hi) {
      return max_right_[node];
    }
    
    if (lb_[node] > hi || ub_[node] < low) return 0.0;
    
    db ret = GetRMax(low, hi, node*2+1);
    if (lb_[node*2+1] >= low && ub_[node*2+1] <= hi) {
      MX(ret, GetRMax(low, hi, node*2) + sum_all_[node*2+1]);
    }
    return ret;
  }

  db GetMax(int low, int hi, int node = 1) {
    if (lb_[node] >= low && ub_[node] <= hi) {
      // cout << lb_[node] << " " << ub_[node] << " " << max_value_[node] << endl;
      return max_value_[node];
    }
    
    if (lb_[node] > hi || ub_[node] < low) return 0.0;
    
    db best = max(GetMax(low, hi, node*2), GetMax(low, hi, node*2+1));
    MX(best, GetRMax(low, hi, node*2) + GetLMax(low, hi, node*2+1));
    
    // cout << lb_[node] << " " << ub_[node] << " " << best << endl;
    return best;
  }

 private:
  int* lb_;
  int* ub_;
  db* max_value_;
  db* max_left_;
  db* max_right_;
  db* sum_all_;
};

int main() {
  int n, m, c;
  cin >> n >> m >> c;
  
  FORN(i, n) {
    scanf("%d", loc + i);
  }
  
  sumlen[0] = 0;
  REP(i, 1, n) {
    sumlen[i] = sumlen[i-1] + (ll)loc[i] - (ll)loc[i-1];
  }
  
  FORN(i, n-1) {
    int x;
    scanf("%d", &x);
    hit[i] = (db)x / 100.0;
  }
  
  FORN(i, m) {
    scanf("%d%d", a+i, b+i);
  }
  
  FORN(i, n-1) {
    profit[i] = (db)(loc[i+1] - loc[i]) / 2.0 - (db)hit[i] * (db)c;
    // cout << profit[i] << endl;
  }
  
  MaxSubstringSum tree(n);
  tree.Build(1);
  db ret = 0.0;
  FORN(i, m) {
    // cout << a[i] << " " << b[i] << endl;
    // cout << tree.GetMax(a[i] - 1, b[i] - 2, 1) << endl;
    ret += tree.GetMax(a[i] - 1, b[i] - 2, 1);
  }
  printf("%.10lf\n", ret);
  
}

----

// Authored by dolphinigle
// Codeforces #107
// 17 February 2011
// Author: GlebsHP and SergeiFedorov

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <assert.h>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))

#define SZ(Z) ((int)(Z).size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;

int dp[152][152][152];
int score[152];

string str;

int yeah[152][152];

int best[152];

int Solve(int a, int b, int pad) {
  assert(a >= 0 && a < SZ(str) && b >= 0 && b < SZ(str) && pad >= 0 && pad <= SZ(str)/2);
  assert(pad*2 <= SZ(str));
  int& alias = dp[a][b][pad];
  if (alias != -2) return alias;
  
  alias = -1;
  if (a > b) {
    if (pad == 0) return alias = 0;
    return alias = score[pad*2];
  }
  
  if (a == b && score[pad * 2 + 1] != -1) {
    assert(pad * 2 + 1 <= SZ(str));
    MX(alias, score[pad * 2 + 1]);
  }
  
  if (a != b && str[a] == str[b]) {
    MX(alias, Solve(a+1, b-1, pad+1));
  }
  
  for (int i = a; i <= b; ++i) {
    if (i == b && pad == 0) continue;
    int sc = Solve(a, i, 0);
    if (sc == -1) continue;
    int mk = Solve(i+1, b, pad);
    if (mk == -1) continue;
    MX(alias, sc + mk);
  }
  
  for (int i = a; i <= b; ++i) {
    if (i == a && pad == 0) continue;
    int sc = Solve(i, b, 0);
    if (sc == -1) continue;
    int mk = Solve(a, i-1, pad);
    if (mk == -1) continue;
    MX(alias, sc + mk);
  }
  
  // cout << a << " " << b << " " << pad << " " << alias << endl;
  return alias;
}

int main() {
  FORN(i, 152) FORN(j, 152) FORN(k, 152) dp[i][j][k] = -2;
  int n;
  cin >> n;
  FORN(i, n) {
    cin >> score[i+1];
  }
  cin >> str;
  
  FORN(i, n) REP(j, i, n) {
    yeah[i][j] = max(0, Solve(i, j, 0));
  }
  
  FORN(i, n+1) best[i] = 0;
  FORN(i, n) REP(j, i, n) MX(best[j+1], best[i] + yeah[i][j]);
  cout << best[n] << endl;
}