#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int MAXL = 2100;
char s[MAXL + 1];
char t[MAXL + 1];

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #endif

  while (scanf("%s%s", s, t) >= 1) {
    int l1 = strlen(s), l2 = strlen(t);

    int ans = l2;
    for (int st = -l2; st < l1; st++) {
      int cans = 0;
      for (int i = 0; i < l2; i++) {
        int pos = st + i;
        if (pos < 0 || pos >= l1) {
          cans++;
          continue;
        }
        cans += s[pos] != t[i];
      }
      ans = min(ans, cans);
    }
    printf("%d\n", ans);
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #endif

  int n, m;
  while (scanf("%d%d", &n, &m) >= 1) {
    vi t(n), f(n);
    vi as(n);
    for (int i = 0; i < n; i++) {
      scanf("%d", &as[i]);
      if (as[i] > 0) t[as[i] - 1]++;
      else f[-as[i] - 1]++;
    }

    int sf = 0;
    for (int i = 0; i < n; i++)
      sf += f[i];

    int kcnt = 0;
    vb ckill(n, false);
    for (int kill = 0; kill < n; kill++) {
      int ccnt = t[kill] + sf - f[kill];
      if (ccnt != m) continue;
      kcnt++;
      ckill[kill] = true;
    }
    assert(kcnt >= 1);

    for (int i = 0; i < n; i++) {
      int x = abs(as[i]) - 1;

      if (as[i] > 0) {
        if (!ckill[x]) printf("Lie\n");
        else if (kcnt == 1) printf("Truth\n");
        else printf("Not defined\n");
      } else {
        if (!ckill[x]) printf("Truth\n");
        else if (kcnt == 1) printf("Lie\n");
        else printf("Not defined\n");
      }
    }
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int MOD = 1e9 + 7;
void add(int &a, int b) {
  a += b;
  if (a >= MOD) a -= MOD;
}

const int MAXL = 110;
char s[MAXL + 1];

const int MAXV = 25;
const int MAXS = MAXL * MAXV;

int d[MAXL + 1][MAXS + 1];

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #endif

  memset(d, 0, sizeof d);
  d[0][0] = 1;
  for (int l = 0; l < MAXL; l++)
  for (int ps = 0; ps <= MAXS; ps++)
    for (int nv = 0; nv <= MAXV && ps + nv <= MAXS; nv++)
      add(d[l + 1][ps + nv], d[l][ps]);

  int TC;
  assert(scanf("%d", &TC) >= 1);
  while (TC --> 0) {
    scanf("%s", s);
    int l = strlen(s), sum = 0;
    for (int i = 0; i < l; i++)
      sum += s[i] - 'a';
    int res = d[l][sum];
    add(res, MOD - 1);
    printf("%d\n", res);
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int MOD;
void add(int &a, int b) {
  a = (a + b) % MOD;
}
int mul(int a, int b) { return ll(a) * b % MOD; }

vvi es;
vb was;

int dfs(int v) {
  if (was[v]) return 0;
  was[v] = true;
  int res = 1;
  for (int i = 0; i < sz(es[v]); i++)
    res += dfs(es[v][i]);
  return res;
}

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #endif

  int n, m;
  while (scanf("%d%d%d", &n, &m, &MOD) >= 1) {
    es = vvi(n);
    for (int i = 0; i < m; i++) {
      int a, b;
      scanf("%d%d", &a, &b), a--, b--;
      es[a].pb(b);
      es[b].pb(a);
    }
    if (MOD == 1) {
      printf("0\n");
      continue;
    }

    vi ws;
    was = vb(n, false);
    for (int i = 0; i < n; i++) if (!was[i])
      ws.pb(dfs(i));

    n = sz(ws);
    int res = 1;

    if (n != 1) {
      for (int i = 0; i < n; i++)
        res = mul(res, ws[i]);

      int k = 0;
      for (int i = 0; i < n; i++) add(k, ws[i]);
      for (int i = 0; i < n - 2; i++) res = mul(res, k);
    }
    printf("%d\n", res);
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

void add(int &a, int b, int p) {
  a = (a + b) % p;
}
int mul(int a, int b, int p) {
  return a * b % p;
}
int getid(char c) {
  if (c >= '0' && c <= '9') return c - '0';
  assert(c >= 'A' && c <= 'F');
  return c - 'A' + 10;
}

const int MAXD = 16;
const int MAXN = 1e4;
const int MSZ = 4;
const ll MMSK = (1 << MSZ) - 1;

struct Req {
  int d;
  ll msk, mval, c;
  bool bad;
};

ll ids[MAXD + 1][MAXN];
int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #endif

  vi ps;
  for (int i = 2; i <= 100; i++) {
    bool g = true;
    for (int i2 = 2; i2 * i2 <= i; i2++)
      if (i % i2 == 0) g = false;
    if (!g) continue;
    ps.pb(i);
  }

  for (int d = 2; d <= MAXD; d++) {
    for (int i = 0; i < MAXN; i++) {
      vi ds;
      int x = i;
      for (; x; x /= d) ds.pb(x % d);

      ll &msk = ids[d][i] = 0;
      for (int i2 = 0; i2 < sz(ds); i2++)
        msk |= (ll)ds[i2] << (MSZ * i2);
    }
  }

  int n, m;
  while (scanf("%d", &n) >= 1) {
    vll as(n);
    vvll asp(n);
    for (int i = 0; i < n; i++) {
      scanf("%I64d", &as[i]);
      for (int i2 = 0; i2 < sz(ps); i2++)
        asp[i].pb(as[i] % ps[i2]);
    }

    scanf("%d", &m);
    vector<set<ll> > msks(MAXD + 1);
    vector<Req> rqs(m);
    for (int i = 0; i < m; i++) {
      int &d = rqs[i].d;
      char _s[31];
      scanf("%d%s%I64d", &d, _s, &rqs[i].c);
      string s = _s;
      while (s.length() < 14) s = "0" + s;

      int i2 = 0;
      int pos = s.length() - 1;
      bool &bad = rqs[i].bad = false;
      while (pos >= 14) {
        if (s[i2] != '?' && s[i2] != '0') {
          bad = true;
          break;
        }
        i2++;
        pos--;
      }
      if (bad)
        continue;

      ll &msk = rqs[i].msk, &mval = rqs[i].mval;
      for (i2 = 0; s[i2]; i2++, pos--)
        if (s[i2] != '?') {
          msk |= MMSK << (MSZ * pos);
          mval |= (ll)getid(s[i2]) << (MSZ * pos);
        }
      eprintf("mval=%I64d\n", mval);
      msks[d].insert(msk);
    }
    eprintf("read\n");

    vector<map<ll, map<ll, vi> > > pcs(MAXD + 1);
    for (int d = 2; d <= MAXD; d++) {
      eprintf("d=%d %d\n", d, sz(msks[d]));
      for (set<ll>::iterator it = msks[d].begin(); it != msks[d].end(); it++) {
         ll msk = *it;

         map<ll, vi> &cnts = pcs[d][msk];
         for (int i = 0; i < n; i++) {
           vi &ccnt = cnts[ids[d][i] & msk];
           if (ccnt.empty()) {
             ccnt = vi(sz(ps), 1);
           }

           for (int i2 = 0; i2 < sz(ccnt); i2++)
             ccnt[i2] = mul(ccnt[i2], asp[i][i2], ps[i2]);
         }
      }
    }

    eprintf("go\n");
    for (int i = 0; i < m; i++) {
      vi cps(sz(ps));
      for (int i2 = 0; i2 < sz(ps); i2++)
        cps[i2] = rqs[i].c % ps[i2];

      vi nps(sz(ps), 1);
      if (!rqs[i].bad) {
        map<ll, vi> &cnts = pcs[rqs[i].d][rqs[i].msk];
        const vi &res = cnts[rqs[i].mval];
        if (!res.empty()) nps = res;
      }

      for (int i2 = 0; i2 < sz(ps); i2++)
        add(cps[i2], nps[i2], ps[i2]);
      int ans = -1;
      for (int i2 = 0; i2 < sz(ps); i2++)
        if (!cps[i2]) { ans = ps[i2]; break; }
      printf("%d\n", ans);
    }
    eprintf("end\n");
  }
  return 0;
}