#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;
int P;

int N;
vector <int> graph[610]; // edge_from
int indeg[610],outdeg[610];
vector <int> source,sink;
int dp[610];

int dfs(int x){
    int i;
    
    if(dp[x] != -1) return dp[x];
    
    int ans = 0;
    REP(i,graph[x].size()){
        ans += dfs(graph[x][i]);
        if(ans >= P) ans -= P;
    }
    
    return dp[x] = ans;
}

int D;
ll a[310][310];

ll power(ll x, ll n){
    if(n == 0) return 1;
    ll y = power(x,n/2);
    y = y * y % P;
    if(n%2 == 1) y = y * x % P;
    return y;
}

ll func(void){
    int i,j,k;
    
/*  REP(i,D){
        REP(j,D) cout << a[i][j] << ' ';
        cout << endl;
    }
*/

    bool neg = false;
    
    REP(j,D){
        for(i=j;i<D;i++) if(a[i][j] != 0) break;
        if(i == D) return 0;
        if(i != j){
            neg = !neg;
            REP(k,D) swap(a[i][k],a[j][k]);
        }
        
        for(i=j+1;i<D;i++){
            ll coef = (P - a[i][j]) * power(a[j][j],P-2) % P;
            for(k=j;k<D;k++) a[i][k] = (a[i][k] + a[j][k] * coef) % P;
        }
    }
    
    ll ans = (neg ? (P - 1) : 1);
    REP(i,D) ans = ans * a[i][i] % P;
    return ans;
}

int main(void){
    int M,x,y,i,j;
    
    scanf("%d%d%d",&N,&M,&P);
    REP(i,M){
        scanf("%d%d",&x,&y);
        x--; y--;
        indeg[y]++; outdeg[x]++;
        graph[y].push_back(x);
    }
    
    REP(i,N){
        if(indeg[i] > 0 && outdeg[i] == 0) sink.push_back(i);
        if(indeg[i] == 0 && outdeg[i] > 0) source.push_back(i);
    }
    
    D = sink.size();
    REP(i,D){
        REP(j,N) dp[j] = -1;
        dp[source[i]] = 1;
        REP(j,D) a[i][j] = dfs(sink[j]);
    }
    
    ll ans = func();
    
    bool neg = false;
    REP(i,N) if(indeg[i] == 0 && outdeg[i] == 0){
        int cnt1 = 0, cnt2 = 0;
        REP(j,D) if(sink[j] < i) cnt1++;
        REP(j,D) if(source[j] < i) cnt2++;
        if(cnt1 % 2 != cnt2 % 2) neg = !neg;
    }
    if(neg) ans = (P - ans) % P;
    
    cout << ans << endl;
    
    return 0;
}