#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

#define INF 2000000000

int V,E;
set <int> bad[100010];
vector <pair <int, int> > edge[100010]; // to, dist
int dist[100010];
priority_queue <pair <int, int> > q; // -dist, vertex
bool used[100010];

int next(int x, int t){
    while(bad[x].find(t) != bad[x].end()) t++;
    return t;
}

void add(int x, int d){
    if(d < dist[x]){
        dist[x] = d;
        q.push(make_pair(-d,x));
    }
}

int main(void){
    int x,y,d,i,j,t;
    
    scanf("%d%d",&V,&E);
    REP(i,E){
        scanf("%d%d%d",&x,&y,&d); x--; y--;
        edge[x].push_back(make_pair(y,d));
        edge[y].push_back(make_pair(x,d));
    }
    REP(i,V){
        int cnt;
        scanf("%d",&cnt);
        REP(j,cnt){
            scanf("%d",&t);
            bad[i].insert(t);
        }
    }
    
    REP(i,V) dist[i] = INF;
    add(0,0);
    
    while(!q.empty()){
        x = q.top().second;
        t = -q.top().first;
        q.pop();
        if(used[x]) continue;
        used[x] = true;
        t = next(x,t);
        
        REP(i,edge[x].size()){
            int y = edge[x][i].first;
            int t2 = t + edge[x][i].second;
            add(y,t2);
        }
    }
    
    if(dist[V-1] == INF) cout << -1 << endl; else cout << dist[V-1] << endl;
    
    return 0;
}