#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;
#define MOD 777777777ll

bool graph[4][4];
ll dp[80000][4][4];

set <int> s;
int a[80000];

#define T (1<<17)
ll tree[2*T];

void tree_update(int x, ll val){
    tree[T+x] = val;
    int i = T+x;
    while(i > 1){
        i /= 2;
        tree[i] = tree[2*i] * tree[2*i+1] % MOD;
    }
}

void calc_dp(int N){
    int i,j,k,l;
    
    REP(i,4) REP(j,4) if(graph[i][j]) dp[1][i][j] = 1;
    for(i=1;i<N;i++) REP(j,4) for(k=1;k<=3;k++) REP(l,4) if(graph[k][l]){
        dp[i+1][j][l] += dp[i][j][k];
        if(dp[i+1][j][l] >= MOD) dp[i+1][j][l] -= MOD;
    }
}

void remove_query(int x){
    s.erase(x);
    a[x] = -1;
    
    __typeof(s.begin()) itr = s.lower_bound(x);
    int R = (*itr);
    itr--;
    int L = (*itr);
    
    tree_update(x, 1);
    tree_update(L, dp[R-L][a[L]][a[R]]);
}

void add_query(int x, int t){
    __typeof(s.begin()) itr = s.lower_bound(x);
    int R = (*itr);
    itr--;
    int L = (*itr);
    
    s.insert(x);
    a[x] = t;
    
    tree_update(L, dp[x-L][a[L]][a[x]]);
    tree_update(x, dp[R-x][a[x]][a[R]]);
}

int query(int x, int t){
    if(s.find(x) != s.end()) remove_query(x);
    if(t != -1) add_query(x, t);
    return (int)tree[1];
}

int main(void){
    int N,Q,i,j,tmp;
    
    cin >> N >> Q;
    REP(i,4) REP(j,4) if(i == 0 || j == 0) graph[i][j] = true;
    REP(i,3) REP(j,3){
        cin >> tmp;
        if(tmp == 1) graph[i+1][j+1] = true;
    }
    
    N++;
    calc_dp(N);
    
    s.insert(0);
    s.insert(N);
    for(i=1;i<N;i++) a[i] = -1;
    REP(i,2*T) tree[i] = 1;
    tree_update(0, dp[N][0][0]);
    
//  cout << tree[1] << endl;
    
    REP(i,Q){
        int x,t;
        scanf("%d%d", &x, &t);
        if(t == 0) t = -1;
        int ans = query(x, t);
        printf("%d\n", ans);
    }
    
    return 0;
}