#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define DEBUG 0

map<int, vector<pair<int, int> > > h, v;
map<int, vector<pair<int, int> > >::iterator it;
vector<pair<int, int> > uh, uv;
int N, M, K, xa, ya, xb, yb, z, hxor, vxor, txor;

void ProcessCuts(map<int, vector<pair<int, int> > >& m, int xmax, int ymax, int& cxor, vector<pair<int, int> >& u) {
	int i, nfull = ymax - 1, xunion, sum, firstfull = 0, lastnonfull = 0;

	cxor = 0;
	for (it = m.begin(); it != m.end(); it++) {
		if (firstfull == 0 && it->first >= lastnonfull + 2) {
			firstfull = lastnonfull + 1;
		}

		lastnonfull = it->first;

		nfull--;
		vector<pair<int, int> >& vv = it->second;
		sort(vv.begin(), vv.end());

		xunion = -1;
		sum = 0;

		for (i = 0; i < vv.size(); i++) {
			if (vv[i].first <= xunion) {
				if (vv[i].second > xunion) {
					sum += (vv[i].second - xunion);
					xunion = vv[i].second;
				}
			} else {
				xunion = vv[i].second;
				sum += (vv[i].second - vv[i].first);
			}
		}
		
		u.push_back(make_pair(it->first, xmax - sum));
		cxor ^= (xmax - sum);
	
		if (DEBUG)
			fprintf(stderr, "  %d: %d\n", it->first, xmax - sum);
	}

	if (firstfull == 0 && lastnonfull < ymax - 1) {
		firstfull = ymax - 1;
	}

	if (DEBUG)
		fprintf(stderr, "nfull=%d firstfull=%d\n", nfull, firstfull);
	
	if ((nfull % 2) == 1) {
		cxor ^= xmax;
		u.push_back(make_pair(firstfull, xmax));
		//fprintf(stderr, "  firstfull=%d\n", firstfull);
	}
}

void DoHorizontalMove(int idx, int cnt) {
	int col = 0, sum = 0, i;

	if (DEBUG)
		fprintf(stderr, "DoHorizontalMove row=%d cnt=%d\n", uh[idx].first, cnt);
	
	vector<pair<int, int> >& vv = h[uh[idx].first];
	for (i = 0; i < vv.size(); i++) {
		if (vv[i].first <= col) {
			if (vv[i].second > col)
				col = vv[i].second;
		} else {
			sum += (vv[i].first - col);
			col = vv[i].first;		
			if (sum < cnt)
				col = vv[i].second;
			else
				break;
		}
	}

	if (sum < cnt) {
		sum += (N - col);
		col = N;
	}
	
	col -= (sum - cnt);	
	printf("0 %d %d %d\n", uh[idx].first, col, uh[idx].first);
}

void DoVerticalMove(int idx, int cnt) {
	int row = 0, sum = 0, i;

	if (DEBUG)
		fprintf(stderr, "DoVerticalMove col=%d cnt=%d\n", uv[idx].first, cnt);
	
	vector<pair<int, int> >& vv = v[uv[idx].first];
	for (i = 0; i < vv.size(); i++) {
		if (vv[i].first <= row) {
			if (vv[i].second > row)
				row = vv[i].second;
		} else {
			sum += (vv[i].first - row);
			row = vv[i].first;		
			if (sum < cnt)
				row = vv[i].second;
			else
				break;
		}
	}

	if (sum < cnt) {
		sum += (M - row);
		row = M;
	}

	row -= (sum - cnt);
	printf("%d 0 %d %d\n", uv[idx].first, uv[idx].first, row);
}

int main() {
	int i;

	if (DEBUG)
		freopen("x.txt", "r", stdin);

	scanf("%d %d %d", &N, &M, &K);
	while (K--) {
		scanf("%d %d %d %d", &xa, &ya, &xb, &yb);
		if (xa == xb) {
			// vertical cut.
			v[xa].push_back(make_pair(min(ya, yb), max(ya, yb)));
		} else {
			// horizontal cut.
			h[ya].push_back(make_pair(min(xa, xb), max(xa, xb)));
		}
	}

	if (DEBUG)
		fprintf(stderr, "HORIZONTAL CUTS\n");	
	ProcessCuts(h, N, M, hxor, uh);

	if (DEBUG)
		fprintf(stderr, "VERTICTAL CUTS\n");
	ProcessCuts(v, M, N, vxor, uv);

	if (DEBUG)
		fprintf(stderr, "hxor=%d vxor=%d\n", hxor, vxor);
	
	txor = hxor ^ vxor;
	if (txor == 0)
		printf("SECOND\n");
	else {
		printf("FIRST\n");
		// Try a horizontal move.
		for (i = 0; i < uh.size(); i++) {
			if (uh[i].second == 0)
				continue;
			hxor = txor ^ uh[i].second;
			if (hxor < uh[i].second) {
				DoHorizontalMove(i, uh[i].second - hxor);
				return 0;
			}
		}

		// Try a vertical move.
		for (i = 0; i < uv.size(); i++) {
			if (uv[i].second == 0)
				continue;
			vxor = txor ^ uv[i].second;
			if (vxor < uv[i].second) {
				DoVerticalMove(i, uv[i].second - vxor);
				return 0;
			}
		}
	}
	
	return 0;
}
