#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define MAX_STEPS 2000000
#define LEPS 1e-7

double w, h, alpha, u, pi, area, li, ls, mid, lastL, L, cosu, sinu, cosua, sinua, xa, ya, xb, yb, sineps, lmax, UEPS;
int first;

int main() {
	pi = 2.0 * acos(0.0);
	
	//freopen("x.txt", "r", stdin);
	scanf("%lf %lf %lf", &w, &h, &alpha);

	alpha = pi * alpha / 180.0;
	UEPS = pi / MAX_STEPS;
	sineps = sin(UEPS);
	lmax = sqrt(w * w + h * h);
	w /= 2.0;
	h /= 2.0;
	area = 0.0;
	
	for (first = 1, u = 0.0; u < pi; u += UEPS) {
		cosu = cos(u);
		sinu = sin(u);
		cosua = cos(u - alpha);
		sinua = sin(u - alpha);
		
		li = 0.0; ls = lmax; L = 0.0;
		
		while (fabs(ls - li) >= LEPS) {
			mid = 0.5 * (li + ls);
			xa = mid * cosu;
			ya = mid * sinu;
			xb = mid * cosua;
			yb = mid * sinua;
			
			//fprintf(stderr, "xa=%lf ya=%lf xb=%lf yb=%lf\n", xa, ya, xb, yb);
			
			if (fabs(xa) <= w && fabs(xb) <= w && fabs(ya) <= h && fabs(yb) <= h) {
				L = mid;
				li = mid;
			} else
				ls = mid;
		}

		//fprintf(stderr, "u=%.9lf L=%.9lf\n", u, L);
		
		if (!first) {
			area += lastL * L * sineps;
		}

		lastL = L;
		first = 0;
	}
	
	printf("%.9lf\n", area);
	
	return 0;
}
