#include <iostream>
#include <cstdio>
#include <string.h>
#include <algorithm>
#include <vector>
using namespace std;

struct NODE
{
    int max, Lmax, Rmax;
    int L, R, Lx, Rx;
    NODE() {}
    NODE(int _max, int _Lmax, int _Rmax, int _L, int _R, int _Lx, int _Rx)
    {
        max = _max, Lmax = _Lmax, Rmax = _Rmax, L = _L, R = _R, Lx = _Lx, Rx = _Rx;
    }
};

struct TREE
{
    NODE max, min;
    int rev, sum;
    TREE() {}
};

const int maxn = 100007;
      int n, m;
      int a[maxn];
      TREE tree[maxn*4];
      
void update(TREE &mid, TREE L, TREE R)
{
    mid.sum = L.sum+R.sum;
    mid.max.max = L.max.Rmax+R.max.Lmax, mid.max.L = L.max.Rx, mid.max.R = R.max.Lx;
    if (L.max.max > mid.max.max)
    {
        mid.max.max = L.max.max;
        mid.max.L = L.max.L, mid.max.R = L.max.R;
    }
    if (R.max.max > mid.max.max)
    {
        mid.max.max = R.max.max;
        mid.max.L = R.max.L, mid.max.R = R.max.R;
    }
    mid.min.max = L.min.Rmax+R.min.Lmax, mid.min.L = L.min.Rx, mid.min.R = R.min.Lx;
    if (L.min.max < mid.min.max)
    {
        mid.min.max = L.min.max;
        mid.min.L = L.min.L, mid.min.R = L.min.R;
    }
    if (R.min.max < mid.min.max)
    {
        mid.min.max = R.min.max;
        mid.min.L = R.min.L, mid.min.R = R.min.R;
    }
    mid.max.Lmax = L.max.Lmax, mid.max.Lx = L.max.Lx;
    mid.max.Rmax = R.max.Rmax, mid.max.Rx = R.max.Rx;
    if (L.sum+R.max.Lmax > mid.max.Lmax)
    {
        mid.max.Lmax = L.sum+R.max.Lmax;
        mid.max.Lx = R.max.Lx;
    }
    if (R.sum+L.max.Rmax > mid.max.Rmax)
    {
        mid.max.Rmax = R.sum+L.max.Rmax;
        mid.max.Rx = L.max.Rx;
    }
    mid.min.Lmax = L.min.Lmax, mid.min.Lx = L.min.Lx;
    mid.min.Rmax = R.min.Rmax, mid.min.Rx = R.min.Rx;
    if (L.sum+R.min.Lmax < mid.min.Lmax)
    {
        mid.min.Lmax = L.sum+R.min.Lmax;
        mid.min.Lx = R.min.Lx;
    }
    if (R.sum+L.min.Rmax < mid.min.Rmax)
    {
        mid.min.Rmax = R.sum+L.min.Rmax;
        mid.min.Rx = L.min.Rx;
    }
}

void build(int mark, int L, int R)
{
    tree[mark].rev = 0;
    if (L == R)
    {
        tree[mark].sum = a[L];
        tree[mark].max = tree[mark].min = NODE(a[L], a[L], a[L], L, R, L, R);
        return;
    }
    int mid = (L+R)/2;
    build(mark*2, L, mid);
    build(mark*2+1, mid+1, R);
    update(tree[mark], tree[mark*2], tree[mark*2+1]);
}

void Rev(TREE &x)
{
    swap(x.max, x.min);
    x.sum = -x.sum;
    x.max.max = -x.max.max;
    x.max.Lmax = -x.max.Lmax, x.max.Rmax = -x.max.Rmax;
    x.min.max = -x.min.max;
    x.min.Lmax = -x.min.Lmax, x.min.Rmax = -x.min.Rmax;
}

void pushdown(TREE &mid, TREE &L, TREE &R)
{
    if (mid.rev == 1)
    {
        L.rev ^= 1, R.rev ^= 1, mid.rev ^= 1;
        Rev(L), Rev(R);
    }
}

void insert(int mark, int L, int R, int x, int val)
{
    if (L == R)
    {
        tree[mark].sum = val;
        tree[mark].max = tree[mark].min = NODE(val, val,val, L, R, L, R);
        return;
    }
    pushdown(tree[mark], tree[mark*2], tree[mark*2+1]);
    int mid = (L+R)/2;
    if (x <= mid) insert(mark*2, L, mid, x, val);
    else          insert(mark*2+1, mid+1, R, x, val);
    update(tree[mark], tree[mark*2], tree[mark*2+1]);
}

TREE calc(int mark, int L, int R, int fir, int lst)
{
    if (L == fir && lst == R) return tree[mark];
    pushdown(tree[mark], tree[mark*2], tree[mark*2+1]);
    int mid = (L+R)/2;
    if (lst <= mid) return calc(mark*2, L, mid, fir, lst);
    if (fir > mid) return calc(mark*2+1, mid+1, R, fir, lst);
    TREE res;
    update(res, calc(mark*2, L, mid, fir, mid), calc(mark*2+1, mid+1, R, mid+1, lst));
    return res;
}

void Reverse(int mark, int L, int R, int fir, int lst)
{
    if (L == fir && lst == R)
    {
        tree[mark].rev ^= 1;
        Rev(tree[mark]);
        return;
    }
    pushdown(tree[mark], tree[mark*2], tree[mark*2+1]);
    int mid = (L+R)/2;
    if (lst <= mid) Reverse(mark*2, L, mid, fir, lst);
    else
        if (fir > mid) Reverse(mark*2+1, mid+1, R, fir, lst);
        else
        {
            Reverse(mark*2, L, mid, fir, mid);
            Reverse(mark*2+1, mid+1, R, mid+1, lst);
        }
    update(tree[mark], tree[mark*2], tree[mark*2+1]);
}

int main()
{
    //freopen("d.out", "w", stdout);
    scanf("%d", &n);
    for (int i = 1; i <= n; i++) scanf("%d", &a[i]);
    build(1, 1, n);
    scanf("%d", &m);
    for (int i = 1; i <= m; i++)
    {
        int order;
        scanf("%d", &order);
        if (order == 0)
        {
            int x, val;
            scanf("%d%d", &x, &val);
            insert(1, 1, n, x, val);
        }
        else
        {
            int l, r, k;
            scanf("%d%d%d", &l, &r, &k);
            vector< pair<int, int> > zz;
            int res = 0;
            for (int run = 1; run <= k; run++)
            {
                TREE add = calc(1, 1, n, l, r);
                if (add.max.max <= 0) break;
                res += add.max.max;
                zz.push_back(make_pair(add.max.L, add.max.R));
                Reverse(1, 1, n, add.max.L, add.max.R);
            }
            printf("%d\n", res);
            for (int x = 0; x < zz.size(); x++) 
                Reverse(1, 1, n, zz[x].first, zz[x].second);
        }
    }
    return 0;
}