#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <bitset>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define snuke(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

#define T (1<<18)
double tree[2*T];

void add(int L, int R, double val, int id = 1, int low = 0, int high = T){
    if(low >= L && high <= R){
        tree[id] += val;
        return;
    }
    
    int mid = (low + high) / 2;
    if(L < mid) add(L, R, val, 2*id, low, mid);
    if(R > mid) add(L, R, val, 2*id+1, mid, high);
}

double get(int x){
    double ans = 0.0;
    int id = T + x;
    while(id > 0){
        ans += tree[id];
        id /= 2;
    }
    return ans;
}

int main(void){
    int N,i;
    double sum = 0.0;
    int sz = 1;
    
    cin >> N;
    REP(i,N){
        int t,a,x,k;
        scanf("%d", &t);
        
        if(t == 1){
            scanf("%d%d", &a, &x);
            add(0, a, x);
            sum += (double)a * (double)x;
        } else if(t == 2){
            scanf("%d", &k);
            add(sz, sz+1, k);
            sz++;
            sum += k;
        } else if(t == 3){
            double tmp = get(sz-1);
            add(sz-1, sz, -tmp);
            sz--;
            sum -= tmp;
        }
        
        printf("%.9f\n", sum/sz);
    }
    
    return 0;
}