#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define NMAX 100100

vector<pair<int, int> > v;
int q[NMAX], t[NMAX];
int N, M;

void ReadInput() {
	int i, l, r;
	
	//freopen("x.txt", "r", stdin);
	
	scanf("%d %d", &N, &M);
	
	for (i = 1; i <= M; i++) {
		scanf("%d %d %d", &l, &r, &t[i]);
		v.push_back(make_pair(l, i));
		v.push_back(make_pair(r, -i));
	}

	for (i = 1; i <= N; i++)
		scanf("%d", &q[i]);
}

#define TMAX 131072
long long tsum[2 * TMAX];
int tcnt[2 * TMAX];

int L, R, CNT;
long long SUM;

void UpdateTree(int node, int lnode, int rnode) {
	if (L <= lnode && rnode <= R) {
		tsum[node] += SUM;
		tcnt[node] += CNT;
		return;
	}
	
	int mnode = (lnode + rnode) / 2;
	int lson = node << 1;
	int rson = lson + 1;
	
	if (L <= mnode)
		UpdateTree(lson, lnode, mnode);
	
	if (R > mnode)
		UpdateTree(rson, mnode + 1, rnode);
}

void QueryTree(int node) {
	node = TMAX + node - 1;
	SUM = 0;
	CNT = 0;

	while (node >= 1) {
		SUM += tsum[node];
		CNT += tcnt[node];
		node >>= 1;
	}
}

set<pair<int, int> > vmin;

void Solve() {
	int i, li, ls, mid, qmin, qmax;

	sort(v.begin(), v.end());
	for (i = 0; i < v.size(); i++) {
		if (v[i].second > 0)
			vmin.insert(make_pair(t[v[i].second], v[i].second));
		else
			vmin.erase(make_pair(t[-v[i].second], -v[i].second));

		if (vmin.size() > 0) {
			pair<int, int> p = *(vmin.begin());
			
			li = 1; ls = N;
			qmin = N + 1;
			while (li <= ls) {
				mid = (li + ls) / 2;
				if (q[mid] + v[i + 1].first <= p.first) {
					li = mid + 1;
				} else {
					qmin = mid;
					ls = mid - 1;
				}
			}

			li = qmin; ls = N;
			qmax = N + 1;
			while (li <= ls) {
				mid = (li + ls) / 2;
				if (q[mid] + v[i].first <= p.first) {
					li = mid + 1;
				} else {
					qmax = mid;
					ls = mid - 1;
				}
			}

			//fprintf(stderr, "twall=%d lwall=%d rwall=%d qmin=%d qmax=%d\n", p.first, v[i].first, v[i + 1].first, qmin, qmax);
			
			if (qmax <= N) {
				L = qmax; R = N;
				SUM = v[i + 1].first - v[i].first;
				CNT = 0;
				UpdateTree(1, 1, TMAX);
			}

			if (qmax > qmin) {
				L = qmin; R = qmax - 1;
				SUM = v[i + 1].first - p.first;
				CNT = 1;
				UpdateTree(1, 1, TMAX);
			}
		}
	}
}

void WriteOutput() {
	int i;
	for (i = 1; i <= N; i++) {
		QueryTree(i);
		printf("%I64d\n", SUM + (long long) q[i] * (long long) CNT);
	}
}

int main() {
	ReadInput();
	Solve();
	WriteOutput();
	return 0;
}
