import java.util.*;
import java.math.*;
import static java.lang.Math.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;

public class Main{
	static void debug(Object...os){
//		System.err.println(deepToString(os));
	}
	
	long start;
	void run(){
		int n=nextInt(),m=nextInt();
		int x1=nextInt()-1,y1=nextInt()-1;
		int x2=nextInt()-1,y2=nextInt()-1;
		start=System.currentTimeMillis();
		boolean black1 = (x1+y1&1)==0;
		boolean black2 = (x2+y2&1)==0;
		if((n&1)==1 && (m&1)==1) {
			if(black1 && black2)System.out.println(n*m);
			else if(black1 || black2)System.out.println(n*m-1);
			else System.out.println(n*m-2);
		}else {
			if(black1^black2)System.out.println(n*m);
			else System.out.println(n*m-1);
		}
		solve(n,m,x1,y1,x2,y2);
	}
	private int[][] visit;
	private int[] dx={1,0,-1,0};
	private int[] dy={0,1,0,-1};
	private int[] p1,p2;
	private int[] walls;
	private int[][] loopIds;
	private boolean[][] loopVerticals;
	private boolean[] loopVisited;
	
	// 10 10 3 3 6 6
	private void solve(int n,int m,int x1,int y1, int x2, int y2){
		visit=new int[n][m];
		for(int i=0;i<n;i++)for(int j=0;j<m;j++)visit[i][j]=-1;
		visit[x1][y1]=0;
		p1=new int[] {x1,y1};p2=new int[] {x2,y2};
		loopVisited=new boolean[n+m];
		walls=new int[] {n-1,m-1,0,0};
		loopIds=new int[n][m];
		for(int i=0;i<n;i++)for(int j=0;j<m;j++)loopIds[i][j]=-1;
		loopVerticals=new boolean[n][m];
		sb=new StringBuilder();
		solve();
//		for(int i=0;i<n;i++) {
//			for(int j=0;j<m;j++)System.out.printf("%3d ",visit[i][j]);
//			System.out.println();
//		}
//		System.out.println();
//		for(int i=0;i<n;i++) {
//			for(int j=0;j<m;j++)System.out.printf("%3d ",loopIds[i][j]);
//			System.out.println();
//		}
//		System.out.println(res.size());
		tick();
//		for(String s:res) {
//			b.append(s);
//			b.append('\n');
//		}
		System.out.println(sb);
	}
	StringBuilder sb;
	
	ArrayList<String> res;
	private void solve() {
		res=new ArrayList<String>();
		sb.append(String.format("%d %d",p1[0]+1,p1[1]+1));
		sb.append('\n');
		res.add(String.format("%d %d",p1[0]+1,p1[1]+1));
		int loopId=0;
		// 1000 988 499 28 277 298
		for(int d=0;d<2;d++) {
			tick();
			while(walls[d]-walls[d+2]+1>5) {
				tick();
				debug(walls[d],walls[d+2],p1);
				if(min(p1[d],p2[d])-walls[d+2]>=2) {
					for(int i=walls[d+2];i<walls[d+2]+2;i++)for(int j=walls[d+2^1];j<=walls[d^1];j++) {
						loopIds[d==0?i:j][d==0?j:i]=loopId;
					}
					loopId++;
					walls[d+2]+=2;
				}else if(walls[d]-max(p1[d],p2[d])>=2) {
					for(int i=walls[d]-1;i<=walls[d];i++)for(int j=walls[d+2^1];j<=walls[d^1];j++) {
						loopIds[d==0?i:j][d==0?j:i]=loopId;
					}
					loopId++;
					walls[d]-=2;
				}else {
					if(p1[d]-walls[d+2]==0) {
						snake(d);
						walls[d+2]+=2;
					}else if(p1[d]-walls[d+2]==1) {
						loopPush(d);
						walls[d+2]+=2;
					}else if(walls[d]-p1[d]==0) {
						snake(d+2);
						walls[d]-=2;
					}else if(walls[d]-p1[d]==1) {
						loopPush(d+2);
						walls[d]-=2;
					}else assert false;
				}
			}
			tick();
		}
		int upper=walls[2],left=walls[3];
		solveStupid(walls[0]-upper+1,walls[1]-left+1,p1[0]-upper,p1[1]-left,p2[0]-upper,p2[1]-left);
	}

	private void tick(){
		debug("tick",System.currentTimeMillis()-start);
	}

	int maxLen;
	E best;

	private void solveStupid(int n,int m,int x1,int y1,int x2,int y2){
		maxLen=0;
		dfs(n,m,new E(1<<x1*m+y1,x1,y1,null),x2,y2,new HashSet<E>());
		Stack<E> stk = new Stack<E>();
		while(best!=null) {
			stk.push(best);
			best=best.bef;
		}
		E cur = stk.pop();
		while(!stk.isEmpty()) {
			E nxt=stk.pop();
			for(int d=0;d<4;d++) {
				int nx=cur.x+dx[d],ny=cur.y+dy[d];
				if(nx==nxt.x && ny==nxt.y) {
					go(d);break;
				}
				if(d==3)debug(cur.x,cur.y,nxt.x,nxt.y);
				assert d!=3;
			}
			cur=nxt;
		}
	}
	private void dfs(int n,int m,E e,int x2, int y2, HashSet<E> set){
		assert !set.contains(e);
		set.add(e);
		if(x2==e.x && y2==e.y) {
			int len=Integer.bitCount(e.msk);
			if(maxLen<len) {
				maxLen=len;
				best=e;
			}
			return;
		}
		for(int d=0;d<4;d++) {
			final int nx=e.x+dx[d],ny=e.y+dy[d];
			int v=1<<nx*m+ny;
			if(0<=nx&&nx<n&&0<=ny&&ny<m && (e.msk&v)==0) {
				E ne = new E(e.msk|v,nx,ny,e);
				if(!set.contains(ne))dfs(n,m,ne,x2,y2,set);
			}
		}
	}
	class E{
		final E bef;
		final int msk;
		final int x,y;
		private E(int msk,int x,int y,E bef){
			this.bef=bef;
			this.msk=msk;
			this.x=x;
			this.y=y;
		}
		public int hashCode(){
			final int prime=31;
			int result=msk;
			result=prime*result+x;
			result=prime*result+y;
			return result;
		}
		public boolean equals(Object obj){
			E other=(E)obj;
			if(msk!=other.msk)return false;
			if(x!=other.x) return false;
			if(y!=other.y) return false;
			return true;
		}
	}

	private void snake(int d){
		debug("snake");
		if(p1[d+1&1]-walls[3-(d&1)]<2) {
			snake(d,3-(d&1));
		}else {
			snake(d,1-(d&1));
		}
	}
	
	private void snake(int d,int d2){
		int to=p1[d+1&1];
		while(p1[d+1&1]!=walls[d2])go(d2);
		go(d);
		while(p1[d+1&1]!=to)go(d2^2);
		go(d2^2);
		go(d^2);
		int cnt=0;
		while(p1[d+1&1]!=walls[d2^2]) {
			go(d2^2);cnt++;
		}
		go(d);
		for(int i=0;i<cnt-1;i++)go(d2);
		go(d);
	}
	int[][] ds= {
		{1,0,-1,0},
		{0,1,0,-1}
	};
	
	int[] p=new int[2];
	private int[] next(int[] p,int d) {
		int[] res=this.p;
		for(int i=0;i<2;i++)res[i]=p[i]+ds[i][d];
		return res;
	}
	
	private void go(int d){
		int np1[] = next(p1,d).clone();
		for(int d2=0;d2<4;d2++){
			int i1 = getLoopId(next(p1,d2));
			int i2 = getLoopId(next(np1,d2));
			if(i1!=-1 && i1==i2 && !loopVisited[i1]) {
				assert ((d^d2)&1)==1;
				loopVisited[i1]=true;
				eatLoop(d2,d^2);
				return;
			}
		}
		assert visit[np1[0]][np1[1]]==-1;
		visit[np1[0]][np1[1]]=visit[p1[0]][p1[1]]+1;
		p1=np1;
		sb.append(String.format("%d %d",p1[0]+1,p1[1]+1));
		sb.append('\n');
		if(sb.length()>100000) {
			System.out.println(sb);
			sb.setLength(0);
		}
	}
	
	private void eatLoop(int d,int d2){
		go(d);
		int id=getLoopId(p1);
		loopIds[p1[0]][p1[1]]=-1;
		while(getLoopId(next(p1,d2))==id)go(d2);
		while(getLoopId(next(p1,d))==id)go(d);
		while(getLoopId(next(p1,d2^2))==id)go(d2^2);
		while(getLoopId(next(p1,d^2))==id)go(d^2);
		while(getLoopId(next(p1,d2))==id)go(d2);
		go(d^2);
	}
	
	private int getLoopId(int[] p){
		int x=p[0],y=p[1];
		if(0<=x && x<loopIds.length && 0<=y && y<loopIds[x].length)return loopIds[x][y];
		return -1;
	}
	
	private void loopPush(int d){
		debug("loopPush");
		if(p1[d+1&1]-walls[3-(d&1)]<1) {
			loopPush(d,3-(d&1));
		}else {
			loopPush(d,1-(d&1));
		}
	}
	
	private void loopPush(int d,int d2){
		int to=p1[d+1&1];
		while(p1[d+1&1]!=walls[d2])go(d2);
		go(d^2);
		while(p1[d+1&1]!=to)go(d2^2);
		go(d2^2);
		int cnt=0;
		while(p1[d+1&1]!=walls[d2^2]) {
			go(d2^2);cnt++;
		}
		go(d);
		for(int i=0;i<cnt;i++)go(d2);
		go(d);
	}
	
	int nextInt(){
		try{
			int c=System.in.read();
			if(c==-1) return c;
			while(c!='-'&&(c<'0'||'9'<c)){
				c=System.in.read();
				if(c==-1) return c;
			}
			if(c=='-') return -nextInt();
			int res=0;
			do{
				res*=10;
				res+=c-'0';
				c=System.in.read();
			}while('0'<=c&&c<='9');
			return res;
		}catch(Exception e){
			return -1;
		}
	}
	
	long nextLong(){
		try{
			int c=System.in.read();
			if(c==-1) return -1;
			while(c!='-'&&(c<'0'||'9'<c)){
				c=System.in.read();
				if(c==-1) return -1;
			}
			if(c=='-') return -nextLong();
			long res=0;
			do{
				res*=10;
				res+=c-'0';
				c=System.in.read();
			}while('0'<=c&&c<='9');
			return res;
		}catch(Exception e){
			return -1;
		}
	}
	
	double nextDouble(){
		return Double.parseDouble(next());
	}
	
	String next(){
		try{
			StringBuilder res=new StringBuilder("");
			int c=System.in.read();
			while(Character.isWhitespace(c))
				c=System.in.read();
			do{
				res.append((char)c);
			}while(!Character.isWhitespace(c=System.in.read()));
			return res.toString();
		}catch(Exception e){
			return null;
		}
	}
	
	String nextLine(){
		try{
			StringBuilder res=new StringBuilder("");
			int c=System.in.read();
			while(c=='\r'||c=='\n')
				c=System.in.read();
			do{
				res.append((char)c);
				c=System.in.read();
			}while(c!='\r'&&c!='\n');
			return res.toString();
		}catch(Exception e){
			return null;
		}
	}
	public static void main(String[] args){
		new Main().run();
	}
}