#include <map>
#include <set>
#include <cmath>
#include <stack>
#include <queue>
#include <string>
#include <vector>
#include <bitset>
#include <fstream>
#include <sstream>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <iostream>
#include <algorithm>
using namespace std;
#define li       	long long int
#define rep(i,to)	for(li i=0;i<((li)(to));++i)
#define pb       	push_back
#define sz(v)    	((li)(v).size())
#define bit(n)   	(1ll<<(li)(n))


#define MAX 100005
#define PR2_MAX 18
vector<li> E[MAX];
li end_num[MAX];
li depth[MAX];
int pr2[PR2_MAX][MAX];
li pr[MAX];
li num_pr[MAX];
li COUNT=1;
li NUM[MAX];
li loop_num[MAX];
li loop_start;
li loop_end;
li N=1;
struct _st{ int num,rev,sum,loop; } st[MAX*4];
vector<pair<li,li> > d_vec;

	
li init_pr(li pos,li parent=-1){
	if(pr[pos]==bit(60)) return pr[pos]=pos;
	pr[pos]=bit(60);
	rep(i,sz(E[pos]))if(E[pos][i]!=parent){
		li tmp=init_pr(E[pos][i],pos);
		if(tmp!=-1){
			pr[pos]=pos;
			return (pos==tmp)?-1:tmp;
		}
	}
	pr[pos]=-1;
	return -1;
}

void init_pr2(li pos){
	pr2[0][pos]=pr[pos];
	for(li i=1;i<PR2_MAX;i++)if(bit(i)<=depth[pos]) pr2[i][pos]=pr2[i-1][pr2[i-1][pos]];
}

li alloc_num(li pos){
	if(num_pr[pos]!=-1) return pos;
	if(depth[pos]==0) return pos;
	NUM[pos]=COUNT++;
	rep(i,sz(E[pos]))if(depth[E[pos][i]]<depth[pos]) return num_pr[pos]=alloc_num(E[pos][i]);
}

void alloc_loop_num(li pos){
	if(loop_num[pos]!=-1) return;
	if(depth[pos]!=0) return;
	loop_num[pos]=COUNT++;
	loop_end=COUNT;
	rep(i,sz(E[pos]))if(depth[E[pos][i]]==0) alloc_loop_num(E[pos][i]);
	loop_start=loop_num[pos];
}

li dis(li t0,li t1){
	if(loop_num[t0]<loop_num[t1]) return loop_num[t1]-loop_num[t0];
	return (loop_end-loop_start)-(loop_num[t0]-loop_num[t1]);
}

void init_loop_sum(li v,li left,li right){
	if(left+1==right){
		st[v].sum=(loop_start<=left && left<loop_end)?1:0;
		return;
	}
	li mid=(left+right)/2;
	init_loop_sum(v*2,left,mid);
	init_loop_sum(v*2+1,mid,right);
	st[v].sum=st[v*2].sum+st[v*2+1].sum;
}

void add(li v,li flag,li left,li right,li LEFT,li RIGHT){
	if(right<=left || RIGHT<=LEFT) return;
	if(!flag){
		add(v,!flag,left,right,0,LEFT);
		add(v,!flag,left,right,RIGHT,N);
		return;
	}
	if(right<=LEFT || RIGHT<=left) return;
	if(LEFT<=left && right<=RIGHT){
		st[v].num=(right-left)-st[v].num;
		st[v].rev=1-st[v].rev;
		st[v].loop=st[v].sum-st[v].loop;
		return;
	}
	li mid=(left+right)/2;
	add(v*2,flag^st[v].rev,left,mid,LEFT,RIGHT);
	add(v*2+1,flag^st[v].rev,mid,right,LEFT,RIGHT);
	st[v].num=st[v*2].num+st[v*2+1].num;
	st[v].rev=false;
	st[v].loop=st[v*2].loop+st[v*2+1].loop;
}

void init_depth(li pos,li d=0,li parent=-1){
	if(depth[pos]!=-1) return ;
	depth[pos]=d;
	if(pr[pos]==pos) depth[pos]=0;
	if(pr[pos]==-1) pr[pos]=parent;
	rep(i,sz(E[pos])) init_depth(E[pos][i],depth[pos]+1,pr[pos]);
}

int main(){
	li n,m,t0,t1;
	cin>>n>>m;
	memset(depth,-1,sizeof(depth));
	memset(pr,-1,sizeof(pr));
	memset(pr2,-1,sizeof(pr2));
	memset(num_pr,-1,sizeof(num_pr));
	memset(loop_num,-1,sizeof(loop_num));
	memset(NUM,-1,sizeof(NUM));
	rep(i,n){
		cin>>t0>>t1; t0--; t1--;
		E[t0].pb(t1);
		E[t1].pb(t0);
	}
	init_pr(0);
	rep(i,n)if(pr[i]==i && depth[i]==-1) init_depth(i);
	rep(i,n) d_vec.pb(make_pair(depth[i],i));
	sort(d_vec.begin(),d_vec.end());
	rep(i,n)if(pr[d_vec[i].second]!=d_vec[i].second) init_pr2(d_vec[i].second);
	reverse(d_vec.begin(),d_vec.end());
	rep(i,n) alloc_num(d_vec[i].second);
	rep(i,n)if(loop_num[i]==-1 && depth[i]==0) alloc_loop_num(i);
	while(N<MAX) N*=2;
	rep(i,MAX*4) st[i].rev=st[i].num=st[i].loop=0;
	init_loop_sum(1,0,N);
	rep(stage,m){
		cin>>t0>>t1; t0--; t1--;
		for(;t0!=pr[t0];t0=num_pr[t0]) add(1,1,0,N,NUM[t0],NUM[t0]+depth[t0]-depth[num_pr[t0]]);
		for(;t1!=pr[t1];t1=num_pr[t1]) add(1,1,0,N,NUM[t1],NUM[t1]+depth[t1]-depth[num_pr[t1]]);
		if(t0!=t1){
			vector<pair<li,li> > vec;
			rep(i,sz(E[t0]))if(depth[E[t0][i]]==0) vec.pb(make_pair(E[t0][i],loop_num[E[t0][i]]));
			if(dis(t1,t0)<dis(t0,t1)) swap(t0,t1);
			if(dis(t0,t1)==dis(t1,t0)){
				li b0=0,b1=0;
				if(vec[0].first<vec[1].first) b0=1;
				if(vec[0].second==loop_num[t0]-1 || vec[1].second==loop_num[t0]+1) b1=1;
				if((b0^b1)==0) swap(t0,t1);
			}
			if(loop_num[t0]<loop_num[t1]){
				add(1,1,0,N,loop_num[t0],loop_num[t1]);
			}else{
				add(1,1,0,N,loop_num[t0],loop_end);
				add(1,1,0,N,loop_start,loop_num[t1]);
			}
		}
		cout<<n-(st[1].num)+((st[1].loop==loop_end-loop_start)?1:0)<<endl;
	}
}