#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef long double real;

#ifdef WIN32
#define INT64 "%I64d"
#define UINT64 "%I64u"
#else
#define INT64 "%lld"
#define UINT64 "%llu"
#endif

#ifdef DEBUG
#define eprintf(...) fprintf (stderr, __VA_ARGS__)
#else
#define eprintf(...) assert (true)
#endif

const int MaxN = 1 << 16, MaxD = 6, MaxK = 1 << 7;
const int MaxC = 0x3F3F3F3F, NA = -1, START = -2;

int a [MaxN];
int ap [MaxN];
int f [MaxN] [MaxK];
int g [MaxN] [MaxK];
int h [MaxN] [MaxK];
int b [MaxK];
int c [MaxK];
int m [MaxD] [MaxN];
int ans [MaxK];
int n, p;

int main (void)
{
 int d, i, j, k;

 while (scanf (" %d %d", &n, &p) != EOF)
 {
  for (i = 0; i < p; i++)
   m[0][i] = i;
  for (d = 1; d < MaxD; d++)
   for (i = 0; i < p; i++)
    m[d][i] = (m[d - 1][i] * 10) % p;

  for (i = 0; i < n; i++)
  {
   scanf (" %d", &a[i]);
  }

  int nn = min (n, MaxK - 1);
  j = 0;
  for (i = 0; i < n; i++)
   if (a[i] <= nn)
   {
    a[j] = a[i];
    c[j] = i;
    j++;
   }
  assert (j == nn);
  n = nn;

  for (i = 0; i < n; i++)
  {
   ap[i] = a[i] % p;
   k = 1;
   b[i] = NA;
   for (d = 1; d < MaxD; d++)
   {
    k *= 10;
    if (a[i] < k)
    {
     b[i] = d;
     break;
    }
   }
   eprintf ("%d: %d %d\n", a[i], b[i], ap[i]);
   assert (b[i] != NA);
  }

  memset (f, NA, sizeof (f));
  f[0][0] = START;
  for (i = 0; i < n; i++)
  {
   for (j = 0; j < MaxN; j++)
    for (k = 0; k < MaxK; k++)
     if ((f[j][k] != NA) && (f[j][k] < i))
     {
      int nj = m[b[i]][j] + ap[i];
      if (nj >= p)
       nj -= p;
      int nk = k ^ a[i];
      if (f[nj][nk] >= 0)
       continue;
      eprintf ("%d: (%d, %d) -> (%d, %d)\n", a[i], j, k, nj, nk);
      f[nj][nk] = i;
      g[nj][nk] = j;
      h[nj][nk] = k;
     }
   if (f[0][0] != START)
    break;
  }
  if (f[0][0] == START)
   printf ("No\n");
  else
  {
   printf ("Yes\n");
   i = 0;
   j = 0;
   k = 0;
   int len = 0;
   do
   {
    int pi = f[j][k];
    int pj = g[j][k];
    int pk = h[j][k];
    ans[len++] = pi;
    i = pi;
    j = pj;
    k = pk;
   }
   while (j != 0 || k != 0);
   printf ("%d\n", len);
   for (i = 0; i < len; i++)
    printf ("%d%c", c[ans[i]] + 1, "\n "[i + 1 < len]);
  }
 }

 return 0;
}