#include <stdio.h>
#include <string.h>
#include <time.h>

#define NMAX 40

int bit[18];
char A[NMAX][NMAX], sel[NMAX];
int vec[2][NMAX][NMAX], nvec[2][NMAX];
int max_nodes[1 << 18];
int N, M, i, j, k, conf, pconf, confmax, answer;
int MIN_NODE, MAX_NODE, BKT_TYPE;

void BKT(int node) {
	if (node == MAX_NODE) {
		if (BKT_TYPE == 1) {
			max_nodes[conf] = k;
			//fprintf(stderr, "BKT_TYPE=1: conf=%d: k=%d\n", conf, k);
		} else {
			//fprintf(stderr, "BKT_TYPE=2: k=%d conf=%d (%d)\n", k, conf, max_nodes[conf]);
			k += max_nodes[conf];
			if (k > answer)
				answer = k;
			k -= max_nodes[conf];
		}
	} else {
		sel[node] = 0;
		BKT(node + 1);
		
		sel[node] = 1;
		for (i = 0; i < nvec[0][node]; i++)
			if (sel[vec[0][node][i]] || vec[0][node][i] > node)
				break;
		
		if (i == nvec[0][node] || vec[0][node][i] > node) {
			if (BKT_TYPE == 2) {
				for (i = 0; i < nvec[1][node]; i++) {
					j = vec[1][node][i];
					sel[j]++;
					if (sel[j] == 1)
						conf ^= bit[j - 1];
				}
			}
			
			k++;
			if (BKT_TYPE == 1)
				conf ^= bit[node - 1];

			BKT(node + 1);

			k--;
			if (BKT_TYPE == 1)
				conf ^= bit[node - 1];

			if (BKT_TYPE == 2) {
				for (i = 0; i < nvec[1][node]; i++) {
					j = vec[1][node][i];
					sel[j]--;
					if (sel[j] == 0)
						conf ^= bit[j - 1];
				}
			}
		}
		
		sel[node] = 0;
	}
}

int main() {
	int tstart = clock();

	bit[0] = 1;
	for (i = 1; i < 18; i++)
		bit[i] = bit[i - 1] << 1;
	
	freopen("alianta.in", "r", stdin);
	freopen("alianta.out", "w", stdout);

	int T;
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d %d", &N, &M);

		memset(A, 0, sizeof(A));
		for (k = 1; k <= M; k++) {
			scanf("%d %d", &i, &j);
			A[i][j] = A[j][i] = 1;
		}

		memset(max_nodes, 0, sizeof(max_nodes));
		
		MIN_NODE = 1; MAX_NODE = (N / 2) + 1; BKT_TYPE = 1;
		
		for (i = MIN_NODE; i < MAX_NODE; i++) {
			nvec[0][i] = 0;
			for (j = MIN_NODE; j < MAX_NODE; j++)
				if (A[i][j]) {
					vec[0][i][nvec[0][i]] = j;
					nvec[0][i]++;
				}
		}

		memset(sel, 0, sizeof(sel));
		k = 0;
		conf = 0;
		BKT(MIN_NODE);

		confmax = 1 << (MAX_NODE - 1);
		for (conf = 0; conf < confmax; conf++)
			for (i = 0; i < MAX_NODE - 1; i++)
				if ((conf & bit[i]) == 0) {
					pconf = conf | bit[i];
					if (max_nodes[conf] > max_nodes[pconf])
						max_nodes[pconf] = max_nodes[conf];
				}

		conf = confmax - 1;
		answer = 0;
		MIN_NODE = MAX_NODE; MAX_NODE = N + 1; BKT_TYPE = 2;

		for (i = MIN_NODE; i < MAX_NODE; i++) {
			nvec[0][i] = nvec[1][i] = 0;
			for (j = MIN_NODE; j < MAX_NODE; j++)
				if (A[i][j]) {
					vec[0][i][nvec[0][i]] = j;
					nvec[0][i]++;
				}
	
			for (j = 1; j < MIN_NODE; j++)
				if (A[i][j]) {
					vec[1][i][nvec[1][i]] = j;
					nvec[1][i]++;
				}
		}


		memset(sel, 0, sizeof(sel));
		k = 0;
		BKT(MIN_NODE);

		printf("%d\n", answer);
	}

	fprintf(stderr, "Duration=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);
	return 0;
}
