#include <stdio.h>
#include <string.h>

#define LMAX 1000
char line[LMAX];
int pozline = 0, lenline = 0;
 
inline void ReadInt(int *x) {
    while (pozline < lenline && (line[pozline] < '0' || line[pozline] > '9'))
        pozline++;
 
    if (pozline == lenline) {
        fgets(line, LMAX - 3, stdin);
        pozline = 0;
        lenline = strlen(line);
        while (pozline < lenline && line[pozline] < '1' && line[pozline] > '9' && line[pozline] != '-')
            pozline++;
    }
     
    *x = 0;
    while (line[pozline] >= '0' && line[pozline] <= '9') {
        *x = (*x) * 10 + (line[pozline] - '0');
        pozline++;
    }   
}

#define NMAX 100100
#define LOGMAX 11
#define BMAX 20

int bit[BMAX];
unsigned char Anc[NMAX][25];
int N, M, A, B, X, Y, tip, i, current = 0;

inline int GetAnc(int i, int j) {
	int b, ans = 0;
	for (b = 0; b < 17; b++)
		if ((Anc[i][(j * 17 + b) >> 3] & bit[(j * 17 + b) & 7]) > 0)
			ans |= bit[b];
	return ans;
}

inline void SetAnc(int i, int j, int anc) {
	int b;
	for (b = 0; b < 17; b++)
		if ((anc & bit[b]) > 0)
			Anc[i][(j * 17 + b) >> 3] |= bit[(j * 17 + b) & 7];
}

void ComputeBits() {
	int i;
	bit[0] = 1;
	for (i = 1; i < BMAX; i++)
		bit[i] = bit[i - 1] * 2;
}

int main() {
	ComputeBits();
	
	freopen("citylog.in", "r", stdin);
	freopen("citylog.out", "w", stdout);

	ReadInt(&N);
	ReadInt(&M);
	
	memset(Anc, 0, sizeof(Anc));
	
	while (M--) {
		ReadInt(&tip); ReadInt(&A); ReadInt(&B);
		X = A ^ current; Y = B ^ current;

		if (tip == 0) {
			SetAnc(X, 0, Y);
			for (i = 1; i < LOGMAX; i++) {
				Y = GetAnc(Y, i - 1);
				SetAnc(X, i, Y);
			}
		} else {
			while (Y > bit[LOGMAX - 1] && X > 0) {
				X = GetAnc(X, LOGMAX - 1);
				Y -= bit[LOGMAX - 1];
			}
			
			i = LOGMAX - 1;
			while (X > 0 && Y > 0) {
				if (Y >= bit[i]) {
					X = GetAnc(X, i);
					Y -= bit[i];
				} else
					i--;
			}

			printf("%d\n", X);
			current = X;
		}
	}
	
	return 0;
}
