#include <stdio.h>
//#include <queue>
#include <time.h>

//using namespace std;

#define LMAX 1111

char S[LMAX];
int P[LMAX], next[LMAX][2];
int N, L;

void ReadInput() {
	freopen("interzis.in", "r", stdin);
	scanf("%d %d %s", &N, &L, S + 1);
}

void ComputePrefixFunction() {
	int i, k;
	P[1] = k = 0;
	for (i = 2; i <= L; i++) {
		while (k > 0 && S[k + 1] != S[i])
			k = P[k];
		if (S[k + 1] == S[i])
			k++;
		P[i] = k;
		//fprintf(stderr, "P[%d]=%d\n", i, P[i]);
	}
}

void BuildAutomaton() {
	int i, c;
	next[0][S[1] - 'a'] = 1;
	next[0][1 - (S[1] - 'a')] = 0;
	for (i = 1; i < L; i++) {
		next[i][S[i + 1] - 'a'] = i + 1;
		c = 1 - (S[i + 1] - 'a');
		next[i][c] = next[P[i]][c];
		//for (c = 0; c <= 1; c++)
		//	fprintf(stderr, "next[%d][%d]=%d\n", i, c, next[i][c]);
	}
	
	next[L][0] = next[P[L]][0];
	next[L][1] = next[P[L]][1];
}

#define MOD 101267

int cnt[2][LMAX], marked[2][LMAX], answer;
//queue<int> q[2];

void ComputeAnswer(int N) {
	int cp, np, c, n, i, ch, marking_number = 1;

	cnt[0][0] = 1;
	marked[0][0] = marking_number;
	//q[0].push(0);

	for (i = 0; i < N; i++) {
		//fprintf(stderr, "i=%d\n", i);
		marking_number++;
		c = i % 2;
		n = (i + 1) % 2;
		
		//while (q[c].size() > 0) {
			//cp = q[c].front();
			//fprintf(stderr, "i=%d cp=%d cnt=%d\n", i, cp, cnt[c][cp]);
			//q[c].pop();

		for (cp = 0; cp < L; cp++) {
			if (marked[c][cp] != (marking_number - 1))
				continue;
			for (ch = 0; ch <= 1; ch++) {
				np = next[cp][ch];
				if (np == L)
					continue;
				if (marked[n][np] != marking_number) {
					marked[n][np] = marking_number;
					cnt[n][np] = 0;
					//q[n].push(np);
				}
				cnt[n][np] = (cnt[n][np] + cnt[c][cp]) % MOD;
			}
		}
	}
	
	c = N % 2;
	answer = 0;
	for (cp = 0; cp < L; cp++)
		if (marked[c][cp] == marking_number)
			answer = (answer + cnt[c][cp]) % MOD;
}

/*
void ComputeAnswer2(int N) {
	int i, p, c;
	
	if (L > N) {
		answer = 1;
		for (i = 1; i <= N; i++)
			answer = (answer * 2) % MOD;
	} else {
		ComputeAnswer(L);
	}
}
*/

void WriteAnswer() {
	freopen("interzis.out", "w", stdout);
	printf("%d\n", answer);
}

int main() {
	int tstart = clock();
	ReadInput();
	ComputePrefixFunction();
	BuildAutomaton();
	ComputeAnswer(N);
	//ComputeAnswer2(N);
	WriteAnswer();
	fprintf(stderr, "Duration=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);
	return 0;
}
