#include <stdio.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <vector>

using namespace std;

vector<double> u;
double R;
int N, K;

void ReadInput() {
	int i;
	
	freopen("kgon.in", "r", stdin);
	scanf("%d %d %lf", &N, &K, &R);
	u.resize(N);
	for (i = 0; i < N; i++)
		scanf("%lf", &(u[i]));
}

#define eps 1e-5
#define NMAX 100111

int next[NMAX];

void FindNext() {
	int i, j, rewind = 0;
	double doipiR, delta, d;

	doipiR = 4.0 * acos(0.0) * R;
	delta = doipiR / (double) K;

	sort(u.begin(), u.end());

	for (i = j = 0; i < N; i++) {
		next[i] = -1;

		d = u[i] + delta;
		if (fabs(d - doipiR) < eps) {
			d = 0.0;
			if (!rewind) {
				j = 0;
				rewind = 1;
			}
		} else if (d > doipiR) {
			d -= doipiR;
			if (!rewind) {
				j = 0;
				rewind = 1;
			}
		}

		while (j < N && u[j] < d && fabs(u[j] - d) >= eps)
			j++;
		
		if (j < N && fabs(u[j] - d) < eps)
			next[i] = j;
	}
}

char visited[NMAX];
int answer;

void ComputeAnswer() {
	int i, j;

	answer = 0;
	memset(visited, 0, sizeof(visited));
	
	for (i = 0; i < N; i++)
		if (!visited[i]) {
			visited[i] = 1;
			j = next[i];
			while (j >= 0 && j != i) {
				visited[j] = 1;
				j = next[j];
			}
			
			if (j == i)
				answer++;
		}
}

void WriteOutput() {
	freopen("kgon.out", "w", stdout);
	printf("%d\n", answer);
}

int main() {
	ReadInput();
	FindNext();
	ComputeAnswer();
	WriteOutput();
	return 0;
}
