#include <stdio.h>

#define DEBUG 0
#define NMAX 100111

int p[NMAX];
int N;

void ReadInput() {
	int i;
	freopen("move.in", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%d", &p[i]);
}

int stk[NMAX], lis[NMAX], seq[NMAX];
int M;

void LongestIncreasingSubsequence() {
	int i, j, poz, li, ls, mid, ans;

	for (M = 0, i = 1; i <= N; i++) {
		li = 1; ls = M; ans = 0;
		while (li <= ls) {
			mid = (li + ls) / 2;
			if (stk[mid] < p[i]) {
				ans = mid;
				li = mid + 1;
			} else
				ls = mid - 1;
		}
		
		stk[ans + 1] = p[i];
		if (ans == M)
			M++;
		lis[i] = ans + 1;
	}

	for (i = N; i >= 1; i--) {
		if (lis[i] == M)
			break;
	}

	seq[j = M] = p[i];
	poz = i;

	for (i--; i >= 1 && j > 1; i--) {
		if (p[i] < p[poz] && lis[i] == lis[poz] - 1) {
			j--;
			seq[j] = p[i];
			poz = i;
		}
	}

	if (DEBUG) {
		fprintf(stderr, "Longest increasing subsequence: %d elements =>", M);
		for (j = 1; j <= M; j++)
			fprintf(stderr, " %d", seq[j]);
		fprintf(stderr, "\n");
	}
}

void GenerateMoves() {
	int i, j;
	freopen("move.out", "w", stdout);
	printf("%d\n", N - M);
	for (i = j = 1; i <= N; i++) {
		while (i > seq[j] && j < M)
			j++;
		if (i != seq[j])
			printf("%d %d\n", i, i - 1);
	}
}

int main() {
	ReadInput();
	LongestIncreasingSubsequence();
	GenerateMoves();
	return 0;
}
