#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define NMAX 100100
#define INF 2000000000

#define fmin(a, b) ((a) <= (b) ? (a) : (b))

int c[NMAX];
vector<int> vec[NMAX];
int N;

void ReadInput() {
	int i, j, k;
	freopen("mvc.in", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%d", &c[i]);
	for (k = 1; k <= N; k++) {
		scanf("%d %d", &i, &j);
		vec[i].push_back(j);
		vec[j].push_back(i);
	}
}

char visited[NMAX];
int parent[NMAX], cbest[NMAX][2], cmin;
int q[NMAX], li, ls;
int ei, ej;

void BFS(int root, bool compute) {
	int i, j, k;
	
	memset(visited, 0, sizeof(visited));
	parent[root] = 0;
	visited[root] = 1;
	li = ls = 1;
	q[1] = root;
	
	while (li <= ls) {
		i = q[li];
		li++;

		for (k = 0; k < vec[i].size(); k++) {
			j = vec[i][k];
			if ((ei == i && ej == j) || (ej == i && ei == j))
				continue;
			
			if (!visited[j]) {
				visited[j] = 1;
				parent[j] = i;
				ls++;
				q[ls] = j;
			}
		}
	}
	
	if (compute) {
		for (int o = N; o >= 1; o--) {
			i = q[o];
			cbest[i][0] = 0;
			cbest[i][1] = c[i];
			
			for (k = 0; k < vec[i].size(); k++) {
				j = vec[i][k];
				if (parent[j] == i) {
					cbest[i][0] += cbest[j][1];
					cbest[i][1] += fmin(cbest[j][0], cbest[j][1]);
				}
			}

			//fprintf(stderr, "o=%d: i=%d: %d %d\n", o, i, cbest[i][0], cbest[i][1]);
		}

		if (cbest[root][1] < cmin)
			cmin = cbest[root][1];
	}
}

void FindExtraEdge() {
	int i, j, k;
	for (i = 1; i <= N; i++)
		for (k = 0; k < vec[i].size(); k++) {
			j = vec[i][k];
			if (parent[j] != i && parent[i] != j) {
				ei = i;
				ej = j;
			}
		}
	//fprintf(stderr, "extra edge: %d %d\n", ei, ej);
}

void WriteAnswer() {
	freopen("mvc.out", "w", stdout);
	printf("%d\n", cmin);
}

int main() {
	ReadInput();

	ei = ej = 0;
	BFS(1, false);
	FindExtraEdge();

	cmin = INF;
	BFS(ei, true);
	BFS(ej, true);
	
	WriteAnswer();
	return 0;
}
