import java.util.*;
import java.io.*;

public class dowry_as {
    int n;
    long L;
    long R;
    long[] v;
    long[] w;

    class SS implements Comparable<SS> {
        long w;
        long v;
        int mask;

        public SS(int mask, long w, long v) {
            this.mask = mask;
            this.w = w;
            this.v = v;
        }

        public int compareTo(SS o) {
            return w < o.w ? -1 : w > o.w ? 1 : 0;
        }
    }

    int sn;
    SS[] s;

    int ts;
    long[] rt;
    int[] rtmask;

    void generate(int i, int mask, long sw, long sv) {
        if (i == n / 2) {
            s[sn++] = new SS(mask, sw, sv);
            return;
        }
        generate(i + 1, mask, sw, sv);
        generate(i + 1, mask | (1 << i), sw + w[i], sv + v[i]);
    }

    long best;
    int bestmask;

    int findFrom(long w) {
        int l = -1;
        int r = sn;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (s[m].w >= w) {
                r = m;
            } else {
                l = m;
            }
        }
        return r;
    }

    int findTo(long w) {
        int l = -1;
        int r = sn;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (s[m].w <= w) {
                l = m;
            } else {
                r = m;
            }
        }
        return l;
    }

    void relax(int mask, long sw, long sv) {
        int from = findFrom(L - sw);
        int to = findTo(R - sw);
        if (to < from) {
            return;
        }

        int i = from + ts;
        int j = to + ts;
        long bestv = 0;
        int bestm = 0;
        while (i <= j) {
            if (rt[i] > bestv) {
                bestv = rt[i];
                bestm = rtmask[i];
            }
            if (rt[j] > bestv) {
                bestv = rt[j];
                bestm = rtmask[j];
            }
            i = i / 2;
            j = j / 2 - 1;
        }

        if (bestv + sv > best) {
            best = bestv + sv;
            bestmask = mask | bestm;
        }
    }

    void backtrack(int i, int mask, long sw, long sv) {
        if (i == n) {
            relax(mask, sw, sv);

            return;
        }
        backtrack(i + 1, mask, sw, sv);
        backtrack(i + 1, mask | (1 << i), sw + w[i], sv + v[i]);
    }

    public void run() throws IOException {
        Scanner in = new Scanner(new File("dowry.in"));
        PrintWriter out = new PrintWriter(new File("dowry.out"));

        n = in.nextInt();
        L = in.nextLong();
        R = in.nextLong();

        assert L <= R;
        assert 0L <= L && L <= R && R <= 1000000000000000000L;

        v = new long[n];
        w = new long[n];
        for (int i = 0; i < n; i++) {
            w[i] = in.nextLong();
            v[i] = in.nextLong();

            assert 1 <= w[i] && w[i] <= 1000000000000000L;
            assert 1 <= v[i] && v[i] <= 1000000000000000L;
        }

        sn = 0;
        s = new SS[1 << (n / 2)];
        generate(0, 0, 0, 0);

        Arrays.sort(s);

        ts = (1 << (n / 2)) - 1;
        rt = new long[(1 << ((n / 2) + 1)) - 1];
        rtmask = new int[(1 << ((n / 2) + 1)) - 1];

        for (int i = 0; i < s.length; i++) {
            rt[ts + i] = s[i].v;
            rtmask[ts + i] = s[i].mask;
        }

        for (int i = ts - 1; i >= 0; i--) {
            if (rt[2 * i + 1] > rt[2 * i + 2]) {
                rt[i] = rt[2 * i + 1];
                rtmask[i] = rtmask[2 * i + 1];
            } else {
                rt[i] = rt[2 * i + 2];
                rtmask[i] = rtmask[2 * i + 2];
            }
        }

        best = 0;
        backtrack(n / 2, 0, 0, 0);

        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if ((bestmask & (1 << i)) != 0) {
                cnt++;
            }
        }
        out.println(cnt);
        for (int i = 0; i < n; i++) {
            if ((bestmask & (1 << i)) != 0) {
                out.print(i + 1);
                if (--cnt != 0) {
                    out.print(" ");
                }
            }
        }
        out.println();


        in.close();
        out.close();
    }

    public static void main(String[] arg) throws IOException {
        new dowry_as().run();
    }
}
