import java.util.*;
import java.io.*;

public class dowry_as_backtrack_tc {
    int n;
    long L;
    long R;

    class Diamond implements Comparable<Diamond> {
        long v;
        long w;
        int i;

        public Diamond(long v, long w, int i) {
            this.v = v;
            this.w = w;
            this.i = i;
        }

        public int compareTo(Diamond o) {
            double myr = 1.0 * v / w;
            double otr = 1.0 * o.v / o.w;
            if (myr > otr) {
                return -1;
            } else if (myr < otr) {
                return 1;
            } else {
                return i - o.i;
            }
        }
    }

    Diamond[] d;

    long best;
    int bestMask;

    void backtrack(int i, long w, long v, int mask) {
        if (i == n) {
            if (v > best && (L <= w && w <= R)) {
                best = v;
                bestMask = mask;
            }
        }

        if (System.currentTimeMillis() - time > 1800) {
            return;
        }

        long sumw = w;
        long sumv = v;
        for (int j = i; j < n; j++) {
            sumw += d[j].w;
            sumv += d[j].v;
        }
        if (sumw < L) {
            return;
        }
        if (sumv <= best) {
            return;
        }

        if (w + d[i].w <= R) {
            backtrack(i + 1, w + d[i].w, v + d[i].v, mask | (1 << d[i].i));
        }
        backtrack(i + 1, w, v, mask);
    }

    long time;

    public void run() throws IOException {
        time = System.currentTimeMillis();

        Scanner in = new Scanner(new File("dowry.in"));
        PrintWriter out = new PrintWriter(new File("dowry.out"));

        n = in.nextInt();
        L = in.nextLong();
        R = in.nextLong();
        d = new Diamond[n];
        for (int i = 0; i < n; i++) {
            long w = in.nextLong();
            long v = in.nextLong();
            d[i] = new Diamond(v, w, i);
        }

        Arrays.sort(d);

        best = 0;
        bestMask = 0;
        backtrack(0, 0L, 0L, 0);

        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if ((bestMask & (1 << i)) != 0) {
                cnt++;
            }
        }
        out.println(cnt);
        for (int i = 0; i < n; i++) {
            if ((bestMask & (1 << i)) != 0) {
                out.print(i + 1);
                if (--cnt != 0) {
                    out.print(" ");
                }
            }
        }
        out.println();


        in.close();
        out.close();
    }

    public static void main(String[] arg) throws IOException {
        new dowry_as_backtrack_tc().run();
    }
}