import java.io.IOException;
import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Arrays;

public class dowry_as_dumb {
    int n;
    long L;
    long R;
    long[] v;
    long[] w;

    class SS implements Comparable<dowry_as_dumb.SS> {
        long w;
        long v;
        int mask;

        public SS(int mask, long w, long v) {
            this.mask = mask;
            this.w = w;
            this.v = v;
        }

        public int compareTo(dowry_as_dumb.SS o) {
            return w < o.w ? -1 : w > o.w ? 1 : 0;
        }
    }

    int sn;
    dowry_as_dumb.SS[] s;

    int ts;
    long[] rt;
    int[] rtmask;

    void generate(int i, int mask, long sw, long sv) {
        if (i == n / 2) {
            s[sn++] = new dowry_as_dumb.SS(mask, sw, sv);
            return;
        }
        generate(i + 1, mask, sw, sv);
        generate(i + 1, mask | (1 << i), sw + w[i], sv + v[i]);
    }

    long best;
    int bestmask;

    int findFrom(long w) {
        int l = -1;
        int r = sn;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (s[m].w >= w) {
                r = m;
            } else {
                l = m;
            }
        }
        return r;
    }

    int findTo(long w) {
        int l = -1;
        int r = sn;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (s[m].w <= w) {
                l = m;
            } else {
                r = m;
            }
        }
        return l;
    }

    void relax(int mask, long sw, long sv) {
        if (sw < L || sw > R) {
            return;
        }
        if (sv > best) {
            best = sv;
            bestmask = mask;
        }
    }

    void backtrack(int i, int mask, long sw, long sv) {
        if (i == n) {
            relax(mask, sw, sv);

            return;
        }
        backtrack(i + 1, mask, sw, sv);
        backtrack(i + 1, mask | (1 << i), sw + w[i], sv + v[i]);
    }

    public void run() throws IOException {
        Scanner in = new Scanner(new File("dowry.in"));
        PrintWriter out = new PrintWriter(new File("dowry.out"));

        n = in.nextInt();
        L = in.nextLong();
        R = in.nextLong();
        v = new long[n];
        w = new long[n];
        for (int i = 0; i < n; i++) {
            w[i] = in.nextLong();
            v[i] = in.nextLong();
        }

        best = 0;
        backtrack(0, 0, 0, 0);

        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if ((bestmask & (1 << i)) != 0) {
                cnt++;
            }
        }
        out.println(cnt);
        for (int i = 0; i < n; i++) {
            if ((bestmask & (1 << i)) != 0) {
                out.print(i + 1);
                if (--cnt != 0) {
                    out.print(" ");
                }
            }
        }
        out.println();


        in.close();
        out.close();
    }

    public static void main(String[] arg) throws IOException {
        new dowry_as_dumb().run();
    }
}
