//  ""
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , argentony@gmail.com

import java.io.*;
import java.util.*;

public class equation_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new equation_af()).start();
	}
	
	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;
	String FNAME = "equation";
	Random rand = new Random(this.hashCode());
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
		} catch(IOException e) {
		} finally {
			out.close();
		}
	}
	
	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch(Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}
	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	long nextLong() {
		return Long.parseLong(nextToken());
	}
	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	void myAssert(boolean e, String msg) {
		if (!e) throw new Error(msg);
	}
	
	
	void solve() throws IOException {
		long a = nextLong();
		long b = nextLong();
		long c = nextLong();
		long d = nextLong();
		long v = nextLong();
		
		myAssert(Math.abs(a) <= 1000, "a out of bounds exception");
		myAssert(Math.abs(b) <= 1000, "b out of bounds exception");
		myAssert(Math.abs(c) <= 1000, "c out of bounds exception");
		myAssert(Math.abs(d) <= 1000, "d out of bounds exception");
		myAssert(Math.abs(v) <= 1000, "v out of bounds exception");
		
		long p = v * d - b;
		long q = a - v * c;
		if (c == 0 && d == 0 || q == 0 && p != 0) {
			out.println("NONE");
			return;
		}
		if (p == 0 && q == 0) {
			out.println("MULTIPLE");
			return;
		}
		if (c * p + d * q == 0) {
			out.println("NONE");
			return;
		}
		if (q < 0) {
			p = -p;
			q = -q;
		}
		out.println("X = " + p / gcd(p, q) + "/" + q / gcd(p, q));
	}
	
	long gcd(long a, long b) {
		if (a < 0) return gcd(b, -a);
		if (a == 0) return b;
		return gcd(b % a, a);
	}
	
}
