import java.util.*;
import java.io.*;

public class independent_as {
    String s;
    int p;

    enum GT {
        S, P, g
    }

    class Graph {
        GT type;
        Graph l;
        Graph r;

        int[] is;

        public Graph(GT type, Graph l, Graph r) {
            this.type = type;
            this.l = l;
            this.r = r;
        }

        void calcIS() {
            is = new int[4];
            switch (type) {
                case g:
                    is[0] = 0;
                    is[1] = is[2] = 1;
                    is[3] = -1;
                    break;
                case S:
                    l.calcIS();
                    r.calcIS();
                    for (int i = 0; i < 4; i++) {
                        is[i] = -1;
                        for (int j = 0; j < 2; j++) {
                            int li = (i & 2) | j;
                            int ri = (j << 1) | (i & 1);
                            if (l.is[li] != -1 && r.is[ri] != -1) {
                                is[i] = Math.max(is[i], l.is[li] + r.is[ri] - j);
                            }
                        }
                    }
                    break;
                case P:
                    l.calcIS();
                    r.calcIS();
                    for (int i = 0; i < 4; i++) {
                        is[i] = -1;
                        if (l.is[i] != -1 && r.is[i] != -1) {
                            is[i] = l.is[i] + r.is[i] - ((i & 1) + (i >> 1));
                        }
                    }
                    break;
            }
        }
    }

    Graph parse() {
        switch (s.charAt(p++)) {
            case 'g':
                return new Graph(GT.g, null, null);
            case 'S':
                return new Graph(GT.S, parse(), parse());
            case 'P':
                return new Graph(GT.P, parse(), parse());
        }
        return null;
    }

    public void run() throws IOException {
        Scanner in = new Scanner(new File("independent.in"));
        PrintWriter out = new PrintWriter(new File("independent.out"));

        s = in.next();
        p = 0;
        Graph g = parse();
        g.calcIS();

        int isize = 0;
        for (int x : g.is) {
            if (x > isize) {
                isize = x;
            }
        }

        out.println(isize);

        in.close();
        out.close();
    }

    public static void main(String[] arg) throws IOException {
        new independent_as().run();
    }
}
