import java.io.*;
import java.util.*;

//Problem "Martian Language"
//7th Internet Olympiad, basic level, season 2007-2008
//Problem Author: Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Maxim Buzdalov, buzdalov@rain.ifmo.ru

//Incorrect solution: the possible sum bounds are handled in wrong way.
public class language_mb_wrong1 {
    public static void main(String[] args) throws IOException {
	Scanner in = new Scanner(new File("language.in"));
	int n = in.nextInt();
	int min = in.nextInt();
	int max = in.nextInt();
	String sequence = in.next();
	in.close();

	assert sequence.length() == n : "The number of symbols is wrong";
	assert 1 <= min && min <= max && max <= n : "Bounds are wrong";
	assert n <= 5000 : "N is too big";
	
	int[] bestLength = new int[n + 1];
	int[] bestSum = new int[n + 1];
	Arrays.fill(bestSum, -1);
	bestSum[0] = 0;
	
	for (int i = 0; i < n; ++i) {
	    if (bestSum[i] == -1) {
		continue;
	    }
	    int minChar = sequence.charAt(i);
	    int maxChar = minChar;
	    for (int j = 0; j < max && i + j < n; ++j) {
		minChar = Math.min(minChar, sequence.charAt(i + j));
		maxChar = Math.max(maxChar, sequence.charAt(i + j));
		if (j >= min) {
		    if (bestSum[i] + maxChar - minChar > bestSum[i + j + 1]) {
			bestSum[i + j + 1] = bestSum[i] + maxChar - minChar;
			bestLength[i + j + 1] = j + 1;
		    }
		}
	    }
	}
	
	PrintWriter out = new PrintWriter("language.out");
	if (bestSum[n] == -1) {
    	    out.println("NO SOLUTION");
    	} else {
    	    out.println(bestSum[n]);
    	    ArrayList<String> words = new ArrayList<String>();
    	    int cp = n;
    	    while (cp > 0) {
    		words.add(sequence.substring(cp - bestLength[cp], cp));
    		cp -= bestLength[cp];
    	    }
    	    out.println(words.size());
    	    for (int i = words.size() - 1; i >= 0; --i) {
    		out.println(words.get(i));
    	    }
    	}
	out.close();
    }
}
