//  " "
// 07- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class language_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new language_sp()).run();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "language";

	public void solve() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		int n = nextInt();
		int c = nextInt();
		int C = nextInt();
		myAssert((1 <= c) && (c <= C) && (C <= n) && (n <= 5000), "Range of numbers is wrong");
		String s = br.readLine();
		myAssert(s.length() == n, "Wrong length of string");
		for (int i = 0; i < n; i++) {
			myAssert(s.charAt(i) >= 'a' && s.charAt(i) <= 'z', "Wrong character in string");
		}
		char[][] max = new char[n][n];
		char[][] min = new char[n][n];
		for (int i = 0; i < n; i++) {
			min[i][i] = s.charAt(i);
			max[i][i] = s.charAt(i);
			for (int j = i + 1; j < n; j++) {
				min[i][j] = (char) Math.min(min[i][j - 1], s.charAt(j));
				max[i][j] = (char) Math.max(max[i][j - 1], s.charAt(j));
			}
		}
		int[] ans = new int[n + 1];
		int[] par = new int[n + 1];
		Arrays.fill(ans, Integer.MIN_VALUE / 2);
		ans[0] = 0;
		for (int i = 1; i <= n; i++) {
			for (int j = Math.max(0, i - C); j < Math.max(0, i - c + 1); j++) {
				if (ans[j] + max[j][i - 1] - min[j][i - 1] > ans[i]) {
					ans[i] = ans[j] + max[j][i - 1] - min[j][i - 1];
					par[i] = j;
				}
			}
		}
		if (ans[n] < 0) {
			out.println("NO SOLUTION");
		} else {
			out.println(ans[n]);
			int i = n;
			int[] st = new int[n + 1];
			int top = 0;
			while (i != 0) {
				st[top++] = i;
				i = par[i];
			}
			out.println(top);
			for (i = top; i > 0; i--) {
				out.println(s.substring(st[i], st[i - 1]));
			}
		}
		out.close();
	}
}
