import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class rmq2_sdupid_da implements Runnable {
	
	private static final int MINN = 1;
	private static final int MAXN = 500;
	private static final int MINM = 1;
	private static final int MAXM = 500;
	private static final int MINA = Integer.parseInt("-2147483648");
	private static final int MAXA = Integer.parseInt("2147483647");
	private static final int MINQ = 1;
	private static final int MAXQ = 200000;
	
	private static final int INF = MAXA;
	
	private PrintWriter out;
	private BufferedReader in;
	
	private int[] solve(int[][] a, int[] x1, int[] y1, int[] x2, int[] y2) {
		int q = x1.length;
		int[] result = new int[q];
		for (int i = 0; i < q; i++) {
			int min = INF;
			for (int x = x1[i]; x <= x2[i]; x++) {
				for (int y = y1[i]; y <= y2[i]; y++) {
					if (min > a[x - 1][y - 1]) {
						min = a[x - 1][y - 1];
					}
				}
			}
			result[i] = min;
		}
		return result;
	}

	private Input readInput() throws Exception {
		StringTokenizer aline;
		aline = new StringTokenizer(in.readLine());
		int m = Integer.parseInt(aline.nextToken());
		int n = Integer.parseInt(aline.nextToken());
		if (aline.hasMoreTokens()) {
			throw new Exception("Too many tokens in a line");
		}
		int[][] a = new int[m][n];
		for (int i = 0; i < m; i++) {
			aline = new StringTokenizer(in.readLine());
			for (int j = 0; j < n; j++) {
				a[i][j] = Integer.parseInt(aline.nextToken());
			}
			if (aline.hasMoreTokens()) {
				throw new Exception("Too many tokens in a line");
			}
		}
		aline = new StringTokenizer(in.readLine());
		int q = Integer.parseInt(aline.nextToken());
		if (aline.hasMoreTokens()) {
			throw new Exception("Too many tokens in a line");
		}
		int[][] p = new int[4][q];
		for (int i = 0; i < q; i++) {
			aline = new StringTokenizer(in.readLine());
			for (int j = 0; j < 4; j++) {
				p[j][i] = Integer.parseInt(aline.nextToken());
			}
			if (aline.hasMoreTokens()) {
				throw new Exception("Too many tokens in a line");
			}
		}
		Input result = new Input(a, p[0], p[1], p[2], p[3]);
		if (!result.isConsistent()) {
			throw new Exception("Inconsistent input");
		}
		return result;
	}
	
	private void printResult(int[] result) {
		for (int i = 0; i < result.length; i++) {
			out.println(result[i]);
		}
	}
	
	public void run() {
		try {
			Input input = readInput();
			int[] result = solve(input.a, input.x1, input.y1, input.x2, input.y2);
			printResult(result);
		} catch (Exception e) {
			apstenu(e);
		} finally {
		    out.close();
		}
	}

	private void apstenu(Exception e) {
		e.printStackTrace();
		System.exit(239);
	}
	
	private rmq2_sdupid_da(String name) {
		try {
			out = new PrintWriter(new FileWriter(name + ".out"));
			in = new BufferedReader(new FileReader(name + ".in"));
		} catch (Exception e) {
			apstenu(e);
		}
	}
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new rmq2_sdupid_da("rmq2")).start();
	}
	
	public static class Input {
		public int[][] a;
		public int[] x1;
		public int[] y1;
		public int[] x2;
		public int[] y2;
		public Input(int[][] a, int[] x1, int[] y1, int[] x2, int[] y2) {
			this.a = a;
			this.x1 = x1;
			this.y1 = y1;
			this.x2 = x2;
			this.y2 = y2;
		}
		public boolean isConsistent() {
			int m = a.length;
			if (m < MINM || m > MAXM) {
				return false;
			}
			int n = a[0].length;
			if (n < MINN || n > MAXN) {
				return false;
			}
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					if (a[i][j] < MINA || a[i][j] > MAXA) {
						return false;
					}
				}
			}
			int q = x1.length;
			if (q < MINQ || q > MAXQ) {
				return false;
			}
			for (int i = 0; i < q; i++) {
				if (x1[i] < 1 || x1[i] > m) {
					return false;
				}
				if (y1[i] < 1 || y1[i] > n) {
					return false;
				}
				if (x2[i] < 1 || x2[i] > m) {
					return false;
				}
				if (y2[i] < 1 || y2[i] > n) {
					return false;
				}
				if (x1[i] > x2[i] || y1[i] > y2[i]) {
					return false;
				}
			}
			return true;
		}
	}
}
