//  " "
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class cyclic_ft implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "cyclic";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               

	public void solve() {
		String s = in.next();
		int n = s.length();
		myAssert(1 <= n && n <= MAX_N, "Length is out of bounds: " + n);
		for (int i = 0; i < n; i++) {
			char ch = s.charAt(i);
			myAssert('a' <= ch && ch <= 'z', "Character #" + i + " is not a letter: " + ch);
		}
		boolean hasDifferent = false;
		for (int i = 1; i < n; i++) {
			hasDifferent |= s.charAt(0) != s.charAt(i);
		}
		if (hasDifferent) {
			out.println("YES");
		} else {
			out.println("NO");
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public cyclic_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new cyclic_ft()).start();
	}

}                       