//  "  "
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class lines2d_ft implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "lines2d";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}

    int gcd(int a, int b) {
    	if (b == 0) {
    		return a;
    	} else {
    		return gcd(b, a % b);
    	}
    }                    
	
	class Line2D {
		int a;
		int b;
		public Line2D(int aa, int bb) {
			a = aa;
			b = bb;
			int g = gcd(Math.abs(a), Math.abs(b));
			a /= g;
			b /= g;
			if (b < 0) {
		    	a = -a;
		    	b = -b;
			}
		}
        
		public int hashCode() {
			return 17 * a + 239 * b;
		}

		public boolean equals(Object o) {
			Line2D l = (Line2D) o;
			return l.a == a && l.b == b;
		}
	}

	public void solve() {
		int n = in.nextInt();
		HashSet<Line2D> set = new HashSet<Line2D>();
		for (int i = 0; i < n; i++) {
			int a = in.nextInt();
			int b = in.nextInt();
			int c = in.nextInt();
			myAssert(Math.abs(a) <= 100000, "");
			myAssert(Math.abs(b) <= 100000, "");
			myAssert(Math.abs(c) <= 100000, "");
			myAssert(a != 0 || b != 0, "");
			set.add(new Line2D(a, b));
		}
		out.println(set.size());
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public lines2d_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new lines2d_ft()).start();
	}

}                       