import java.io.*;
import java.util.*;

//Problem "Lines on the plane"
//7th Internet Olympiad, basic level, season 2007-2008
//Problem Author: Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Maxim Buzdalov, buzdalov @rain.ifmo.ru

//Correct solution.
public class lines2d_mb {
    public static void main(String[] args) throws IOException {
	Scanner in = new Scanner(new File("lines2d.in"));
	int n = in.nextInt();
	assert 1 <= n && n <= 1000 : "N is out of bounds";
	long[] a = new long[n];
	long[] b = new long[n];
	int diffCount = 0;
	for (int i = 0; i < n; ++i) {
	    a[i] = in.nextInt();
	    b[i] = in.nextInt();
	    assert Math.abs(a[i]) <= 100000 : "A is out of bounds";
	    assert Math.abs(b[i]) <= 100000 : "B is out of bounds";
	    int t = in.nextInt();
	    assert Math.abs(t) <= 100000 : "C is out of bounds";
	    
	    diffCount++;
	    
	    for (int j = 0; j < i; ++j) {
		if (a[i] * b[j] == a[j] * b[i]) {
		    diffCount--;
		    break;
		}
	    }
	}
	in.close();
	
	PrintWriter out = new PrintWriter("lines2d.out");
	out.println(diffCount);
	out.close();
    }
}