//  ""
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class roads_ft implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "roads";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               
	
	int cnt(boolean[] a) {
		int res = 0;
		for (boolean b : a) {
			if (b) {
				res++;
			}
		}
		return res;
	}

	public void solve() {
		int n = in.nextInt();
		myAssert(0 <= n && n <= 1000, "n is out of bounds: " + n);
		long[] a = new long[n];
		long[] b = new long[n];
		long[] c = new long[n];
		long[] d = new long[n];

		for (int i = 0; i < n; i++) {
			int x1 = in.nextInt();
			int y1 = in.nextInt();
			int x2 = in.nextInt();
			int y2 = in.nextInt();
			myAssert(Math.abs(x1) <= 10000, "");
			myAssert(Math.abs(x2) <= 10000, "");
			myAssert(Math.abs(y1) <= 10000, "");
			myAssert(Math.abs(y2) <= 10000, "");
			d[i] = in.nextInt();
			myAssert(1 <= d[i] && d[i] <= 1000, "");
			a[i] = y1 - y2;
			b[i] = x2 - x1;
			c[i] = -a[i] * x1 - b[i] * y1;
		}

		int m = in.nextInt();
		myAssert(0 <= m && m <= 1000, "m is out of bounds: " + m);
		long[] x = new long[m];
		long[] y = new long[m];
		for (int i = 0; i < m; i++) {
			x[i] = in.nextInt();
			y[i] = in.nextInt();
			myAssert(Math.abs(x[i]) <= 10000, "");
			myAssert(Math.abs(y[i]) <= 10000, "");
		}

		boolean[] road = new boolean[n];
		boolean[] sign = new boolean[m];

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (4 * (a[i] * x[j] + b[i] * y[j] + c[i]) * (a[i] * x[j] + b[i] * y[j] + c[i]) <=
					d[i] * d[i] * (a[i] * a[i] + b[i] * b[i])) {
						road[i] = true;
						sign[j] = true;
					}
			}
		}

 		
 		out.println(cnt(road) + " " + cnt(sign));

	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public roads_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new roads_ft()).start();
	}

}                       