import java.util.*;
import java.io.*;
import java.math.*;

//Problem "Roads"
//7th Internet Olympiad, season 2007-2008
//Problem Author:  Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Vladimir Ulyantsev, ulyantsev@rain.ifmo.ru

public class roads_vu implements Runnable {
	final static String FILE = "roads";

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new roads_vu()).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	long nextLong() throws IOException {
		while (st == null || !st.hasMoreElements()) {
			st = new StringTokenizer(in.readLine());
		}
		return Long.parseLong(st.nextToken());
	}

	int nextInt() throws IOException {
		while (st == null || !st.hasMoreElements()) {
			st = new StringTokenizer(in.readLine());
		}
		return Integer.parseInt(st.nextToken());
	}

	double nextDouble() throws IOException {
		while (st == null || !st.hasMoreElements()) {
			st = new StringTokenizer(in.readLine());
		}
		return Double.parseDouble(st.nextToken());
	}

	public roads_vu() {
		try {
			in = new BufferedReader(new FileReader(FILE + ".in"));
			out = new PrintWriter(new File(FILE + ".out"));
			st = new StringTokenizer("");
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	private void Assert(boolean e) {
		if (!e) {
			throw new Error("Test-author error");
		}
	}
	
	public void solve() throws IOException {
		int maxX = 10000;
		int maxD = 1000;
		int n = nextInt();
		long[] a = new long[n];
		long[] b = new long[n];
		long[] c = new long[n];
		long[] d = new long[n];
		for (int i = 0; i < n; i++) {
			int x1 = nextInt();
			int y1 = nextInt();
			int x2 = nextInt();
			int y2 = nextInt();
			Assert(Math.abs(x1) <= maxX && Math.abs(y1) <= maxX);
			Assert(Math.abs(x2) <= maxX && Math.abs(y2) <= maxX);
			d[i] = nextInt();
			Assert(d[i] <= maxD);
			a[i] = y2 - y1;
			b[i] = x1 - x2;
			c[i] = -a[i] * x1 - b[i] * y1;
		}

		int m = nextInt();
		int[] x = new int[m];
		int[] y = new int[m];
		for (int i = 0; i < m; i++) {
			x[i] = nextInt();
			y[i] = nextInt();
			Assert(Math.abs(x[i]) <= maxX && Math.abs(y[i]) <= maxX);
		}
		
		boolean[] line = new boolean[n];
		boolean[] point = new boolean[m];
		int ans1 = 0;
		int ans2 = 0;
		
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if ((a[i] * x[j] + b[i] * y[j] + c[i]) * (a[i] * x[j] + b[i] * y[j] + c[i]) * 4 <= (a[i] * a[i] + b[i] * b[i]) * d[i] * d[i]) {
					ans1 += (!line[i]) ? 1 : 0;
					ans2 += (!point[j]) ? 1 : 0;
					line[i] = true;
					point[j] = true;
				}
			}
		}
		out.print(ans1 + " " + ans2);		
	}
}