//  " "
// 8- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class gentest_ft implements Runnable {

	private Scanner in;
	private PrintWriter out;
	String fname = "gentest";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               
	
	class Line implements Comparable<Line> {
		int a;
		int b;
		public Line(int a, int b) {
			int g = gcd(Math.abs(a), Math.abs(b));
			a /= g;
			b /= g;
			if (a < 0) {
				a = -a;
				b = -b;
			} else if (a == 0) {
				if (b < 0) {
					b = -b;
				}			
			}
			this.a = a;
			this.b = b;
		}

	    int gcd(int a, int b) {
    		if (b == 0) {
	    		return a;
    		} else {
    			return gcd(b, a % b);
	    	}
    	}                    
	
	    public int compareTo(Line l) {
	    	if (a == l.a) {
	    		return b - l.b;
	    	}                  
	    	return a - l.a;
	    }

	}

	public final static int MAXC = 10000;

	public void solve() {
		int n = in.nextInt();
		myAssert(1 <= n && n <= 2000, "");
		Random r = new Random(6351268);
		int[] x = new int[n];
		int[] y = new int[n];

		for (int i = 0; i < n; i++) {
			while (true) {
				int cx = r.nextInt(2 * MAXC + 1) - MAXC;
				int cy = r.nextInt(2 * MAXC + 1) - MAXC;
				boolean good = true;
				for (int j = 0; j < i; j++) {
					if (x[j] == cx && y[j] == cy) {
						good = false;
						break;
					}
				}
				if (!good) {
					continue;
				}
				if (good) {
					Line[] a = new Line[i];
					for (int j = 0; j < i; j++) {
						a[j] = new Line(cy - y[j], x[j] - cx);
					}
					Arrays.sort(a);
					for (int j = 0; j < i - 1; j++) {
						if (a[j].a == a[j + 1].a && a[j].b == a[j + 1].b) {
							good = false;
							break;
						}	
					}
				}
				if (good) {
					x[i] = cx;
					y[i] = cy;
					break;					
				}
			}
		}
		out.println("YES");
		for (int i = 0; i < n; i++) {
			out.println(x[i] + " " + y[i]);
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public gentest_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new gentest_ft()).start();
	}

}                                      