//  " "
// 8- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

//   n <= 500

import java.io.*;
import java.util.*;

public class gentest_ft_smalln implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "gentest";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               
	
	class Line implements Comparable<Line> {
		int a;
		int b;
		public Line(int a, int b) {
			int g = gcd(Math.abs(a), Math.abs(b));
			a /= g;
			b /= g;
			if (a < 0) {
				a = -a;
				b = -b;
			} else if (a == 0) {
				if (b < 0) {
					b = -b;
				}			
			}
			this.a = a;
			this.b = b;
		}

	    int gcd(int a, int b) {
    		if (b == 0) {
	    		return a;
    		} else {
    			return gcd(b, a % b);
	    	}
    	}                    
	
	    public int compareTo(Line l) {
	    	if (a == l.a) {
	    		return b - l.b;
	    	}                  
	    	return a - l.a;
	    }

	}

	public final static int MAXC = 10000;

	public void solve() {
		int attempts = 0;
		int n = in.nextInt();
		myAssert(1 <= n && n <= 2000, "");
		Random r = new Random(6351268);
		while (true) {
			int[] x = new int[n];
			int[] y = new int[n];
			for (int i = 0; i < n; i++) {
				x[i] = r.nextInt(2 * MAXC + 1) - MAXC;
				y[i] = r.nextInt(2 * MAXC + 1) - MAXC;
			}
			attempts++;
			boolean good = true;
			outer:
			for (int i = 0; i < n; i++) {
				for (int j = i + 1; j < n; j++) {
					int a = y[i] - y[j];
					int b = x[j] - x[i];
					if (a == 0 && b == 0) {
						good = false;
						break outer;
					}
				}
			}
			if (good) {
				outer1:
				for (int i = 0; i < n; i++) {
					Line[] a = new Line[n - 1];
					int cnt = 0;
					for (int j = 0; j < n; j++) {
						if (i == j) {
							continue;
						}
						a[cnt++] = new Line(y[j] - y[i], x[i] - x[j]);
					}
					Arrays.sort(a);
					for (int j = 0; j < cnt - 1; j++) {
						if (a[j].a == a[j + 1].a && a[j].b == a[j + 1].b) {
							good = false;
							break outer1;
						}	
					}
				}
			}
			if (good) {
				System.out.println(attempts);
				out.println("YES");
				for (int i = 0; i < n; i++) {
					out.println(x[i] + " " + y[i]);
				}
				break;
			}
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public gentest_ft_smalln() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new gentest_ft_smalln()).start();
	}

}                                      