import java.io.*;
import java.math.*;
import java.util.*;

public class maze_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new maze_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("maze.in"));
			out = new PrintWriter("maze.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 100, "n out of bounds exception");
		g = new ArrayList[n];
		for (int i = 0; i < n; ++i)
			g[i] = new ArrayList<Edge>();
		int m = nextInt();
		myAssert(0 <= m && m <= 1000, "m out of bounds exception");
		ArrayList<Edge>[] lst = new ArrayList[2];
		lst[0] = new ArrayList<Edge>();
		lst[1] = new ArrayList<Edge>();

		for (int i = 0; i < m; ++i) {
			int a = nextInt() - 1;
			myAssert(0 <= a && a < n, "a out of bounds exception");
			int b = nextInt() - 1;
			myAssert(0 <= b && b < n, "b out of bounds exception");
			int c = nextInt();
			myAssert(0 <= c && c <= 1, "c out of bounds exception");
			Edge tab = new Edge(b, c, 0);
			lst[0].add(tab);
			g[a].add(tab);
			Edge tba = new Edge(a, c, 0);
			lst[1].add(tba);
			g[b].add(tba);
		}
		int k = nextInt();
		int[] sw = new int[n];
		Arrays.fill(sw, -1);
		myAssert(1 <= k && k <= 10, "k out of bounds exception");
		for (int i = 0; i < k; ++i) {
			int rn = nextInt() - 1;
			myAssert(0 <= rn && rn < n, "rn out of bounds exception");
			sw[rn] = i;
			int tl = nextInt();
			myAssert(0 <= tl && tl <= m, "tl out of bounds exception");
			HashSet<Integer> hs = new HashSet<Integer>();
			for (int l = 0; l < tl; ++l) {
				int en = nextInt() - 1;
				myAssert(0 <= en && en < m, "en out of bounds exception");
				myAssert(!hs.contains(en), "Duplicate edges");
				hs.add(en);
				lst[0].get(en).mask |= (1 << i);
				lst[1].get(en).mask |= (1 << i);
			}
		}
		int s = nextInt() - 1;
		myAssert(0 <= s && s < n, "s out of bounds exception");
		int t = nextInt() - 1;
		myAssert(0 <= t && t < n, "t out of bounds exception");

		int[][] D = new int[1 << k][n];
		for (int i = 0; i < D.length; ++i) {
			Arrays.fill(D[i], Integer.MAX_VALUE);
		}
		D[0][s] = 0;
		int[] qx = new int[(1 << k) * n];
		int[] qm = new int[(1 << k) * n];
		int head = 0;
		qx[0] = s;
		qm[0] = 0;
		int tail = 1;
		while (head != tail) {
			int x = qx[head];
			int mask = qm[head];
			++head;
			int dist = D[mask][x];

			for (int i = 0; i < 2; ++i) {
				for (Edge e : g[x]) {
					if (canGo(e, mask) && D[mask][e.j] > dist + 1) {
						D[mask][e.j] = dist + 1;
						qx[tail] = e.j;
						qm[tail] = mask;
						++tail;
					}
				}
				if (sw[x] < 0) break;
				mask = mask ^ (1 << sw[x]);
			}
		}

		int ans = Integer.MAX_VALUE;
		for (int i = 0; i < 1 << k; ++i) {
			ans = Math.min(D[i][t], ans);
		}
		
		if (ans == Integer.MAX_VALUE)
		{
			out.println(-1);
		}
		else
		{
			out.println(ans);
		}
	}

	boolean canGo(Edge a, int mask) {
		return (Integer.bitCount(a.mask & mask) % 2) != a.c;
	}

	ArrayList<Edge>[] g;

	class Edge {
		int j, c, mask;

		Edge(int j, int c, int mask) {
			this.j = j;
			this.c = c;
			this.mask = mask;
		}
	}
}
