//  " "
// 8-  -  2008-2009
//  :   , ulyantsev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

uses
	math, sysutils;
type
	int = longint;
const
	inf = 1000000000;
	maxn = 100;
	maxm = 1000;
	maxk = 10;
	kpow = 1 shl maxk;
var
	n, m : int;
	u, v, c : array [1..maxm] of int;
	k : int;
	b : array [1..maxk, 1..maxm] of boolean;
	room : array [1..maxk] of int;
	ss, tt : int;

//        
procedure readData();
var
	i, j, cnt, cor : int;
begin
	read(n, m);
	assert((1 <= n) and (n <= maxn));
	assert((1 <= m) and (m <= maxm));
	for i := 1 to m do begin
		read(u[i], v[i], c[i]);
		assert((1 <= u[i]) and (u[i] <= n));
		assert((1 <= v[i]) and (v[i] <= n));
		assert((0 <= c[i]) and (c[i] <= 1)); // :-)
	end;
	
	fillchar(b, sizeof(b), 0);
	read(k);
	assert((1 <= k) and (k <= maxk));
	for i := 1 to k do begin
		read(room[i], cnt);
		assert((1 <= room[i]) and (room[i] <= n));
		for j := 1 to cnt do begin
			read(cor);
			assert((1 <= cor) and (cor <= m));
			assert(not b[i][cor]);
			b[i][cor] := true;
		end;
	end;
	
	read(ss, tt);
	assert((1 <= ss) and (ss <= n));
	assert((1 <= tt) and (tt <= n));
end;

var
	first : array [1..maxn * kpow] of int;
	t, w, next : array [1..4 * maxm * kpow] of int;
	edgeCnt : int;

//    a  b  c
procedure addEdge(a, b, c : int);
begin
	inc(edgeCnt);
	next[edgeCnt] := first[a];
	first[a] := edgeCnt;
	t[edgeCnt] := b;
	w[edgeCnt] := c;
	//writeln(a, ' ', b, ' ', c);
end;

//  ...
procedure buildGraph();
var
	mask, tmp, i, j : int;
	use : array [1..maxm] of boolean;
begin
	edgeCnt := 0;
	fillchar(first, sizeof(first), 0);
	for mask := 0 to (1 shl k - 1) do begin
		for i := 1 to m do begin
			use[i] := (c[i] = 1);
		end;

		// ,       
		tmp := mask;
		for i := 1 to k do begin
			if (tmp and 1 > 0) then begin
				for j := 1 to m do begin
					use[j] := use[j] xor b[i][j];
				end;
				//  0-  
				addEdge(mask * n + room[i], (mask - (1 shl (i - 1))) * n + room[i], 0);
				addEdge((mask - (1 shl (i - 1))) * n + room[i], mask * n + room[i], 0);
			end;
			tmp := tmp shr 1;
		end;

		//  
		for j := 1 to m do begin
			if (use[j]) then begin
				addEdge(mask * n + u[j], mask * n + v[j], 1);
				addEdge(mask * n + v[j], mask * n + u[j], 1);
			end;
		end;

	end;
end;

var
	dist : array [1..maxn * kpow] of int;

procedure bfs01();
var
	q : array [-kpow * maxn..kpow * maxn] of int;
	head, tail, u, a, i : int;
begin
	for i := 1 to n * (1 shl k) do begin
		dist[i] := -1;
	end;
	head := 0;
	tail := 1;
	q[head] := ss;
	dist[ss] := 0;

	while (head < tail) do begin
		u := q[head];
		inc(head);

		a := first[u];
		while (a > 0) do begin
			if (dist[t[a]] = -1) then begin
				if (w[a] = 0) then begin
					dec(head);
					q[head] := t[a];
				end else begin
					q[tail] := t[a];
					inc(tail);
				end;
				dist[t[a]] := dist[u] + w[a];
			end;
			a := next[a];
		end;
	end;
end;

var
	i, ans : int;

begin
	reset(input, 'maze.in');
	rewrite(output, 'maze.out');
	
	readData();
	buildGraph();
	bfs01();

	ans := -1;
	for i := 0 to (1 shl k - 1) do begin
		if ((dist[i * n + tt] > -1) and ((ans > dist[i * n + tt]) or (ans = -1))) then
			ans := dist[i * n + tt];
	end;
	writeln(ans);
end.
