//  "root"
// 8-  - 2008/2009 
//  :  , fedor.tsarev@gmail.com
//  :  , nosenkomax@gmail.com
//   O(p)

import java.util.*;
import java.io.*;
import java.math.BigInteger;

public class root_mn_slow implements Runnable {

	public static void main(String args[]) {
		new Thread(new root_mn_slow()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	private String FNAME = "root";
	boolean eof = false;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			br.close();
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}

	long gcd (long a, long b) {
		if (b == 0)
			return a;
		else
			return gcd(b,a % b);
	}
	
	long generator(long p) {
		for (int i = 1; i < p; i++) {
			if (good(i, p))
				return i;
		}
		My_Assert(false, "BOTVA");
		return -1;
	}
	
	private boolean good(long n, long p) {
		long t = n;
		for (int i = 1; i <= (p - 1) / 2; i++) {
			if (t == 1)
				return false;
			t = (t*n) % p;
		}
		return true;
	}

	private void solve() {
		long p = nextLong(),k = nextLong();
		BigInteger a = BigInteger.valueOf(p);
		
		My_Assert(2 <= p && p <= 1000000000, "p is out of range: " + p);
		My_Assert(2 <= k && k <= p - 1, "k is out of range: " + k);
		My_Assert(a.isProbablePrime(100), "p is not prime: " + p);
		
		int d = (int) gcd(k ,p - 1);
		out.println(d);
		
		long ans[] = new long[d];
		long t = generator(p);
		long n = 1;
		
		for (int i = 0; i < (p-1) / d; i++)
			n = (n * t) % p;
		
		t = n;
		
		
		for (int i = 0; i < ans.length; i++) {
			ans[i] = n;
			n = (n * t) % p;
		}
		Arrays.sort(ans);
		for (int i = 0; i < ans.length; i++) {
			out.print(ans[i] + " ");
		}
		out.println();
		
	}
}