//  "root"
// 8-  - 2008/2009 
//  :  , fedor.tsarev@gmail.com
//  :  , nosenkomax@gmail.com
//     - -  sqrt(p)*log(p)
//     - 3 2,   1 -    3

import java.util.*;
import java.io.*;
import java.math.BigInteger;

public class root_mn_wrong implements Runnable {

	public static void main(String args[]) {
		new Thread(new root_mn_wrong()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	private String FNAME = "root";
	boolean eof = false;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			br.close();
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}

	long gcd(long a, long b) {
		if (b == 0)
			return a;
		else
			return gcd(b, a % b);
	}

	long generator(long p) {
		for (int i = 1; i < p; i++) {
			if (good(i, p))
				return i;
		}
		My_Assert(false, "BOTVA");
		return -1;
	}

	long power(long a, long b, long p) {
		long res = 1;
		long t = a;

		while (b > 0) {
			if (b % 2 == 1)
				res = (res * t) % p;
			t = (t * t) % p;
			b = b / 2;
		}

		return res;
	}

	private boolean good(long n, long p) {
		for (int i = 0; i < div.length; i++)
			if (power(n, div[i], p) == 1)
				return false;
		return true;
	}

	long[] div;

	private void solve() {
		long p = nextLong(), k = nextLong();
		BigInteger a = BigInteger.valueOf(p);

		My_Assert(2 <= p && p <= 1000000000, "p is out of range: " + p);
		My_Assert(2 <= k && k <= p - 1, "k is out of range: " + k);
		My_Assert(a.isProbablePrime(100), "p is not prime: " + p);

		int d = (int) gcd(k, p - 1);
		out.println(d);

		ArrayList<Long> dd = new ArrayList<Long>();
		for (int i = 2; i * i <= p - 1; i++)
			if ((p - 1) % i == 0) {
				dd.add((long) i);
				if (i * i != p - 1)
					dd.add((p - 1) / i);
			}
		
		div = new long[dd.size()];
		for (int i = 0; i < div.length; i++) {
			div[i] = dd.get(i);
		}

		long ans[] = new long[d];
		long e = generator(p);
				
		long t = power(e, (p - 1) / d, p);
		
		long n = t;

		for (int i = 0; i < ans.length; i++) {
			ans[i] = n;
			n = (n * t) % p;
		}
		Arrays.sort(ans);
		for (int i = 0; i < ans.length; i++) {
			out.print(ans[i] + " ");
		}
		out.println();
		
	}
}