//  ""
// 8-  -  2007-2008
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;
import java.math.*;

public class root_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new root_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}
	
	private static final String FILENAME = "root";
	
	int pow(long a, int b, int p) {
		long ans = 1;
		while (b > 0) {
			if ((b & 1) == 1) {
				ans = (ans * a) % p;
			}
			a = (a * a) % p;
			b >>= 1;
		}
		return (int) ans;
	}
	
	public void solve() throws IOException {
		int p = nextInt();
		int k = nextInt();
		myAssert(2 <= p && p <= 1e9, "Wrong p");
		myAssert(2 <= k && k <= p - 1, "Wrong k");
		BigInteger P = BigInteger.valueOf(p);
		myAssert(P.isProbablePrime(20), "P is not prime");
		int gcd = BigInteger.valueOf(k).gcd(BigInteger.valueOf(p - 1)).intValue();
		myAssert(gcd <= 10000, "Too many solutions");
		if (p == 3) {
			out.println(2);
			out.println("1 2");
			return;
		}
		ArrayList<Integer> divs = new ArrayList<Integer>();
		for (int i = 2; i * i <= p - 1; i++) {
			if ((p - 1) % i == 0) {
				divs.add(i);
				if (i != (p - 1) / i) {
					divs.add((p - 1) / i);
				}
			}
		}
		int gen = -1;
		for (int i = 1; ; i++) {
			boolean good = true;
			for (int j : divs) {
				if (pow(i, j, p) == 1) {
					good = false;
					break;
				}
			}
			if (good) {
				gen = i;
				break;
			}
		}
		long[] ans = new long[gcd];
		ans[0] = pow(gen, (p - 1) / gcd, p);
		for (int i = 1; i < gcd; i++) {
			ans[i] = (ans[i - 1] * ans[0]) % p;
		}
		Arrays.sort(ans);
		for (int i = 1; i < ans.length; i++) {
			if (ans[i] == ans[i - 1]) {
				gcd--;
			}
		}
		out.println(gcd);
		for (int i = 0; i < ans.length; i++) {
			if (i == 0 || ans[i] != ans[i - 1]) {
				out.print(ans[i] + " ");
			}
		}
	}
}
