import java.io.*;
import java.util.*;

public class tree_as implements Runnable {
    String s;
    int p;

    char[][] f;

    class Tree {
        char op;
        Tree l;
        Tree r;
        int w;
        int h;
        int c;

        Tree(char op, Tree l, Tree r) {
            this.op = op;
            this.l = l;
            this.r = r;
        }

        void dfs() {
            if (op >= 'a' && op <= 'z') {
                w = 1;
                h = 1;
                c = 0;
                return;
            }

            l.dfs();
            r.dfs();
            w = l.w + r.w + 5;
            h = Math.max(l.h, r.h) + 2;
            c = l.w + 2;
        }

        void print(int dx, int dy) {
            if (op >= 'a' && op <= 'z') {
                f[dx][dy] = op;
                return;
            }
            l.print(dx + 2, dy);
            r.print(dx + 2, dy + l.w + 5);

            f[dx][l.c + dy] = '.';
            f[dx][l.w + 5 + r.c + dy] = '.';
            f[dx + 1][l.c + dy] = '|';
            f[dx + 1][l.w + 5 + r.c + dy] = '|';
            for (int i = l.c + dy + 1; i < l.w + 5 + r.c + dy; i++) {
                f[dx][i] = '-';
            }
            f[dx][dy + c - 1] = '[';
            f[dx][dy + c] = op;
            f[dx][dy + c + 1] = ']';
        }
    }

    Tree item() {
        if (s.charAt(p) == '(') {
            p++;
            Tree r = expr();
            assert s.charAt(p) == ')';
            p++;
            return r;
        } else {
            Tree r = new Tree(s.charAt(p), null, null);
            p++;
            return r;
        }
    }

    Tree factor() {
        Tree r = item();
        if (s.charAt(p) == '^') {
            p++;
            r = new Tree('^', r, factor());
        }
        return r;
    }

    Tree term() {
        Tree r = factor();
        while (s.charAt(p) == '*' || s.charAt(p) == '/') {
            char sc = s.charAt(p);
            p++;
            r = new Tree(sc, r, factor());
        }
        return r;
    }

    Tree expr() {
        Tree r = term();
        while (s.charAt(p) == '+' || s.charAt(p) == '-') {
            char sc = s.charAt(p);
            p++;
            r = new Tree(sc, r, term());
        }
        return r;
    }

    public void solve() throws IOException {
        BufferedReader in = new BufferedReader(new FileReader("tree.in"));
        PrintWriter out = new PrintWriter(new File("tree.out"));

        s = in.readLine() + "$";
        p = 0;
        Tree root = expr();

        root.dfs();
        f = new char[root.h][root.w];
        for (char[] z : f) {
            Arrays.fill(z, ' ');
        }
        root.print(0, 0);

        for (int i = 0; i < root.h; i++) {
            for (int j = 0; j < root.w; j++) {
                out.print(f[i][j]);
            }
            out.println();
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new tree_as()).start();
    }
}
