import java.io.*;
import java.util.ArrayList;

public class wikipidia_as implements Runnable {
    BufferedReader in;
    String str;
    int pos;

    char next() {
        while (str == null || pos >= str.length()) {
            try {
                str = in.readLine();
                if (str == null) {
                    return '$';
                }
                str = str + '\n';
            } catch (IOException e) {
            }
            pos = 0;
        }
        return str.charAt(pos++);
    }

    public void solve() throws IOException {
        in = new BufferedReader(new FileReader("wikipidia.in"));
        PrintWriter out = new PrintWriter(new File("wikipidia.out"));

        char c;
        ArrayList<Integer> l = new ArrayList<Integer>();
        ArrayList<String> tr = new ArrayList<String>();
        int ap = 0;
        boolean inAp = false;
        StringBuilder cur = new StringBuilder();
        while ((c = next()) != '$') {
            if (c == '\'') {
                if (!inAp) {
                    tr.add(cur.toString());
                    cur.setLength(0);
                }
                ap++;
                inAp = true;
            } else {
                if (inAp) {
                    l.add(ap);
                    ap = 0;
                }
                cur.append(c);
                inAp = false;
            }
        }
        if (inAp) {
            l.add(ap);
        }
        tr.add(cur.toString());

        int n = l.size();
        boolean[][] can = new boolean[n + 1][16];
        int[][] from = new int[n + 1][16];
        String[][] how = new String[n + 1][16];
        can[0][0] = true;
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 16; j++) {
                int m = l.get(i);
                if (can[i][j]) {
                    boolean[][] at = new boolean[m + 1][16];
                    int[][] frl = new int[m + 1][16];
                    at[0][j] = true;
                    for (int k = 0; k < m; k++) {
                        for (int p = 0; p < 16; p++) {
                            if (at[k][p]) {
                                if ((p & 1) == 0 && (k + 2 <= m)) {
                                    int q = (p ^ 3) & ~8;
                                    at[k + 2][q] = true;
                                    frl[k + 2][q] = p;
                                }
                                if ((p & 3) == 3 && (k + 2 <= m)) {
                                    int q = p ^ 3;
                                    if (q == 4) {
                                        q |= 8;
                                    }
                                    at[k + 2][q] = true;
                                    frl[k + 2][q] = p;
                                }
                                if ((p & 4) == 0 && (k + 3 <= m)) {
                                    int q = (p ^ 12) & ~2;
                                    at[k + 3][q] = true;
                                    frl[k + 3][q] = p;
                                }
                                if ((p & 12) == 12 && (k + 3 <= m)) {
                                    int q = p ^ 12;
                                    if (q == 1) {
                                        q |= 2;
                                    }
                                    at[k + 3][q] = true;
                                    frl[k + 3][q] = p;
                                }
                            }
                        }
                    }

                    for (int p = 0; p < 16; p++) {
                        if (at[m][p]) {
                            can[i + 1][p] = true;
                            from[i + 1][p] = j;

                            sb.setLength(0);
                            int w = m;
                            int q = p;
                            while (w != 0) {
                                if (((frl[w][q] ^ q) & 3) == 3 && (q & 1) == 1) {
                                    sb.append(">i<");
                                    q = frl[w][q];
                                    w -= 2;
                                } else if (((frl[w][q] ^ q) & 3) == 3 && (q & 1) == 0) {
                                    sb.append(">i/<");
                                    q = frl[w][q];
                                    w -= 2;
                                } else if (((frl[w][q] ^ q) & 12) == 12 && (q & 4) == 4) {
                                    sb.append(">b<");
                                    q = frl[w][q];
                                    w -= 3;
                                } else if (((frl[w][q] ^ q) & 12) == 12 && (q & 4) == 0) {
                                    sb.append(">b/<");
                                    q = frl[w][q];
                                    w -= 3;
                                } else {
                                    assert false;
                                }
                            }
                            how[i + 1][p] = sb.reverse().toString();
                        }
                    }
                }
            }
        }

        if (can[n][0]) {
            ArrayList<String> tags = new ArrayList<String>();
            int z = n;
            int p = 0;
            while (z > 0) {
//                System.out.println(p);
                tags.add(how[z][p]);
                p = from[z][p];
                z--;
            }

            for (int i = 0; i < n; i++) {
                out.print(tr.get(i));
                out.print(tags.get(n - i - 1));
            }
            out.print(tr.get(n));
        } else {
            out.println("!@#$%");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new wikipidia_as()).start();
    }
}


