// " "
//9-  -  2008-2009
// :  , tsarev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru
import java.io.*;
import java.util.*;
import java.math.*;

public class genetic_aa_fast implements Runnable {

	public static void main(String[] args) {
		new Thread(new genetic_aa_fast()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		myAssert(l <= x && x <= r, name + " = " + x + " is not in bounds [" + l
				+ ".." + r + "]");
	}

	String FNAME = "genetic_aa".substring(0, "genetic_aa".indexOf('_'));

	private void solve() throws IOException {
		int n = nextInt();
		inBounds(n, 1, 20, "N");
		int[] perm1 = new int[n];
		int[] perm2 = new int[n];
		for (int i = 0; i < perm1.length; i++) {
			perm1[i] = nextInt();
		}
		for (int i = 0; i < perm2.length; i++) {
			perm2[i] = nextInt();
		}
		int[] rev1 = new int[n];
		int[] rev2 = new int[n];
		for (int i = 0; i < perm1.length; i++) {
			rev1[perm1[i] - 1] = i;
		}
		for (int i = 0; i < perm2.length; i++) {
			rev2[perm2[i] - 1] = i;
		}
		Arrays.sort(perm1);
		Arrays.sort(perm2);
		for (int i = 0; i < perm1.length; i++) {
			inBounds(perm1[i], i + 1, i + 1, "perm1[" + i + "]");
			inBounds(perm2[i], i + 1, i + 1, "perm2[" + i + "]");
		}
		boolean[][] a = new boolean[n][n];
		for (int i = 0; i < a.length; i++) {
			for (int j = 0; j < a[i].length; j++) {
				if (rev1[i] > rev1[j] && rev2[i] > rev2[j]) {
					a[i][j] = true;
				}
			}
		}
		for (int k = 0; k < a.length; k++) {
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a.length; j++) {
					a[i][j] |= a[i][k] && a[k][j];
				}
			}
		}
		int[] c = new int[n];
		for (int i = 0; i < c.length; i++) {
			for (int j = 0; j < c.length; j++) {
				if (a[i][j]) {
					c[i] ^= 1 << j;
				}
			}
		}
		long[] b = new long[1 << n];
		b[0] = 1;
		for (int i = 1; i < b.length; i++) {
			for (int j = 0; j < n; j++) {
				if ((i & (1 << j)) != 0) {
					if ((c[j] & i) == 0) {
						b[i] += b[i ^ (1 << j)];
					}
				}
			}
		}
		out.println(b[b.length - 1]);
	}
}
