//  " "
// 9-  -  2008-2009
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru
//   2^n*n^2 

import java.io.*;
import java.util.*;

public class genetic_sp_n2 implements Runnable {

	public static void main(String[] args) {
		new Thread(new genetic_sp_n2()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "genetic";
	
	public void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 20, "Wrong n");
		int[] a = new int[n];
		int[] b = new int[n];
		boolean[][] ta = new boolean[n][n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt() - 1;
			for (int j = 0; j < i; j++) {
				ta[a[j]][a[i]] = true;
			}
		}
		
		Arrays.sort(a);
		for (int i = 0; i < n; i++) {
			myAssert(a[i] == i, "Not a permutation");
		}
		
		boolean[][] tab = new boolean[n][n];
		for (int i = 0; i < n; i++) {
			b[i] = nextInt() - 1;
			for (int j = 0; j < i; j++) {
				tab[b[j]][b[i]] = ta[b[j]][b[i]];
			}
		}
		
		Arrays.sort(b);
		for (int i = 0; i < n; i++) {
			myAssert(b[i] == i, "Not a permutation");
		}
		
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int k = 0; k < n; k++) {
					tab[j][k] |= tab[j][i] && tab[j][k];
				}
			}
		}
		
		long[] c = new long[1 << n];
		c[0] = 1;
		for (int i = 1; i < (1 << n); i++) {
			for (int j = 0; j < n; j++) {
				if ((i & (1 << j)) != 0) {
					boolean good = true;
					for (int k = 0; k < n; k++) {
						if (tab[j][k] && (i & (1 << k)) == 0) {
							good = false;
							break;
						}
					}
					if (good) {
						c[i] += c[i ^ (1 << j)];
					}
				}
			}
		}
		
		out.println(c[(1 << n) - 1]);
	}
}
