import java.io.*;
import java.math.*;
import java.util.*;

public class newseq_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new newseq_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("newseq.in"));
			out = new PrintWriter("newseq.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	final int MAX_N = (int)1e+9;
	final int MAX_K = 75000;
	
		
	void solve() throws IOException {
		int n = nextInt();
		myAssert(2 <= n && n <= MAX_N, "n out of bounds exception");
		int k = nextInt();
		myAssert(1 <= k && k <= MAX_K, "k out of bounds exception");
		
		TreeMap<Integer, BigInteger> ts = new TreeMap<Integer, BigInteger>();
		ts.put(n - 1, BigInteger.ONE);
		
		for (int i = 0; i <= k; ++i) {
			if (ts.lastKey() <= 3) {
				BigInteger d2 = ts.containsKey(2) ? ts.get(2) : BigInteger.ZERO;
				BigInteger d3 = ts.containsKey(3) ? ts.get(3) : BigInteger.ZERO;
				int st = k - i + 1;
				BigInteger p2 = BigInteger.valueOf(2).pow(st / 2);
				d2 = d2.multiply(p2);
				d3 = d3.multiply(p2);
				if (st % 2 == 1) {
					BigInteger t = d3;
					d3 = d2;
					d2 = t.multiply(BigInteger.valueOf(2));
				}
				ts.clear();
				ts.put(2, d2);
				ts.put(3, d3);
				break;
			}
			TreeMap<Integer, BigInteger> tts = new TreeMap<Integer, BigInteger>();
			for (Integer p : ts.keySet()) {
				BigInteger d = ts.get(p);
				tts.put(p + 1, d);
			}
			ts.clear();
			while (tts.size() > 0) {
				int p = tts.lastKey();
				BigInteger d = tts.get(p);
				tts.remove(p);
				for (int j = 2; j * j <= p; ++j) {
					int td = 0;
					while (p % j == 0) {
						++td;
						p /= j;
					}
					if (td > 0) {
						modify(ts, j, d.multiply(BigInteger.valueOf(td)));
					}
				}
				if (p > 1) {
					modify(ts, p, d);
				}	
			}
		}
		out.println(ts.size());
		for (int i : ts.keySet()) {
			out.println(i + " " + ts.get(i));
		}
	}
	
	void modify(TreeMap<Integer, BigInteger> tm, int x, BigInteger y) {
		if (tm.containsKey(x)) {
			y = y.add(tm.get(x));
			tm.remove(x);			
		}
		tm.put(x, y);
	}
}
