import java.io.*;
import java.math.*;
import java.util.*;

//Integer overflow

public class newseq_af_slow_bug1 implements Runnable {
	public static void main(String[] args) {
		new Thread(new newseq_af_slow_bug1()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("newseq.in"));
			out = new PrintWriter("newseq.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	final int MAX_N = (int)1e+9;
	final int MAX_K = 5000;
	
		
	void solve() throws IOException {
		int n = nextInt();
		myAssert(2 <= n && n <= MAX_N, "n out of bounds exception");
		int k = nextInt();
		myAssert(1 <= k && k <= MAX_K, "k out of bounds exception");
		
		TreeMap<Integer, Integer> ts = new TreeMap<Integer, Integer>();
		ts.put(n - 1, 1);
		
		for (int i = 0; i <= k; ++i) {
			TreeMap<Integer, Integer> tts = new TreeMap<Integer, Integer>();
			for (Integer p : ts.keySet()) {
				Integer d = ts.get(p);
				tts.put(p + 1, d);
			}
			ts.clear();
			while (tts.size() > 0) {
				int p = tts.lastKey();
				int d = tts.get(p);
				tts.remove(p);
				for (int j = 2; j * j <= p; ++j) {
					int td = 0;
					while (p % j == 0) {
						++td;
						p /= j;
					}
					if (td > 0) {
						modify(ts, j, d * td);
					}
				}
				if (p > 1) {
					modify(ts, p, d);
				}	
			}
		}
		out.println(ts.size());
		for (int i : ts.keySet()) {
			out.println(i + " " + ts.get(i));
		}
	}
	
	void modify(TreeMap<Integer, Integer> tm, int x, int y) {
		if (tm.containsKey(x)) {
			y = y + tm.get(x);
			tm.remove(x);			
		}
		tm.put(x, y);
	}
}
