import java.io.*;
import java.math.BigInteger;
import java.util.*;


public class newseq_at implements Runnable {
	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;
	
	TreeMap<Integer, Integer> list = new TreeMap<Integer, Integer>();
	int c2 = 0;
	int c3 = 0;
	
	private boolean iterate() {
		boolean result = false;
		TreeMap<Integer, Integer> tmpList = list;
		list = new TreeMap<Integer, Integer>();
		int oc2 = c2;
		int oc3 = c3;
		c2 = 2 * oc3;
		c3 = oc2;
		for(int d : tmpList.keySet()) {
			if (d != 2 && d != 3) {
				result = true;
			}
			int old = d;
			d = d + 1;
			while(d % 2 == 0) {
				d = d / 2;
				c2 = c2 + tmpList.get(old);
			}
			while(d % 3 == 0) {
				d = d / 3;
				c3 = c3 + tmpList.get(old);
			}
			old = d;
			int count = 0;
			for(int i = 5; i * i <= old; ++i) {
				count = 0;
				while (d % i == 0) {
					++count;
					d = d / i;
				}
				if (count != 0) {
					list.put(i, count);
				}
			}
			if (d != 1) {
				list.put(d, 1);
			}
		}
		return result;
	}
	
	public void factorize(int d) {
		int old = d;
		int count = 0;
		for(int i = 2; i * i <= old; ++i) {
			count = 0;
			while (d % i == 0) {
				++count;
				d = d / i;
			}
			if (count != 0) {
				list.put(i, count);
			}
		}
		if (d != 1) {
			list.put(d, 1);
		}
	}
	
	public void solve() throws Exception {
		int n = nextInt(); factorize(n);
		int k = nextInt();
		int step = 1;
		while(step < k && iterate()) {
			++step;
		}
		if (step != k) {
			k = k - step;
			int pow = k / 2;
			BigInteger p2 = BigInteger.valueOf(2).pow(pow).multiply(BigInteger.valueOf(c2));
			BigInteger p3 = BigInteger.valueOf(2).pow(pow).multiply(BigInteger.valueOf(c3));
			if (k % 2 == 1) {
				BigInteger op2 = p2;
				BigInteger op3 = p3;
				p2 = op3.add(op3);
				p3 = op2;
			}
			out.println(2);
			out.println("2 " + p2);
			out.println("3 " + p3);
		}
		else {
			out.println( (c2 == 0 ? 0 : 1) + (c3 == 0 ? 0 : 1) + (list.size()));
			if (c2 != 0) {
				out.println("2 " + c2 + " ");
			}
			if (c3 != 0) {
				out.println("3 " + c3 + " ");
			}
			for(int i : list.keySet()) {
				out.println(i + " " + list.get(i) + " ");
			}
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(89);
		} finally {
			out.close();
		}
	}

	private newseq_at(String name) {
		try {
			in = new BufferedReader(new FileReader(name + ".in"));
//			in = new BufferedReader(new FileReader("input.txt"));
//			in = new BufferedReader(new InputStreamReader(System.in));
			st = new StringTokenizer("");
			out = new PrintWriter(new File(name + ".out"));
//			out = new PrintWriter(new File("output.txt"));
//			out = new PrintWriter(System.out);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(89);
		}
	}

	public static void main(String[] args) {
		(new Thread(new newseq_at("newseq"))).start();
	}

	private String nextToken() throws Exception {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}
}