//  ""
// 9-  -  2008-2009
//  : 
//  :  , melnikov@rain.ifmo.ru

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;
import java.math.*;

public class newseq_sm_slow_decomp extends Thread {
                           
	Map<Integer, BigInteger> decomp(int a){
		int i = 2;
		Map<Integer, BigInteger> res = new TreeMap<Integer, BigInteger>();
		while (a > 1){
			int k = 0;
			while (a % i == 0){
				a /= i;
				k++;
			}
			if (k != 0){
				res.put(i, BigInteger.valueOf(k));
			}
			i++;
		}
		return res;				
	}

	void inc(Map<Integer, BigInteger> a, Map<Integer, BigInteger> b){
		for (Map.Entry<Integer, BigInteger> e: b.entrySet()){
			if (a.containsKey(e.getKey())){
				a.put(e.getKey(), a.get(e.getKey()).add(e.getValue()));
			}else{
				a.put(e.getKey(), e.getValue());
			}
		}
		
	}

	Map<Integer, BigInteger> next(Map<Integer, BigInteger> a){
		Map<Integer, BigInteger> res = new TreeMap<Integer, BigInteger>();
		for (Map.Entry<Integer, BigInteger> e: a.entrySet()) {
			inc(res, mul(decomp(e.getKey() + 1),e.getValue()));
		}
		return res;
	}

	Map<Integer, BigInteger> mul(Map<Integer, BigInteger> a, BigInteger k){
		Map<Integer, BigInteger> res = new TreeMap<Integer, BigInteger>();
		for (Map.Entry<Integer, BigInteger> e: a.entrySet()) {
			res.put(e.getKey(), e.getValue().multiply(k));			
		}
		return res;
	}

	void solve() throws IOException {
		int n = in.nextInt();
		myAssert(2 <= n && n <= 1e9);
		int k = in.nextInt();                                        
		myAssert(1 <= k && k <= 75000);
		Map<Integer, BigInteger> tm = decomp(n);
		for (int i = 0; i < k; i++){
			tm = next(tm);
		}
		tout(tm);

	}

	void tout(Map<Integer, BigInteger> tm) { 
		out.println(tm.size());
		for (Map.Entry<Integer, BigInteger> e: tm.entrySet()) {
			out.println(e.getKey() + " " + e.getValue());
		}
		out.println();

	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	Scanner in;
	PrintWriter out;

	public void run() {
		try {
			in = new Scanner(new File("newseq.in"));
			out = new PrintWriter(new BufferedWriter(new FileWriter(
					"newseq.out")));
			solve();
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new newseq_sm_slow_decomp().start();
	}

}
