import java.io.*;
import java.util.*;

//Problem "Bracket Sequences"
//11th Personal Internel Olympiad, season 2007-2008
//Problem Author: Vladimir Ulyantsev
//Solution Author: Maxim Buzdalov, buzdalov@rain.ifmo.ru

public class brackets_mb {
    static char matching(char arg) {
	switch (arg) {
	    case '(': return ')';
	    case '[': return ']';
	    default: return '*';
	}
    }
    public static void main(String[] args) throws IOException {
	Scanner in = new Scanner(new File("brackets.in"));
	int n = in.nextInt();
	String order = in.next();
	String start = in.hasNext() ? in.next() : "";
	in.close();
	
	assert 1 <= n && n <= 100000 : "N is out of bounds";
	assert order.length() == 4 : "Order string is illegal (length != 4)";
	assert 
	    order.indexOf('[') >= 0 && 
	    order.indexOf(']') >= 0 && 
	    order.indexOf('(') >= 0 && 
	    order.indexOf(')') >= 0 
	: "Order string is illegal (wrong symbols)";
	
	assert start.length() <= n : "String prefix is too long";
	
	char[] stack = new char[n];
	int stackp = 0;
	for (int i = 0; i < start.length(); ++i) {
	    if (matching(start.charAt(i)) != '*') {
		stack[stackp++] = start.charAt(i);
	    } else {
		assert stackp > 0 && matching(stack[stackp - 1]) == start.charAt(i) : "Prefix is illegal";
		--stackp;
	    }
	}
	StringBuilder ans = new StringBuilder(start);
	while (ans.length() < n) {
	    boolean done = false;
	    for (int i = 0; i < 4; ++i) {
		if (stackp > 0 && matching(stack[stackp - 1]) == order.charAt(i)) {
		    ans.append(order.charAt(i));
		    --stackp;
		    done = true;
		    break;
		}
		//It is also possible to test "n - ans.length() - 1 >= stackp", 
		//because "n - ans.length()" has the same remainder modulo 2 as "stackp"
		if (n - ans.length() - 1 >= stackp + 1 && matching(order.charAt(i)) != '*') {
		    ans.append(order.charAt(i));
		    stack[stackp++] = order.charAt(i);
		    done = true;
		    break;
		}
	    }
	    assert done : "Impossible";
	}
	
	PrintWriter out = new PrintWriter("brackets.out");
	out.println(ans);
	out.close();
    }
}
