import java.util.*;
import java.io.*;

public class transform_as implements Runnable {

    class Pos {
        int v;
        int action;

        Pos(int v, int action) {
            this.v = v;
            this.action = action;
        }
    }

    class Transformation {
        int from;
        int to;
        int hm;

        Transformation(int from, int to, int hm) {
            this.from = from;
            this.to = to;
            this.hm = hm;
        }

        @Override
        public String toString() {
            return from + " " + to + " " + hm;
        }
    }

    void relax(Map<Integer, Pos> map, int key, int value, int action) {
        if (!map.containsKey(key) || map.get(key).v > value) {
            map.put(key, new Pos(value, action));
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("transform.in"));
        PrintWriter out = new PrintWriter("transform.out");

        String s = in.next();
        String t = in.next();

        int n = s.length();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = "ACGT".indexOf(s.charAt(i));
        }
        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            b[i] = "ACGT".indexOf(t.charAt(i));
        }

        int[] np = new int[]{1, (n + 1), (n + 1) * (n + 1)};

        Map<Integer, Pos>[] c = new Map[n + 1];
        c[0] = new HashMap<Integer, Pos>();
        c[0].put(0, new Pos(0, 0));
        for (int i = 0; i < n; i++) {
            c[i + 1] = new HashMap<Integer, Pos>();
            for (Map.Entry<Integer, Pos> e : c[i].entrySet()) {
                int z = e.getKey();
                int v = e.getValue().v;
//                System.out.println(i + " " + z + " " + v);
                int[] o = new int[3];
                o[0] = z % (n + 1);
                o[1] = z / (n + 1) % (n + 1);
                o[2] = z / (n + 1) / (n + 1);
                for (int j = 0; j < 4; j++) {
                    int nz = z;
                    int ac = 0;
                    int d = o[0] + 2 * o[1] + 3 * o[2];
                    if (j != 3) {
                        if (o[j] == 0) {
                            continue;
                        }
                        d -= (j + 1);
                        nz -= np[j];
                        ac |= 1 << (j + 3);
                    }

                    int need = ((b[i] - (a[i] + d)) % 4 + 4) % 4;

                    if (need != 0) {
                        nz += np[need - 1];
                        ac |= 1 << (need - 1);
                    }
                    relax(c[i + 1], nz, v + (need == 0 ? 0 : 1), ac);
                }
            }
        }

        int best = Integer.MAX_VALUE;
        int bestz = 0;
        for (Map.Entry<Integer, Pos> e : c[n].entrySet()) {
            int z = e.getKey();
            int v = e.getValue().v;
//            System.out.println(n + " " + z + " " + v);
            if (v < best) {
                best = e.getValue().v;
                bestz = z;
            }
        }

        Set<Transformation> trans = new HashSet<Transformation>();
        ArrayList<Integer> ends[] = new ArrayList[3];
        int cz = bestz;
        for (int i = 0; i < 3; i++) {
            ends[i] = new ArrayList<Integer>();
        }

        int[] o = new int[3];
        o[0] = cz % (n + 1);
        o[1] = cz / (n + 1) % (n + 1);
        o[2] = cz / (n + 1) / (n + 1);

        for (int j = 0; j < 3; j++) {
            for (int k = 0; k < o[j]; k++) {
                ends[j].add(n);
            }
        }

        for (int i = n; i > 0; i--) {
            Pos p = c[i].get(cz);
            for (int j = 0; j < 3; j++) {
                if ((p.action & (1 << j)) != 0) {
                    int end = ends[j].get(ends[j].size() - 1);
                    ends[j].remove(ends[j].size() - 1);
                    trans.add(new Transformation(i, end, j + 1));
                    cz -= np[j];
                }

                if ((p.action & (1 << (j + 3))) != 0) {
                    ends[j].add(i - 1);
                    cz += np[j];
                }
            }
        }

        assert cz == 0;

        out.println(best);
        for (Transformation tr : trans) {
            out.println(tr);
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new transform_as()).start();
    }
}