//  ""
// 11-  -  2007-2008, 
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class words_ft implements Runnable {

	public final static int MODULO = (int) 1e9 + 7;

	private Scanner in;
	private PrintWriter out;
	String fname = "words";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}

	long pow(long x, long a) {
		if (a == 0) {
			return 1;
		}
		if (a == 1) {
			return x;
		}
		long b = pow(x, a / 2);
		b = (b * b) % MODULO;
		if (a % 2 == 1) {
			b *= x;
			b %= MODULO;
		}
		return b;
	}

	public void solve() {
		int n = in.nextInt();
		int k = in.nextInt();
		myAssert(1 <= n && n <= (int) 1e9, "n is out of range: " + n);
		myAssert(1 <= k && k <= (int) 1e9, "k is out of range: " + k);
		long a1 = pow(k, n);
		long a2 = pow(k, (n + 1) / 2);
		long inv2 = (int) 5e8 + 4;
		out.println(((a1 + a2) * inv2) % MODULO);
	}                                        

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public words_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new words_ft()).start();
	}

}                       