#include <iostream>
#include <fstream>
#include <cassert>

//Problem "Words"
//11th Personal Internet Olympiad, season 2007-2008
//Problem Author: Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Maxim Buzdalov, buzdalov@rain.ifmo.ru

typedef long long int64;

int main()
{
    int n, k;
    std::ifstream("words.in") >> n >> k;
    assert(1 <= n && n <= 1000000000);
    assert(1 <= k && k <= 1000000000);
    
    int64 mod = 1000000007;
    int64 pow = k;
    int64 pown = 1, powh = 1;
    for (unsigned i = 0; i < 32; ++i)
    {
	if ((1 << i) & n) 
	{ 
	    (pown *= pow) %= mod; 
	}
	if ((1 << i) & ((n + 1) / 2)) 
	{ 
	    (powh *= pow) %= mod; 
	}
	(pow *= pow) %= mod;
    }

    std::ofstream("words.out") << ((pown + powh) * (mod + 1) / 2) % mod << std::endl;
    return 0;
}
