import java.io.*;
import java.util.*;

public class palin_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new palin_af()).start();
	}
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(-1);
		}
		out.close();
	}
	
	String FNAME = "palin";
	
	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;
	
	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}
	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	int[] genPerm(int n, int k) {
		int[] ans = new int[n];
		if (k == 0) {
			for (int i = 0; i < n; i++) {
				ans[i] = i;
			}
		} else {
			int[] tans = genPerm((n + 1) / 2, k - 1);
			for (int i = 0; i < tans.length; i++) {
				ans[i] = tans[i];
				ans[n - i - 1]  = tans[i];
			}
		}
		return ans;
	}
	
	void myAssert(boolean e, String msg) {
		if (!e) throw new Error(msg);
	}
	
	void solve() throws IOException {
		int k = nextInt();
		myAssert(0 <= k && k <= 20, "k is out of bounds!");
		String s = nextToken();
		int n = s.length();
		myAssert(1 <= n && n <= 100000, "String length is out of bounds!");
		for (int i = 0; i < n; i++) {
			myAssert('a' <= s.charAt(i) && s.charAt(i) <= 'z', "Symobol number " + (i + 1) + " is incorrect!");
		}
		int l = (n + (1 << k) - 1) >> k;
		if ((n + (1 << (k - 1)) - 1) >> (k - 1) <= 1) {
			out.println(-1);
			return;
		}
		int[] p = genPerm(n , k);
		int[][] c = new int[l][26];
		for (int i = 0; i < n; i++) {
			c[p[i]][s.charAt(i) - 'a']++;
		}
		
		int[][] best = new int[l][2];
		for (int i = 0; i < l; i++) {
			Arrays.fill(best[i], -1);
			for (int j = 0; j < 26; j++) {
				if (best[i][0] == -1 || c[i][best[i][0]] < c[i][j]) {
					best[i][1] = best[i][0];
					best[i][0] = j;
				} else {
					if (best[i][1] == -1 || c[i][best[i][1]] < c[i][j]) {
						best[i][1] = j;
					}
				}
			}
		}
		boolean bad = l != 1;
		int ans = n;
		int md = Integer.MAX_VALUE;
		int mi = 0;
		for (int i = 0; i < l; i++) {
			bad &= best[i][0] == best[l - i - 1][0];
			if (md > c[i][best[i][0]] - c[i][best[i][1]]) {
				mi = i;
				md = c[i][best[i][0]] - c[i][best[i][1]];
			}
			ans -= c[i][best[i][0]]; 
		}
		if (bad) {
			ans += c[mi][best[mi][0]] - c[mi][best[mi][1]];
		}
		out.println(ans);
	}
}
