//  ""
// 12-  -  2007-2008
//  :  , feskov@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class palin_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new palin_sp()).run();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "palin";
	
	ArrayList<Integer>[] g;
	boolean[] u;
	int[][] count;
	char[] s;
	int[] c;
	int[] min;
	
	void dfs(int i, int t) {
		u[i] = true;
		count[t][s[i] - 'a']++;
		c[i] = t;
		if (i < min[t]) {
			min[t] = i;
		}
		for (int j : g[i]) {
			if (!u[j]) {
				dfs(j, t);
			}
		}
	}

	public void solve() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		int k = nextInt();
		s = nextToken().toCharArray();
		int n = s.length;
		if (k == 0) {
			boolean palin = true;
			for (int i = 0; i < n; i++) {
				palin &= s[i] == s[n - i - 1];
			}
			if (!palin) {
				out.println(0);
			} else {
				if (s.length == 1) {
					out.println(0);
				} else {
					out.println(1);
				}
			}
			out.close();
			return;
		}
		g = new ArrayList[n];
		u = new boolean[n];
		c = new int[n];
		min = new int[n];
		Arrays.fill(min, Integer.MAX_VALUE);
		for (int i = 0; i < n; i++) {
			g[i] = new ArrayList<Integer>();
		}
		count = new int[n][26];
		int m = n;
		int om = n;
		for (int i = 0; i < k; i++) {
			if (m == 1) {
				out.println(-1);
				out.close();
				return;
			}
			for (int j = 0; j < m / 2; j++) {
				g[j].add(m - j - 1);
				g[m - j - 1].add(j);
			}
			om = m;
			m = (m + 1) / 2;
		}
		int nc = 0;
		for (int i = 0; i < n; i++) {
			if (!u[i]) {
				dfs(i, nc++);
			}
		}
		int[] max1 = new int[n]; 
		int[] max2 = new int[n];
		for (int i = 0; i < nc; i++) {
			for (int j = 1; j < 26; j++) {
				if (count[i][j] > max2[i]) {
					if (count[i][j] > count[i][max1[i]]) {
						max2[i] = count[i][max1[i]];
						max1[i] = j;
					} else {
						max2[i] = count[i][j];
					}
				}
			}
		}
		Arrays.fill(u, false);
		int ans = n;
		for (int i = 0; i < nc; i++) {
			ans -= count[i][max1[i]];
		}
		int minc = Integer.MAX_VALUE;
		for (int i = 0; i < nc; i++) {
			if (u[i]) continue;
			int j = m - min[i] - 1;
			u[i] = true;
			u[j] = true;
			if (i == j) {
				continue;
			}
			if (max1[i] != max1[j]) {
				minc = 0;
				continue;
			}
			if (max1[i] == max1[j]) {
				minc = Math.min(minc, count[i][max1[i]] - max2[i]);
				minc = Math.min(minc, count[j][max1[j]] - max2[j]);
			}
		}
		out.println(ans + minc);
		out.close();
	}
}
