import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.StringTokenizer;


public class permutominoes_pm implements Runnable {
	public static void main(String[] args) {
		new Thread(new permutominoes_pm()).start();
	}

	@Override
	public void run() {
		try {
			readInput();
			solve();
			writeOutput();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	final static String TASK_ID = "permutominoes";
	
	int n;
	BigInteger res;

	private void writeOutput() throws FileNotFoundException {
		PrintWriter writer = new PrintWriter(TASK_ID + ".out");
		writer.println(res);
		writer.close();
	}

	private void solve() {
		if (n == 2) {
			res = BigInteger.ONE;
			return;
		}
		BigInteger[] nCorner = new BigInteger[n + 1];
		BigInteger[] nMiddle = new BigInteger[n + 1];
		BigInteger[][] c = new BigInteger[n + 1][n + 1];
		c[0][0] = BigInteger.ONE;
		for (int i = 1; i <= n; ++i)
			c[0][i] = BigInteger.ZERO;
		for (int i = 1; i <= n; ++i) {
			c[i][0] = BigInteger.ONE;
			for (int j = 1; j <= n; ++j)
				c[i][j] = c[i - 1][j - 1].add(c[i - 1][j]);
		}
		BigInteger[][] nSeq = new BigInteger[n + 1][n + 1];
		for (int i = 2; i <= n; ++i)
			for (int j = 0; j <= i - 2; ++j)
				nSeq[i][j] = c[i - 2][j];
		for (int i = 2; i <= n; ++i) {
			BigInteger sum = BigInteger.ZERO;
			for (int j = 0; j <= i - 2; ++j) {
				sum = sum.add(nSeq[i][j].multiply(nSeq[i][j]));
				if (j > 0)
					sum = sum.add(nSeq[i][j].multiply(nSeq[i][j - 1]));
			}
			nMiddle[i] = sum;
		}
		nMiddle[1] = BigInteger.ONE;
		nCorner[1] = BigInteger.ONE;
		for (int i = 2; i <= n; ++i) {
			BigInteger left = BigInteger.ONE.shiftLeft(2 * i - 4);
			for (int j = 2; j < i; ++j)
				left = left.subtract(nCorner[j].multiply(nMiddle[i - j + 1]));
			nCorner[i] = left;
		}
		res = BigInteger.ONE.shiftLeft(2 * n - 5).multiply(BigInteger.valueOf(n));
		for (int a = 2; a <= n - 1; ++a)
			for (int b = 2; b <= n - a + 1; ++b) {
				int t = n - a - b + 2;
				res = res.subtract(nCorner[a].multiply(nCorner[b]).multiply(nMiddle[t]).multiply(BigInteger.valueOf(2)));
			}

		res = res.mod(BigInteger.valueOf(1000000007));
	}

	private void readInput() throws IOException {
		reader = new BufferedReader(new FileReader(TASK_ID + ".in"));
		tokenizer = null;
		
		n = nextInt();
	}

	BufferedReader reader;
	StringTokenizer tokenizer;
	
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	String next() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}
}
