import java.io.*;
import java.util.*;
import java.math.*;

public class resistor_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new resistor_aa()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String nextToken(String delim) {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), delim);
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken(delim);
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	int nextInt(String delim) {
		return Integer.parseInt(nextToken(delim));
	}

	String FILENAME = "resistor";

	double[][] r;

	void solve() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		int n = nextInt();
		int m = nextInt();
		int k = nextInt();
		int l = nextInt();
		check(n, 2, 1000, "N");
		check(m, n - 1, 100000, "M");
		check(k, 1, n - 1, "K");
		check(l--, 1, n, "L");
		boolean[] good = new boolean[n];
		for (int i = 0; i < k; i++) {
			int x = nextInt();
			check(x--, 1, n, "Vertex number");
			MyAssert(!good[x], "Vertex " + (x + 1) + " appeared twice!!!");
			good[x] = true;
		}
		r = new double[n][n];
		for (int i = 0; i < r.length; i++) {
			Arrays.fill(r[i], Double.POSITIVE_INFINITY);
		}
		for (int i = 0; i < m; i++) {
			int x = nextInt() - 1;
			check(x, 0, n - 1, "Vertex number");
			int y = nextInt() - 1;
			check(y, 0, n - 1, "Vertex number");
			int z = nextInt();
			check(z, 0, 100000, "Resistance");
			if (r[x][y] == Double.POSITIVE_INFINITY) {
				r[x][y] = z;
			} else {
				r[x][y] = (r[x][y] * z) / (r[x][y] + z);
			}
			if (r[y][x] == Double.POSITIVE_INFINITY) {
				r[y][x] = z;
			} else {
				r[y][x] = (r[y][x] * z) / (r[y][x] + z);
			}
		}
		resistance = new double[n];
		resistance[l] = 0;
		u = new boolean[n];
		DFS(l);
		for (int i = 0; i < good.length; i++) {
			if (good[i]) {
				out.println((i + 1) + " " + resistance[i]);
			}
		}
		out.close();
	}

	double[] resistance;

	boolean[] u;

	private void DFS(int x) {
		u[x] = true;
		for (int i = 0; i < r[x].length; i++) {
			if (r[x][i] < Double.POSITIVE_INFINITY && !u[i]) {
				resistance[i] = resistance[x] + r[x][i];
				DFS(i);
			}
		}
	}

	private void check(int n, int i, int j, String s) {
		MyAssert(i <= n && n <= j, s + " is not in bounds!!! " + n);
	}
}
