import java.io.*;
import java.util.*;
import java.math.*;

public class resistor_aa_hash implements Runnable {

	public static void main(String[] args) {
		new Thread(new resistor_aa_hash()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String nextToken(String delim) {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), delim);
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken(delim);
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	int nextInt(String delim) {
		return Integer.parseInt(nextToken(delim));
	}

	String FILENAME = "resistor";

	HashMap<Integer, Double>[] g;

	void solve() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		int n = nextInt();
		int m = nextInt();
		int k = nextInt();
		int l = nextInt() - 1;
		boolean[] good = new boolean[n];
		for (int i = 0; i < k; i++) {
			good[nextInt() - 1] = true;
		}
		g = new HashMap[n];
		for (int i = 0; i < g.length; i++) {
			g[i] = new HashMap<Integer, Double>();
		}
		for (int i = 0; i < m; i++) {
			int x = nextInt() - 1;
			int y = nextInt() - 1;
			double r = nextDouble();
			if (g[x].containsKey(y)) {
				double r1 = g[x].get(y);
				g[x].remove(x);
				g[y].remove(x);
				r = r * r1 / (r + r1);
				g[x].put(y, r);
				g[y].put(x, r);
			} else {
				g[x].put(y, r);
				g[y].put(x, r);
			}
		}
		u = new boolean[n];
		r = new double[n];
		DFS(l);
		for (int i = 0; i < good.length; i++) {
			if (good[i]) {
				out.println((i + 1) + " " + r[i]);
			}
		}
		out.close();
	}

	private void DFS(int x) {
		u[x] = true;
		Integer[] e = g[x].keySet().toArray(new Integer[g[x].keySet().size()]);
		for (int i = 0; i < e.length; i++) {
			if (!u[e[i]]) {
				r[e[i]] = r[x] + g[x].get(e[i]);
				DFS(e[i]);
			}
		}
	}

	boolean[] u;

	double[] r;

	private double nextDouble() {
		return Double.parseDouble(nextToken());
	}
}
