import java.io.*;
import java.util.*;
import java.math.*;

public class resistor_aa_no_par implements Runnable {

	public static void main(String[] args) {
		new Thread(new resistor_aa_no_par()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String nextToken(String delim) {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), delim);
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken(delim);
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	int nextInt(String delim) {
		return Integer.parseInt(nextToken(delim));
	}

	String FILENAME = "resistor";

	class Edge {
		public Edge(int y2, int r2) {
			y = y2;
			r = r2;
		}

		long r;

		int y;

	}

	ArrayList<Edge>[] g;

	void solve() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		int n = nextInt();
		int m = nextInt();
		int k = nextInt();
		int l = nextInt() - 1;
		g = new ArrayList[n];
		for (int i = 0; i < g.length; i++) {
			g[i] = new ArrayList<Edge>();
		}
		boolean[] good = new boolean[n];
		for (int i = 0; i < k; i++) {
			good[nextInt() - 1] = true;
		}
		for (int i = 0; i < m; i++) {
			int x = nextInt() - 1;
			int y = nextInt() - 1;
			int r = nextInt();
			g[x].add(new Edge(y, r));
			g[y].add(new Edge(x, r));
		}
		u = new boolean[n];
		resistance = new long[n];
		resistance[l] = 0;
		DFS(l);
		for (int i = 0; i < good.length; i++) {
			if (good[i]) {
				out.println((i + 1) + " " + resistance[i]);
			}
		}
		out.close();
	}

	long[] resistance;

	private void DFS(int x) {
		u[x] = true;
		for (Edge e : g[x]) {
			if (!u[e.y]) {
				resistance[e.y] = resistance[x] + e.r;
				DFS(e.y);
			}
		}
	}

	boolean[] u;
}
