import java.io.*;
import java.util.*;

public class electricity_as implements Runnable {

    int[][] cut(int[][] a, int[] c, int m, int v) {
        int n = a.length;
        int[][] r = new int[m][m];

        int i1 = 0;
        for (int i = 0; i < n; i++) {
            if (c[i] == v) {
                int j1 = 0;
                for (int j = 0; j < n; j++) {
                    if (c[j] == v) {
                        r[i1][j1] = a[i][j];
                        j1++;
                    }
                }
                i1++;
            }
        }
        return r;
    }

    Set<Integer> decycle(int[][] a) {
        int n = a.length;
        if (n == 0) {
            return new HashSet<Integer>();
        }
        int[] f = new int[n];
        int[] g = new int[n];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < n; k++) {
                    if (i != j && j != k && i != k) {
                        assert (a[i][j] <= 0 || a[j][k] <= 0 || a[k][i] <= 0);

                        if (a[i][j] > 0 && a[j][k] > 0 && a[i][k] <= 0) {
                            f[i]++;
                            g[j]++;
                        }
                    }
                }
            }
        }

        int v = -1;
        for (int i = 0; i < n; i++) {
            if (f[i] <= g[i]) {
                v = i;
                break;
            }
        }

        int n1 = 0;
        int n2 = 0;
        int[] c = new int[n];
        for (int i = 0; i < n; i++) {
            if (i == v) {
                continue;
            }
            if (a[v][i] > 0) {
                n1++;
                c[i] = 1;
            } else {
                n2++;
                c[i] = 2;
            }
        }

        int[][] a1 = cut(a, c, n1, 1);
        int[][] a2 = cut(a, c, n2, 2);

        Set<Integer> del = decycle(a1);
        del.addAll(decycle(a2));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (c[i] == 1 && c[j] == 2 && a[i][j] > 0) {
                    del.add(a[i][j]);
                }
            }
        }
        return del;
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("electricity.in"));
        PrintWriter out = new PrintWriter(new File("electricity.out"));

        int n = in.nextInt();
        int m = in.nextInt();

        int[][] a = new int[n][n];
        for (int i = 0; i < m; i++) {
            int j = in.nextInt() - 1;
            int k = in.nextInt() - 1;
            a[j][k] = i + 1;
        }

        Set<Integer> del = decycle(a);

        out.println(del.size());
        for (int x : del) {
            out.print(x + " ");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new electricity_as()).start();
    }
}
