import java.io.*;
import java.util.*;
import java.math.*;

public class crosses_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new crosses_aa()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String nextToken(String delim) {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), delim);
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken(delim);
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	int nextInt(String delim) {
		return Integer.parseInt(nextToken(delim));
	}

	String FILENAME = "crosses";

	void solve() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		while (true) {
			int n = nextInt();
			if (eof) {
				break;
			}
			MyAssert(2 <= n && n <= 1000, "n is not in bounds!!!");

			int[] a = new int[n + 1];
			a[0] = 0;
			a[1] = 1;
			a[2] = 1;
			boolean[] u = new boolean[n];
			for (int i = 1; i < a.length; i++) {
				Arrays.fill(u, false);
				for (int j = 1; j <= i; j++) {
					int k1 = Math.max(0, j - 2);
					int k2 = Math.max(0, i - j - 1);
					int xor = a[k1] ^ a[k2];
					u[xor] = true;
				}
				int j = 0;
				while (u[j]) {
					j++;
				}
				a[i] = j;
			}
			out.println(a[n] == 0 ? "First player loses" : "First player wins");
		}
		out.close();
	}
}
