//  " "
// 11- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class hamming_ft implements Runnable {

	public final static long MAXX = (long) 1e18;
	public final static int TWO = 2;
	public final static int THREE = 3;
	public final static int FIVE = 5;

	private Scanner in;
	private PrintWriter out;
	String fname = "hamming";

	ArrayList<Long> list;
	HashMap<Long, Integer> num2pos;

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}

    void go(long x, int what) {
		if (x <= MAXX) {
			list.add(x);
		} else {
			return;
		}
		if (what == TWO) {
			go(2 * x, TWO);
			go(3 * x, THREE);
			go(5 * x, FIVE);
		}
		if (what == THREE) {
			go(3 * x, THREE);
			go(5 * x, FIVE);
		}
		if (what == FIVE) {
			go(5 * x, FIVE);
		}
	}

	void prepare() {
		list = new ArrayList<Long>();
		go(1, TWO);
		Collections.sort(list);
		num2pos = new HashMap<Long, Integer>();
		for (int i = 0; i < list.size(); i++) {
			num2pos.put(list.get(i), i + 1);
		}
	}

	String getNum(long x) {
		Integer res = num2pos.get(x);
		if (res == null) {
			return "Not in sequence";
		} else {
			return "" + res;
		}
	}

	public void solve() {
		int t = in.nextInt();
		myAssert(t >= 1, "t < 1");
		myAssert(t <= (int) 1e5, "t > 1e5");
		for (int i = 0; i < t; i++) {
			long x = in.nextLong();
			myAssert(x >= 1, "x < 1");
			myAssert(x <= (long) 1e18, "x > 1e18");
			out.println(getNum(x));
		}
	}

	public void run() {
		try {
			prepare();
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public hamming_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		new Thread(new hamming_ft()).start();
	}

}