import java.io.*;
import java.util.*;
import java.math.*;

public class fermat_af implements Runnable {
  public static void main(String[] args) {
    new Thread(new fermat_af()).start();
  }

  public void run() {
    try {
      Locale.setDefault(Locale.US);
      br = new BufferedReader(new FileReader("fermat.in"));
      out = new PrintWriter("fermat.out");
      solve();
      out.close();
    } catch (Throwable e) {
      e.printStackTrace();
      System.exit(-1);
    }
  }

  BufferedReader br;
  StringTokenizer st;
  PrintWriter out;
  boolean eof;

  String nextToken() {
    while (st == null || !st.hasMoreElements()) {
      try {
        st = new StringTokenizer(br.readLine());
      } catch (Exception e) {
        eof = true;
        return "0";
      }
    }
    return st.nextToken();
  }

  int nextInt() {
    return Integer.parseInt(nextToken());
  }

  long nextLong() {
    return Long.parseLong(nextToken());
  }

  double nextDouble() {
    return Double.parseDouble(nextToken());
  }

  void myAssert(boolean e, String msg) {
    if (!e) throw new Error(msg);
  }
  
  void checkSum(double x, double y, double n) {
    double px = 1;
    double py = 1;
    for (int i = 0; i < n; i++) {
      px *= x;
      py *= y;
    }
    myAssert(px + py <= 1e+9, "Sum is out of bounds");
  }
  
  long pow(long x, int n) {
    long ans = 1;
    for (int i = 0; i < n; i++) {
      ans *= x;
    }
    return ans;
  }
  
  void solve() throws IOException {
    int x = nextInt();
    myAssert(1 <= x && x <= 100, "x is out of bounds");
    int y = nextInt();
    myAssert(1 <= y && y <= 100, "y is out of bounds");
    int n = nextInt();
    myAssert(3 <= n && n <= 10, "n is out of bounds");
    checkSum(x, y, n);
    
    long sum = pow(x, n) + pow(y, n);
    
    long i = 0;
    long ans = Long.MAX_VALUE;
    long ai = 0;
    while (pow(i, n) <= sum) {
      if (Math.abs(pow(i, n) - sum) < ans) {
        ans = Math.abs(pow(i, n) - sum);
        ai = i;
      }
      i++;
    }
    if (Math.abs(pow(i, n) - sum) < ans) {
        ans = Math.abs(pow(i, n) - sum);
        ai = i;
    }

    out.println(ans);
    out.println(ai);
  }
}

