import java.io.*;
import java.util.*;

public class football_at implements Runnable {
	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;

	class Player implements Comparable<Player> {
		public String name;
		private int goals, passes, failes;
		public int number;
		
		Player(String name, int number) {
			this.name = name;
			this.number = number;
		}
		
		public void goal() {
			++goals;
		}
		
		public void pass() {
			++passes;
		}
		
		public void fail() {
			++failes;
		}
		
		public int compareTo(Player other) {
			return this.name.compareTo(other.name); 
		}
		
		public String toString() {
			return name + ": " + goals + " " + passes + " " + failes;
		}
	}
	
	class Team {
		private Player[] team;
		private int countGoals;
		
		Team(int n) {
			team = new Player[n];
		}
		
		public void make() throws Exception {
			for(int i = 0; i < team.length; ++i) {
				team[i] = new Player(nextToken(), i);
			}
			Arrays.sort(team);
		}
		
		public Player findPlayer(String name) {
			int l = 0;
			int r = team.length - 1;
			while(l <= r) {
				int m = (l + r) / 2;
				int c = name.compareTo(team[m].name);
				if (c == 0) {
					return team[m];
				}
				else if (c < 0) {
					r = m - 1;
				}
				else {
					l = m + 1;
				}
			}
			return null;
		}
		
		public void print() {
			Arrays.sort(team, new Comparator<Player>() {

				public int compare(Player a, Player b) {
					return a.number - b.number;
				}
				
			});
			for(Player p : team) {
				out.println(p);
			}
			out.println();
		}
	}
	
	public void solve() throws Exception {
		int n = nextInt();
		Team team1 = new Team(n); team1.make();
		Team team2 = new Team(n); team2.make();
		String s1 = null;
		String s2 = null;
		String s3 = nextToken();
		while(s3 != null) {
			if (s3.compareTo("GOAL!") == 0) {
				if (team1.findPlayer(s2) != null) {
					team1.findPlayer(s2).goal();
					++team1.countGoals;
					if (s1 != null && team1.findPlayer(s1) != null) {
						team1.findPlayer(s1).pass();
					}
					else if (s1 != null && team2.findPlayer(s1) != null) {
						team2.findPlayer(s1).fail();
					}
				}
				else {
					team2.findPlayer(s2).goal();
					++team2.countGoals;
					if (s1 != null && team2.findPlayer(s1) != null) {
						team2.findPlayer(s1).pass();
					}
					else if (s1 != null && team1.findPlayer(s1) != null) {
						team1.findPlayer(s1).fail();
					}
				}
			}
			s1 = s2;
			s2 = s3;
			try {
				s3 = nextToken();
			} catch (Exception e) {
				s3 = null;
			}
		}
		if (team2.countGoals > team1.countGoals) {
			team2.print();
			team1.print();
		}
		else {
			team1.print();
			team2.print();
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(89);
		} finally {
			out.close();
		}
	}

	private football_at(String name) {
		try {
			in = new BufferedReader(new FileReader(name + ".in"));
//			in = new BufferedReader(new FileReader("input.txt"));
//			in = new BufferedReader(new InputStreamReader(System.in));
			st = new StringTokenizer("");
			out = new PrintWriter(new File(name + ".out"));
//			out = new PrintWriter(new File("output.txt"));
//			out = new PrintWriter(System.out);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(89);
		}
	}

	public static void main(String[] args) {
		(new Thread(new football_at("football"))).start();
	}

	private String nextToken() throws Exception {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}
}