import java.io.*;
import java.util.*;
import java.math.*;

public class palin3_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new palin3_af()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader("palin3.in"));
			out = new PrintWriter("palin3.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int MAXN = 100000;
	
	void solve() throws IOException {
		String s = nextToken();
		myAssert(0 <= s.length() && s.length() <= MAXN, "String length out of bounds!");
		for (int i = 0; i < s.length(); i++) {
			myAssert('a' <= s.charAt(i) && s.charAt(i) <= 'z', "Unknown symbol " + s.charAt(i) + " at position " + (i + 1));
		}
		int len = s.length();
		int ans = 0;
		
		loop:
		while (len > 1) {
			for (int i = 0; i < len / 2; i++) {
				if (s.charAt(i) != s.charAt(len - i - 1)) {
					break loop;
				}
			}
			ans++;
			len = (len + 1) / 2;
		}
		out.println(ans);
	}
}
