import java.io.*;
import java.util.*;
import java.math.*;

public class pixel_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new pixel_af()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader("pixel.in"));
			out = new PrintWriter("pixel.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}
	
	void solve() throws IOException {
		int n = nextInt();
		myAssert(4 <= n && n <= 100, "n out of bounds");
		int w = nextInt();
		myAssert(1 <= w && w <= 200, "w out of bounds");
		int h = nextInt();
		myAssert(1 <= h && h <= 200, "h out of bounds");
		
		int[] x = new int[n];
		int[] y = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = nextInt();
			myAssert(0 <= x[i] && x[i] <= w, "x[" + i + "] is out of bounds");
			y[i] = nextInt();
			myAssert(0 <= y[i] && y[i] <= h, "y[" + i + "] is out of bounds");
		}
		
		for (int i = 0; i < n; i++) {
			myAssert(x[i] == x[(i + 1) % n] || y[i] == y[(i + 1) % n], "Not a good polygon"); 
			myAssert(x[i] != x[(i + 1) % n] || y[i] != y[(i + 1) % n], "Not a good polygon");
		}
		
		for (int i = 0; i < n; i++) {
			for (int j = i + 2; j < n; j++) {
				if ((j + 1) % n == i) continue;
				long a1 = y[i] - y[(i + 1) % n];
				long b1 = x[(i + 1) % n] - x[i];
				long c1 = - a1 * x[i] - b1 * y[i];
				
				long a2 = y[j] - y[(j + 1) % n];
				long b2 = x[(j + 1) % n] - x[j];
				long c2 = - a2 * x[j] - b2 * y[j];
				
				if ((a1 * x[j] + b1 * y[j] + c1) * (a1 * x[(j + 1) % n] + b1 * y[(j + 1) % n] + c1) > 0) continue;
				if ((a2 * x[i] + b2 * y[i] + c2) * (a2 * x[(i + 1) % n] + b2 * y[(i + 1) % n] + c2) > 0) continue;
				if (a2 * x[i] + b2 * y[i] + c2 == 0 && a2 * x[(i + 1) % n] + b2 * y[(i + 1) % n] + c2 == 0) {
					myAssert(x[i] != x[j] || y[i] != y[j], "Self - touching");
					myAssert(x[(i + 1) % n] != x[j] || y[(i + 1) % n] != y[j], "Self - touching");
					myAssert(x[(i + 1) % n] != x[(j + 1) % n] || y[(i + 1) % n] != y[(j + 1) % n], "Self - touching");
					myAssert(x[i] != x[(j + 1) % n] || y[i] != y[(j + 1) % n], "Self - touching");
					
					myAssert((x[i] - x[j]) * (x[i] - x[(j + 1) % n]) >= 0, "Bad polygon");
					myAssert((y[i] - y[j]) * (y[i] - y[(j + 1) % n]) >= 0, "Bad polygon");
					myAssert((x[(i + 1) % n] - x[j]) * (x[(i + 1) % n] - x[(j + 1) % n]) >= 0, "Bad polygon");
					myAssert((y[(i + 1) % n] - y[j]) * (y[(i + 1) % n] - y[(j + 1) % n]) >= 0, "Bad polygon");
					myAssert((x[j] - x[i]) * (x[j] - x[(i + 1) % n]) >= 0, "Bad polygon");
					myAssert((y[j] - y[i]) * (y[j] - y[(i + 1) % n]) >= 0, "Bad polygon");
					myAssert((x[(j + 1) % n] - x[i]) * (x[(j + 1) % n] - x[(i + 1) % n]) >= 0, "Bad polygon");
					myAssert((y[(j + 1) % n] - y[i]) * (y[(j + 1) % n] - y[(i + 1) % n]) >= 0, "Bad polygon");
					continue;					
				}
				myAssert(false, "Self - intersectiong or touching polygon");
			}
		}
		
		
		long s = 0;
		for (int i = 0; i < n; i++) {
			s += x[i] * y[(i + n - 1) % n] - x[i] * y[(i + 1) % n];
		}
		myAssert(s < 0, "Wrong polygon orientation");
				
		
		char[][] G = new char[w][h]; 
		
		for (int i = 0; i < w; i++) {
			for (int j = 0; j < h; j++) {
				int c = 0;
				for (int k = 0; k < n; k++) {
					if (x[k] == x[(k + 1) % n] && x[k] > i && (Math.min(y[k], y[(k + 1) % n]) <= j && j < Math.max(y[k], y[(k + 1) % n]))) {
						c++;
					}
				}
				if (c % 2 == 1) {
					G[i][j] = '#';
				} else {
					G[i][j] = '.';
				}
			}
		}
		
		for (int j = h - 1; j >= 0; j--) {
			for (int i = 0; i < w; i++) {
				out.print(G[i][j]);
			}
			out.println();
		}
		
	}
}
