import java.util.*;
import java.io.*;

public class carwash_as_random implements Runnable {
    class Car {
        int i;
        long a;
        long b;
        long sa;
        long sb;

        Car(int i, long a, long b) {
            this.i = i;
            this.a = a;
            this.b = b;
            sa = -1;
            sb = -1;
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("carwash.in"));
        PrintWriter out = new PrintWriter("carwash.out");

        int n = in.nextInt();
        Car[] cars = new Car[n];
        for (int i = 0; i < n; i++) {
            cars[i] = new Car(i, in.nextInt(), in.nextInt());
        }

        long bestta = 0;
        long besttb = 0;
        ArrayList<Car> besta = null;
        ArrayList<Car> bestb = null;
        long best = Long.MAX_VALUE;

        long start = System.currentTimeMillis();
        do {
            Random random = new Random();
            ArrayList<Car> a = new ArrayList<Car>();
            a.addAll(Arrays.asList(cars));
            for (int i = 0; i < n; i++) {
                int j = random.nextInt(i + 1);
                Car tmp = a.get(i);
                a.set(i, a.get(j));
                a.set(j, tmp);
            }
            ArrayList<Car> b = new ArrayList<Car>();
            b.addAll(Arrays.asList(cars));
            for (int i = 0; i < n; i++) {
                int j = random.nextInt(i + 1);
                Car tmp = b.get(i);
                b.set(i, b.get(j));
                b.set(j, tmp);
            }

            int ai = 0;
            int bi = 0;
            long cta = 0;
            long ctb = 0;
            while (ai < a.size() || bi < b.size()) {
                if ((cta <= ctb && ai < a.size()) || bi == b.size()) {
                    Car prb = bi == 0 ? null : b.get(bi - 1);
                    Car cra = a.get(ai);
                    if (prb == null || prb.i != cra.i || cta > ctb) {
                        cra.sa = cta;
                    } else {
                        cra.sa = ctb;
                    }
                    cta = cra.sa + cra.a;
                    ai++;
                } else {
                    Car pra = ai == 0 ? null : a.get(ai - 1);
                    Car crb = b.get(bi);
                    if (pra == null || pra.i != crb.i || ctb > cta) {
                        crb.sb = ctb;
                    } else {
                        crb.sb = cta;
                    }
                    ctb = crb.sb + crb.b;
                    bi++;
                }
            }

            if (Math.max(cta, ctb) < best) {
                bestta = cta;
                besttb = ctb;
                best = Math.max(cta, ctb);
                besta = a;
                bestb = b;
            }
        } while (System.currentTimeMillis() - start < 1000);

        long cta = 0;
        long ctb = 0;
        int ai = 0;
        int bi = 0;
        ArrayList<Car> a = besta;
        ArrayList<Car> b = bestb;
        while (ai < a.size() || bi < b.size()) {
            if ((cta <= ctb && ai < a.size()) || bi == b.size()) {
                Car prb = bi == 0 ? null : b.get(bi - 1);
                Car cra = a.get(ai);
                if (prb == null || prb.i != cra.i || cta > ctb) {
                    cra.sa = cta;
                } else {
                    cra.sa = ctb;
                }
                cta = cra.sa + cra.a;
                ai++;
            } else {
                Car pra = ai == 0 ? null : a.get(ai - 1);
                Car crb = b.get(bi);
                if (pra == null || pra.i != crb.i || ctb > cta) {
                    crb.sb = ctb;
                } else {
                    crb.sb = cta;
                }
                ctb = crb.sb + crb.b;
                bi++;
            }
        }

        out.println(Math.max(cta, ctb));
        for (int i = 0; i < n; i++) {
            out.println(cars[i].sa + " " + cars[i].sb);
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new carwash_as_random()).start();
    }
}