import java.util.*;
import java.io.*;

public class carwash_as_sort implements Runnable {
    class Car {
        int i;
        long a;
        long b;
        long sa;
        long sb;

        Car(int i, long a, long b) {
            this.i = i;
            this.a = a;
            this.b = b;
            sa = -1;
            sb = -1;
        }
    }

    int n;
    Car[] cars;

    long bestta = 0;
    long besttb = 0;
    ArrayList<Car> besta = null;
    ArrayList<Car> bestb = null;
    long best = Long.MAX_VALUE;

    void relax(Comparator<Car> useForA, Comparator<Car> useForB) {
        ArrayList<Car> a;
        ArrayList<Car> b;
        a = new ArrayList<Car>();
        b = new ArrayList<Car>();
        a.addAll(Arrays.asList(cars));
        Collections.sort(a, useForA);
        b.addAll(Arrays.asList(cars));
        Collections.sort(b, useForB);

        int ai = 0;
        int bi = 0;
        long cta = 0;
        long ctb = 0;
        while (ai < a.size() || bi < b.size()) {
            if ((cta <= ctb && ai < a.size()) || bi == b.size()) {
                Car prb = bi == 0 ? null : b.get(bi - 1);
                Car cra = a.get(ai);
                if (prb == null || prb.i != cra.i || cta > ctb) {
                    cra.sa = cta;
                } else {
                    cra.sa = ctb;
                }
                cta = cra.sa + cra.a;
                ai++;
            } else {
                Car pra = ai == 0 ? null : a.get(ai - 1);
                Car crb = b.get(bi);
                if (pra == null || pra.i != crb.i || ctb > cta) {
                    crb.sb = ctb;
                } else {
                    crb.sb = cta;
                }
                ctb = crb.sb + crb.b;
                bi++;
            }
        }

        if (Math.max(cta, ctb) < best) {
            bestta = cta;
            besttb = ctb;
            best = Math.max(cta, ctb);
            besta = a;
            bestb = b;
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("carwash.in"));
        PrintWriter out = new PrintWriter("carwash.out");

        n = in.nextInt();
        cars = new Car[n];
        for (int i = 0; i < n; i++) {
            cars[i] = new Car(i, in.nextInt(), in.nextInt());
        }

        Comparator<Car> aDesc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.a < o2.a ? 1 : o1.a > o2.a ? -1 : o1.i - o2.i;
            }
        };
        Comparator<Car> aAsc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.a < o2.a ? -1 : o1.a > o2.a ? 1 : o1.i - o2.i;
            }
        };
        Comparator<Car> bDesc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.b < o2.b ? 1 : o1.b > o2.b ? -1 : o1.i - o2.i;
            }
        };
        Comparator<Car> bAsc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.b < o2.b ? -1 : o1.b > o2.b ? 1 : o1.i - o2.i;
            }
        };
        Comparator<Car> sumDesc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.a + o1.b < o2.a + o2.b ? 1 : o1.a + o1.b > o2.a + o2.b ? -1 : o1.i - o2.i;
            }
        };
        Comparator<Car> sumAsc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.a + o1.b > o2.a + o2.b ? -1 : o1.a + o1.b < o2.a + o2.b ? 1 : o1.i - o2.i;
            }
        };
        Comparator<Car> ratioDesc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.a * 1.0 / o1.b < o2.a * 1.0 /  o2.b ? 1 : o1.a * 1.0 / o1.b > o2.a * 1.0 / o2.b ? -1 : o1.i - o2.i;
            }
        };
        Comparator<Car> ratioAsc = new Comparator<Car>() {
            public int compare(Car o1, Car o2) {
                return o1.a * 1.0 / o1.b < o2.a * 1.0 /  o2.b ? -1 : o1.a * 1.0 / o1.b > o2.a * 1.0 / o2.b ? 1 : o1.i - o2.i;
            }
        };

        ArrayList<Comparator<Car>> comps1 = new ArrayList<Comparator<Car>>();
        comps1.add(aDesc);
        comps1.add(aAsc);
        comps1.add(bDesc);
        comps1.add(bAsc);
        comps1.add(sumDesc);
        comps1.add(sumAsc);
        comps1.add(ratioDesc);
        comps1.add(ratioAsc);
        ArrayList<Comparator<Car>> comps2 = new ArrayList<Comparator<Car>>();
        comps2.add(aDesc);
        comps2.add(aAsc);
        comps2.add(bDesc);
        comps2.add(bAsc);
        comps2.add(sumDesc);
        comps2.add(sumAsc);
        comps2.add(ratioDesc);
        comps2.add(ratioAsc);

        for (Comparator<Car> c : comps1) {
            for (Comparator<Car> d : comps2) {
                relax(c, d);
            }
        }

        long cta = 0;
        long ctb = 0;
        int ai = 0;
        int bi = 0;
        ArrayList<Car> a = besta;
        ArrayList<Car> b = bestb;
        while (ai < a.size() || bi < b.size()) {
            if ((cta <= ctb && ai < a.size()) || bi == b.size()) {
                Car prb = bi == 0 ? null : b.get(bi - 1);
                Car cra = a.get(ai);
                if (prb == null || prb.i != cra.i || cta > ctb) {
                    cra.sa = cta;
                } else {
                    cra.sa = ctb;
                }
                cta = cra.sa + cra.a;
                ai++;
            } else {
                Car pra = ai == 0 ? null : a.get(ai - 1);
                Car crb = b.get(bi);
                if (pra == null || pra.i != crb.i || ctb > cta) {
                    crb.sb = ctb;
                } else {
                    crb.sb = cta;
                }
                ctb = crb.sb + crb.b;
                bi++;
            }
        }

        out.println(Math.max(cta, ctb));
        for (int i = 0; i < n; i++) {
            out.println(cars[i].sa + " " + cars[i].sb);
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new carwash_as_sort()).start();
    }
}