import java.io.*;
import java.util.*;
import java.math.*;

public class cipher_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new cipher_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("cipher.in"));
			out = new PrintWriter("cipher.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	
	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}
	
	String IOB = "is out of bounds!";
	
	void solve() throws IOException {
		int k = nextInt();
		myAssert(1 <= k && k <= 26, "k " + IOB);
		String s = nextToken();
		for (int i = 0; i < s.length(); i++) {
			myAssert('a' <= s.charAt(i) && s.charAt(i) <= 'a' + k - 1, "s[" + i + "] " + IOB);
		}
		String t = nextToken();
		for (int i = 0; i < t.length(); i++) {
			myAssert('a' <= t.charAt(i) && t.charAt(i) <= 'a' + k - 1, "t[" + i + "] " + IOB);
		}
		myAssert(s.length() == t.length(), "t.length() != s.length()");
		int[] a = new int[k];
		Arrays.fill(a, -1);
		boolean[] u = new boolean[k];
		for (int i = 0; i < s.length(); i++) {
			int c1 = s.charAt(i) - 'a';
			int c2 = t.charAt(i) - 'a';
			if (a[c1] < 0) {
				if (u[c2]) {
					out.println("IMPOSSIBLE");
					return;
				}
				a[c1] = c2;
				u[c2] = true;
			} else {
				if (a[c1] != c2) {
					out.println("IMPOSSIBLE");
					return;
				}
			}
		}
		int j = 0;
		for (int i = 0; i < k; i++) {
			if (a[i] < 0) {
				while (u[j]) j++;
				a[i] = j++;
			}
		}
		out.println("POSSIBLE");
		for (int i = 0; i < k; i++) {
			out.println((char)('a' + i) + " -> " + (char)(a[i] + 'a'));
		}
	}
}
