//  " "
// 12- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class ineq_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new ineq_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "ineq";
	
	class Ineq {
		String s1, s2;
		int type;
		int n1;
		int n2;
		
		Ineq() throws IOException {
			s1 = nextToken();
			myAssert("x".equals(s1) || "y".equals(s1) || "z".equals(s1), "Wrong first argument");
			if ("x".equals(s1)) {
				n1 = 0;
			}
			if ("y".equals(s1)) {
				n1 = 1;
			}
			if ("z".equals(s1)) {
				n1 = 2;
			}
			String f = nextToken();
			s2 = nextToken();
			myAssert("<".equals(f) || ">".equals(f), "Wrong type");
			if ("<".equals(f)) {
				type = 2;
				n2 = Integer.parseInt(s2);
				myAssert(n2 >= 0 && n2 <= 100, "Wrong second argument");
			} else {
				if ("x".equals(s2)) {
					type = 0;
					n2 = 0;
				} else if ("y".equals(s2)) {
					type = 0;
					n2 = 1;
				} else if ("z".equals(s2)) {
					type = 0;
					n2 = 2;
				} else {
					type = 1;
					n2 = Integer.parseInt(s2);
					myAssert(n2 >= 0 && n2 <= 100, "Wrong second argument");
				}
			}
		}
		
		boolean check(int[] a) {
			if (type == 0) {
				return a[n1] > a[n2];
			}
			if (type == 1) {
				return a[n1] > n2;
			}
			return a[n1] < n2; 
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		myAssert(n >= 0 && n <= 25, "Wrong n");
		Ineq[] ineqs = new Ineq[n];
		for (int i = 0; i < n; i++) {
			ineqs[i] = new Ineq();
		}
		int ans = 0;
		int[] a = new int[3];
		for (a[0] = 0; a[0] <= 100; a[0]++) {
			for (a[1] = 0; a[1] <= 100; a[1]++) {
				for (a[2] = 0; a[2] <= 100; a[2]++) {
					boolean good = true;
					for (int i = 0; i < n; i++) {
						good &= ineqs[i].check(a);
						if (!good) {
							break;
						}
					}
					if (good) ans++;
				}
			}
		}
		out.println(ans);
	}
}
