import java.io.*;
import java.util.*;
import java.math.*;

public class snooker_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new snooker_aa()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	private void bounds(int x, int l, int r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x);
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "snooker";

	class Player implements Comparable<Player> {
		public Player(String s, int i) {
			name = s;
			firstBreak = i;
			breaks = new ArrayList<Integer>();
		}

		public String toString() {
			StringBuilder s = new StringBuilder(name);
			for (int i : breaks) {
				s.append(" " + i);
			}
			return s.toString();
		}

		ArrayList<Integer> breaks;

		int firstBreak;

		String name;

		public int compareTo(Player p) {
			for (int i = 0; i < Math.max(breaks.size(), p.breaks.size()); i++) {
				int c1 = i < breaks.size() ? breaks.get(i) : 0;
				int c2 = i < p.breaks.size() ? p.breaks.get(i) : 0;
				if (c1 != c2) {
					return c1 < c2 ? 1 : -1;
				}
			}
			return firstBreak < p.firstBreak ? -1
					: firstBreak > p.firstBreak ? 1 : 0;
		}
	}

	void solve() throws IOException {
		int n = nextInt();
		bounds(n, 1, 1000, "n");
		int k = 0;
		HashMap<String, Integer> hm = new HashMap<String, Integer>();
		ArrayList<Player> al = new ArrayList<Player>();
		for (int i = 0; i < n; i++) {
			String s = br.readLine().trim();
			int x = Integer.parseInt(s.substring(0, s.indexOf(' ')));
			bounds(x, 100, 155, "break");
			s = s.substring(s.indexOf(' ') + 1);
			bounds(s.length(), 1, 30, "length");
			MyAssert(s.charAt(0) != ' ', "Name begins with space!!! " + s);
			for (int j = 0; j < s.length(); j++) {
				char c = s.charAt(j);
				MyAssert(('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z')
						|| c == ' ', "symbol is wrong " + c);
			}
			if (!hm.containsKey(s)) {
				hm.put(s, k++);
				al.add(new Player(s, i));
			}
			int q = hm.get(s);
			al.get(q).breaks.add(x);
		}
		for (Player p : al) {
			Collections.sort(p.breaks);
			Collections.reverse(p.breaks);
		}
		Collections.sort(al);
		for (Player p : al) {
			out.println(p);
		}
	}
}
