import java.io.*;
import java.util.*;

public class division_as implements Runnable {

    class Point implements Comparable<Point> {
        int i;
        int x;
        int y;

        public Point(int i, int x, int y) {
            this.i = i;
            this.x = x;
            this.y = y;
        }

        public int compareTo(Point o) {
            if (x == o.x) {
                return o.y - y;
            } else {
                return x - o.x;
            }
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("division.in"));
        PrintWriter out = new PrintWriter(new File("division.out"));

        int n = in.nextInt();
        Point[] p = new Point[n];
        for (int i = 0; i < n; i++) {
            p[i] = new Point(i + 1, in.nextInt(), in.nextInt());
        }

        Arrays.sort(p);

        boolean[][] can = new boolean[n][n];
        int[][] ab = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (p[i].x == p[j].x) {
                    continue;
                }
                can[i][j] = true;
                for (int k = 0; k < n; k++) {
                    if (i == k || j == k) {
                        continue;
                    }

                    if (p[i].x < p[k].x && p[k].x <= p[j].x) {
                        if (p[k].x == p[j].x) {
                            if (p[k].y > p[j].y) {
                                ab[i][j]++;
                            }
                        } else {
                            int d = (p[j].y - p[i].y) * (p[k].x - p[i].x) - (p[j].x - p[i].x) * (p[k].y - p[i].y);
                            if (d == 0) {
                                can[i][j] = false;
                                break;
                            }
                            if (d < 0) {
                                ab[i][j]++;
                            }
                        }
                    }
                }
            }
        }

        boolean[][][] pos = new boolean[n][n + 1][n + 1];
        for (int i = 0; i < n; i++) {
            int cnt = 0;
            for (int j = 0; j < i; j++) {
                if (p[j].y == p[i].y) {
                    cnt = -1;
                    break;
                }
                if (p[j].y > p[i].y) {
                    cnt++;
                }
            }
            if (cnt >= 0) {
                pos[i][1][cnt] = true;
            }
        }

        int[][][] from = new int[n][n + 1][n + 1];
        for (int i = 2; i <= n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < j; k++) {
                    if (can[k][j]) {
                        for (int l = 0; l < n; l++) {
                            if (pos[k][i - 1][l]) {
                                pos[j][i][l + ab[k][j]] = true;
                                from[j][i][l + ab[k][j]] = k;
                            }
                        }
                    }
                }
            }
        }

        int[] lft = new int[n];
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (p[j].x > p[i].x) {
                    if (p[j].y == p[i].y) {
                        lft[i] = -1;
                        break;
                    }
                    if (p[j].y > p[i].y) {
                        lft[i]++;
                    }
                }
            }
        }

        int best = Integer.MAX_VALUE;
        int bi = -1;
        int bon = -1;
        int bab = -1;
        for (int i = 0; i < n; i++) {
            if (lft[i] == -1) {
                continue;
            }
            for (int j = 1; j <= n; j++) {
                for (int k = 0; k < n; k++) {
                    if (pos[i][j][k]) {
                        int[] z = new int[]{j, k + lft[i], n - j - k - lft[i]};
                        Arrays.sort(z);
                        int value = z[2] - z[0];
                        if (value < best) {
                            best = value;
                            bi = i;
                            bon = j;
                            bab = k;
                        }
                    }
                }
            }
        }

        ArrayList<Integer> on = new ArrayList<Integer>();
        on.add(bi);
        int i = bi;
        int j = bon;
        int k = bab;
        while (j > 1) {
            int ni = from[i][j][k];
            int nj = j - 1;
            int nk = k - ab[ni][i];

            on.add(ni);

            i = ni;
            j = nj;
            k = nk;
        }
        Collections.reverse(on);

        out.println(on.size());
        for (int x : on) {
            out.print(p[x].i + " ");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new division_as()).start();
    }
}

