import java.util.*;
import java.io.*;

public class mayors_as implements Runnable {
    boolean checkConstraints = false;

    boolean isConnected(boolean[][] a) {
        int n = a.length;
        boolean[][] b = new boolean[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                b[i][j] = a[i][j];
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < n; k++) {
                    b[j][k] |= b[j][i] && b[i][k];
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i != j && !b[i][j]) {
                    return false;
                }
            }
        }
        return true;
    }

    class Pair {
        int x;
        int y;

        Pair(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("mayors.in"));
        PrintWriter out = new PrintWriter("mayors.out");

        int n = in.nextInt();
        assert 1 <= n && n <= 500;
        int m = in.nextInt();
        assert 0 <= m && m <= 10000; 
        boolean[][] a = new boolean[n][n];
        for (int i = 0; i < m; i++) {
            int x = in.nextInt() - 1;
            int y = in.nextInt() - 1;
            assert x != y;
            assert !a[x][y];
            a[x][y] = a[y][x] = true;
        }
        if (checkConstraints) {
            assert isConnected(a);
            for (int i = 0; i < n; i++) {
                int mn = 0;
                for (int j = 0; j < n; j++) {
                    if (a[i][j]) {
                        mn++;
                    }
                }
                boolean[][] v = new boolean[mn][mn];
                int jj = 0;
                for (int j = 0; j < n; j++) {
                    if (a[i][j]) {
                        int kk = 0;
                        for (int k = 0; k < n; k++) {
                            if (a[i][k]) {
                                v[jj][kk++] = a[j][k];
                            }
                        }
                        jj++;
                    }
                }
                assert isConnected(v);
            }
        }

        if (n == 1) {
            out.println("Plan OK");
            out.println("R");
            out.close();
            return;
        }

        ArrayList<Pair> queue = new ArrayList<Pair>();
        int h = 0;
        int ki = -1, kj = -1;

        search:
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j]) {
                    ki = i;
                    kj = j;
                    break search;
                }
            }
        }


        int[] color = new int[n];
        Arrays.fill(color, -1);
        color[ki] = 0;
        color[kj] = 1;
        queue.add(new Pair(ki, kj));

        while (h < queue.size()) {
            int x = queue.get(h).x;
            int y = queue.get(h).y;
            h++;

            for (int i = 0; i < n; i++) {
                if (color[i] == -1) {
                    if (a[x][i] && a[y][i]) {
                        color[i] = 3 - color[x] - color[y];
                        queue.add(new Pair(x, i));
                        queue.add(new Pair(y, i));
                    }
                }
            }
        }

        boolean fail = false;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] && color[i] == color[j]) {
                    fail = true;
                    break;
                }
            }
        }

        if (fail) {
            out.println("Plan failed");
        } else {
            out.println("Plan OK");
            for (int i = 0; i < n; i++) {
                out.print("RGB".charAt(color[i]));
            }
            out.println();
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new mayors_as()).start();
    }
}