import java.io.*;
import java.math.BigInteger;
import java.util.Random;
import java.util.StringTokenizer;

public class settling_as implements Runnable {
    BufferedReader in;
    StringTokenizer st;

    public int nextInt() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return Integer.parseInt(st.nextToken());
    }

    public String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    public void solve() throws IOException {
        in = new BufferedReader(new FileReader("settling.in"));
        PrintWriter out = new PrintWriter(new File("settling.out"));

        Random rnd = new Random(123654789654123L);
        int pn = 1;
        long[] p = new long[pn];
        for (int i = 0; i < pn; i++) {
            p[i] = BigInteger.valueOf(500000000 + rnd.nextInt(500000000)).nextProbablePrime().longValue();
        }

        int n = nextInt();
        int m = nextInt();
        boolean[][] e = new boolean[n][n];
        for (int i = 0; i < m; i++) {
            int x = nextInt() - 1;
            int y = nextInt() - 1;
            assert x < y;
            assert !e[x][y];
            e[x][y] = true;
        }

        long[][][] c = new long[n][n][pn];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < pn; j++) {
                c[i][i][j] = 1;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                for (int k = i; k < j; k++) {
                    if (e[k][j]) {
                        for (int l = 0; l < pn; l++) {
                            c[i][j][l] = (c[i][j][l] + c[i][k][l]) % p[l];
                        }
                    }
                }
            }
        }

        boolean[][] ex = new boolean[n][n];
        int cc = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                boolean can = false;
                for (int l = 0; l < pn; l++) {
                    if (c[i][j][l] != 0) {
                        can = true;
                        break;
                    }
                }
                if (can) {
                    ex[i][j] = true;
                    cc++;
                }
            }
        }
        out.println(cc);

        int q = nextInt();
        for (int qq = 0; qq < q; qq++) {
            char ch = next().charAt(0);
            switch (ch) {
                case '+': {
                    int x = nextInt() - 1;
                    int y = nextInt() - 1;
                    assert x < y;
                    assert !e[x][y];
                    e[x][y] = true;

                    for (int i = 0; i <= x; i++) {
                        for (int j = y; j < n; j++) {
                            boolean nex = false;
                            for (int l = 0; l < pn; l++) {
                            	if (c[i][x][l] != 0 && c[y][j][l] != 0) {
                                    c[i][j][l] = (c[i][j][l] + c[i][x][l] * c[y][j][l]) % p[l];
                                    if (c[i][j][l] > 0) {
                                        nex = true;
                                    }
                                }
                            }
                            if (!ex[i][j] && nex) {
                                ex[i][j] = true;
                                cc++;
                            }
                        }
                    }

                    out.println(cc);
                    break;
                }
                case '-': {
                    int x = nextInt() - 1;
                    int y = nextInt() - 1;
                    assert x < y;
                    assert e[x][y];
                    e[x][y] = false;

                    for (int i = 0; i <= x; i++) {
                        for (int j = y; j < n; j++) {
                            boolean nex = false;
                            for (int l = 0; l < pn; l++) {
                                if (c[i][x][l] != 0 && c[y][j][l] != 0) {
                                    c[i][j][l] = (c[i][j][l] - c[i][x][l] * c[y][j][l]) % p[l];
                                    if (c[i][j][l] < 0) {
                                        c[i][j][l] += p[l];
                                    }
                                }
                                if (c[i][j][l] > 0) {
                                    nex = true;
                                }
                            }
                            if (ex[i][j] && !nex) {
                                ex[i][j] = false;
                                cc--;
                            }
                        }
                    }

                    out.println(cc);
                    break;
                }
                case '?': {
                    int x = nextInt() - 1;
                    int y = nextInt() - 1;
                    assert x < y;
                    out.println(ex[x][y] ? "YES" : "NO");
                    break;
                }
            }
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new settling_as()).start();
    }
}