import java.io.*;
import java.util.*;
import java.math.*;

public class numbers_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new numbers_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("numbers.in"));
			out = new PrintWriter("numbers.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	String IOB = " is out of bounds!";

	int MAX_VAL = (int) 1e9;

	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 100000, "n" + IOB);
		int[] a = new int[n];
		int[] c = new int[3];
		int r = 0;
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
			myAssert(0 <= a[i] && a[i] <= MAX_VAL, "a[" + i + "]" + IOB);
			c[a[i] % 3]++;
			r = (r + a[i]) % 3;
		}

		int m1 = -1, m2 = -1;

		if (r != 0) {
			if (c[r] > 0) {
				m1 = r;
			} else {
				search: for (int i = 0; i < 3; i++) {
					if (c[i] == 0)
						continue;
					for (int j = 0; j < 3; j++) {
						if (c[j] == 0)
							continue;
						if ((9 - i - j + r) % 3 == 0) {
							m1 = i;
							m2 = j;
							break search;
						}
					}
				}
			}
		}
		int rc = 0;
		out.println(n - ((m1 >= 0) ? 1 : 0) - ((m2 >= 0) ? 1 : 0));
		for (int i = 0; i < n; i++) {
			if (a[i] % 3 == m1) {
				m1 = -1;
				continue;
			}
			if (a[i] % 3 == m2) {
				m2 = -1;
				continue;
			}
			out.print((i + 1) + " ");
			rc = (rc + a[i]) % 3;
		}
		myAssert(rc == 0, "Solution doesn't work =(");
	}
}
