//Problem "Sequense"
//13th Internet Olympiad, season 2007-2008
//Problem Author:  Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Vladimir Ulyantsev, ulyantsev@rain.ifmo.ru

#include <stdio.h>
#include <math.h>
#include <assert.h>

int z(long long x) {
	int ans = 0;
	long long t = x;
	while (t > 0) {
		ans += t % 10;
		t /= 10;
	}
	return ans;
}

int s(int x) {
	if (x == 1) return 1;
	int ans = 0;
	for (int i = 1; i <= (int) sqrt(x); ++i) {
		if (x % i == 0) {
			ans += z(i * (long long)i);
			if (x / i != i) {
				ans += z((x / i) * (long long)(x / i));
			}
		}
	}
	return ans;
}

int x, a[10000];

int main() {
	freopen("seq.in", "r", stdin);
	freopen("seq.out", "w", stdout);
	
	scanf("%d", &x);
	assert(1 <= x && x <= 1000000000);

	a[0] = x;
	for (int i = 1; ; ++i) {
		a[i] = s(a[i - 1]);
		for (int j = 0; j < i; ++j) {
			if (a[i] == a[j]) {
				printf("%d %d", j, i - j);
				return 0;
			}
		}
	}

	return 0;
}

