import java.io.*;
import java.util.*;

// "  "
//1- -  2008-2009,  .
// :   
// :  , buzdalov@rain.ifmo.ru

// .
//         .

public class circles_mb {
    private static final int MAX_COORD = 1000;
    
    private static final void unsafeAssertion(boolean exp, String msg) {
        if (!exp) {
            throw new AssertionError(msg);
        }
    }

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("circles.in"));
        int x1 = in.nextInt();
        int y1 = in.nextInt();
        int x2 = in.nextInt();
        int y2 = in.nextInt();
        in.close();
        
        unsafeAssertion(Math.abs(x1) <= MAX_COORD, "x1 is out of bounds");
        unsafeAssertion(Math.abs(y1) <= MAX_COORD, "y1 is out of bounds");
        unsafeAssertion(Math.abs(x2) <= MAX_COORD, "x2 is out of bounds");
        unsafeAssertion(Math.abs(y2) <= MAX_COORD, "y2 is out of bounds");
        unsafeAssertion(x1 != x2 || y1 != y2, "The segment has zero length");
        
        int a = (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
        int b = (x2 - x1) * x1 + (y2 - y1) * y1;
        int c = x1 * x1 + y1 * y1;
        
        int l1 = x1 * x1 + y1 * y1;
        int l2 = x2 * x2 + y2 * y2;
        
        int ans = 0;
        
        for (int radius = 1; radius <= 2 * MAX_COORD; ++radius) {
            int r2 = radius * radius;
        
            int aa = a;
            int bb = b;
            int cc = c - radius * radius;
            long dd = (long) (bb) * bb - (long) (aa) * cc;

            if (dd == 0) {
                if (bb <= 0 && -bb <= aa) {
                    ++ans;
                }
            } else if (dd > 0) {
                long posMax = Math.max(0, aa + bb);
                long posMin = Math.max(0, bb);
                long negMin = Math.min(bb, 0);
                long negMax = Math.min(aa + bb, 0);
                
                if (posMin * posMin <= dd && dd <= posMax * posMax) {
                    ++ans;
                }
                
                if (negMax * negMax <= dd && dd <= negMin * negMin) {
                    ++ans;
                }
            }
        }
        
        PrintWriter out = new PrintWriter("circles.out");
        out.println(ans);
        out.close();
    }
}
