//  "  "
// 1- -  2007-2008,  
//  :  , ulyantsev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru
//  -     -    

import java.io.*;
import java.util.*;

public class circles_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new circles_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "circles";
	double eps = 1e-9;

	public void solve() throws IOException {
		int x1 = nextInt();
		int y1 = nextInt();
		int x2 = nextInt();
		int y2 = nextInt();
		int p1 = x1 * (x1 - x2) + y1 * (y1 - y2);
		int p2 = x2 * (x2 - x1) + y2 * (y2 - y1);
		double x = x1;
		double y = y1;
		if (p1 >= 0 && p2 >= 0) {
			double a = y2 - y1;
			double b = x1 - x2;
			double t = Math.sqrt(a * a + b * b);
			a /= t;
			b /= t;
			double c = -a * x1 - b * y1;
			x = -a * c;
			y = -b * c;
		}
		double d1 = Math.sqrt(x1 * x1 + y1 * y1);
		double d2 = Math.sqrt(x2 * x2 + y2 * y2);
		double d = Math.sqrt(x * x + y * y);
		if (p1 < 0 || p2 < 0) {
			d = Math.min(d1, d2);
		}
		int ans = 0;
		for (int i = 1; i <= 10000; i++) {
			if (d1 + eps > i && i > d - eps) {
				ans++;
			}
			if (d2 + eps > i && i > d + eps) {
				ans++;
			}
		}
		out.println(ans);
	}
}
