import java.io.*;
import java.util.*;
import java.awt.geom.*;

// " "
//1- -  2008-2009,  
// :  , tsarev@rain.ifmo.ru
// :  , buzdalov@rain.ifmo.ru

//,    

public class dual_mb {
    private static final int MAX_N = 100;
    private static final int MAX_COORD = 100000;
    private static final int MAX_K = 10;
    
    private static final void unsafeAssertion(boolean exp, String msg) {
        if (!exp) {
            throw new AssertionError(msg);
        }
    }

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("dual.in"));
        int n = in.nextInt();
        
        unsafeAssertion(3 <= n && n <= MAX_N, "N is out of bounds");
        
        int[] x = new int[n];
        int[] y = new int[n];
        for (int i = 0; i < n; ++i) {
            x[i] = in.nextInt();
            y[i] = in.nextInt();
            unsafeAssertion(Math.abs(x[i]) <= MAX_COORD, "x[" + (i + 1) + "] is out of bounds");
            unsafeAssertion(Math.abs(y[i]) <= MAX_COORD, "y[" + (i + 1) + "] is out of bounds");
        }
        
        int k = in.nextInt();
        unsafeAssertion(0 <= k && k <= 10, "k is out of bounds");
        
        double[] xx = new double[n], xxt = new double[n];
        double[] yy = new double[n], yyt = new double[n];
        
        for (int i = 0; i < n; ++i) {
            xx[i] = x[i];
            yy[i] = y[i];
        }
        
        for (int j = 0; j < k; ++j) {
            for (int i = 0; i < n; ++i) {
                int u = (i + 1) % n;
                xxt[i] = (xx[i] + xx[u]) / 2.0;
                yyt[i] = (yy[i] + yy[u]) / 2.0;
            }
            double[] tt;
            tt = xx; xx = xxt; xxt = tt;
            tt = yy; yy = yyt; yyt = tt;
        }
        
        double perim = 0;
        for (int i = 0; i < n; ++i) {
            int j = (i + 1) % n;
            perim += Math.sqrt((xx[i] - xx[j]) * (xx[i] - xx[j]) + (yy[i] - yy[j]) * (yy[i] - yy[j]));
        }
        
        PrintWriter out = new PrintWriter("dual.out");
        out.println(perim);
        out.close();
    }
}
