//  ""
// 1- -  2008-2009,  
//  :  , tsarev@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class indic_sm extends Thread{
	public static final int[] CNT = {6,2,5,5,4,5,6,3,7,6};
	int[][][] cmin;
	int min(int n,int k,int first) {
		if (n<0 || k<0)return -1;
		if (cmin[n][k][first]!=-1) {
			return cmin[n][k][first];
		}
		for (int i = first; i <= 9; i++) {
			int p = min(n-1,k-CNT[i],0);
			if (p<0)continue;
			return cmin[n][k][first] = i;			
		}
		return cmin[n][k][first] = -2;
	}
	int[][][] cmax;
	int max(int n,int k,int first) {
		if (n<0 || k<0)return -1;
		if (cmax[n][k][first]!=-1) {
			return cmax[n][k][first];
		}
		for (int i = 9; i >= first; i--) {
			int p = max(n-1,k-CNT[i],0);
			if (p<0)continue;
			return cmax[n][k][first] = i;			
		}
		return cmax[n][k][first] = -2;
	}
	
	void init(int[][][] arr) {
		for (int i = 0; i < arr.length; i++) {
			for (int j = 0; j < arr[0].length; j++) {
				Arrays.fill(arr[i][j], -1);
			}
		}
		arr[0][0][0] = 0;
	}
	
	void restore(int[][][] arr) {
		int j = k;
		int fir = 1;
		for (int i = n; i >0 ; i--) {
			out.print((char)('0'+arr[i][j][fir]));
			j-=CNT[arr[i][j][fir]];
			fir = 0; 
		}
		out.println();
	}
	int n,k;
	void solve() {
		n = in.nextInt();
		k = in.nextInt();
		myAssert(1<=n && n<=100);
		myAssert(1<=k && k<=700);
		
		cmin = new int[n+1][k+1][2];
		init(cmin);
		min(n,k,1);
		if (cmin[n][k][1]<0) {
			out.println("NO SOLUTION");
			return;
		}
		restore(cmin);
		
		cmax= new int[n+1][k+1][2];
		init(cmax);
		max(n,k,1);
		restore(cmax);
		
		
	}
	
	void myAssert(boolean b) {
		if (!b)throw new AssertionError();
	}
	Scanner in;
	PrintWriter out;
	public void run() {
		try {
			in = new Scanner(new File("indic.in"));
			out = new PrintWriter(new File("indic.out"));
			solve();
			out.flush();
			out.close();
//			new FilePrinter("indic.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}
	
	public static void main(String[] args) {
		new indic_sm().start();
	}

}
