import java.io.*;
import java.util.*;

public class casino_as implements Runnable {
    int n;
    int m;
    int s;
    double[] p;
    int[] w;

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("casino.in"));
        PrintWriter out = new PrintWriter(new File("casino.out"));

        n = in.nextInt();
        m = in.nextInt();
        s = in.nextInt();

        p = new double[m];
        w = new int[m];
        for (int i = 0; i < m; i++) {
            p[i] = 1.0 * in.nextInt() / s;
            w[i] = in.nextInt();
        }

        double[] x = new double[n];
        for (int iter = 0; iter < 100000; iter++) {
            for (int i = 0; i < n; i++) {
                double best = 0;
                for (int j = 0; j < m; j++) {
                    double v = 0;
                    if (i + w[j] >= n) {
                        v += p[j];
                    } else {
                        v += p[j] * x[i + w[j]];
                    }
                    if (i > 0) {
                        v += (1 - p[j]) * x[i - 1];
                    }
                    if (v > best) {
                        best = v;
                    }
                }
                x[i] = best;
            }
        }

        System.out.println(x[n - 1]);
        out.println(x[n - 1]);

        in.close();
        out.close();
    }

    @Override
    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] s) {
        Locale.setDefault(Locale.US);
        new Thread(new casino_as()).start();
    }
}