import java.io.*;
import java.util.*;

public class casino_as_wrong2 implements Runnable {
    int n;
    int m;
    int s;
    double[] p;
    int[] w;

    int[] map;

    double best;

    final private double EPS = 1e-9;

    public class LinearSystem {
        public double[][] a;
        public double[] b;
        public double[] x;

        public LinearSystem(double[][] a, double[] b) {
            this.a = a;
            this.b = b;
        }

        public boolean solve() {
            int n = a.length;
            x = new double[n];
            for (int i = 0; i < n; i++) {
                int k = -1;
                for (int j = i; j < n; j++) {
                    if (Math.abs(a[i][j]) > EPS) {
                        k = j;
                        break;
                    }
                }
                if (k == -1) {
                    return false;
                }
                for (int j = 0; j < n; j++) {
                    double t = a[i][j];
                    a[i][j] = a[k][j];
                    a[k][j] = t;
                }
                double t1 = b[i]; b[i] = b[k]; b[k] = t1;

                for (int j = 0; j < n; j++) if (j != i) {
                    double t = a[j][i];
                    for (int l = 0; l < n; l++) {
                        a[j][l] = a[j][l] - t / a[i][i] * a[i][l];
                    }
                    b[j] = b[j] - t / a[i][i] * b[i];
                }
                for (int j = 0; j < n; j++) if (j != i) {
                    assert (Math.abs(a[j][i]) < EPS);
                }
            }

            for (int i = 0; i < n; i++) {
                x[i] = b[i] / a[i][i];
            }
            return true;
        }
    }



    void check() {
        double[][] a = new double[n][n];
        double[] b = new double[n];

        for (int i = 0; i < n; i++) {
            a[i][i] = 1;
            if (i + w[map[i]] >= n) {
                b[i] = p[map[i]];
            } else {
                a[i][i + w[map[i]]] = -p[map[i]];
            }
            if (i > 0) {
                a[i][i - 1] = -(1 - p[map[i]]);
            }
        }

        LinearSystem ls = new LinearSystem(a, b);
        ls.solve();

        if (ls.x[n - 1] > best) {
            for (int i : map) {
                System.out.print((w[i]) + " ");
            }
            System.out.println(ls.x[n - 1]);
            best = ls.x[n - 1];
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("casino.in"));
        PrintWriter out = new PrintWriter(new File("casino.out"));

        n = in.nextInt();
        m = in.nextInt();
        s = in.nextInt();

        p = new double[m];
        w = new int[m];
        for (int i = 0; i < m; i++) {
            p[i] = 1.0 * in.nextInt() / s;
            w[i] = in.nextInt();
        }

        map = new int[n];
        double[] x = new double[n];
        for (int i = n - 1; i >= 0; i--) {
            double bw = 0;
            for (int j = 0; j < m; j++) {
                double pw = p[j];
                if (i + w[j] < n) {
                    pw = p[j] * x[i + w[j]];
                }
                if (pw > bw) {
                    bw = pw;
                    map[i] = j;
                }
            }


            double[][] a = new double[n - i][n - i];
            double[] b = new double[n - i];

            for (int k = i; k < n; k++) {
                a[k - i][k - i] = 1;
                if (k + w[map[k]] >= n) {
                    b[k - i] = p[map[k]];
                } else {
                    a[k -  i][k + w[map[k]] - i] = -p[map[k]];
                }
                if (k > i) {
                    a[k - i][k - i - 1] = -(1 - p[map[k]]);
                }
            }

            LinearSystem ls = new LinearSystem(a, b);
            ls.solve();

            for (int k = i; k < n; k++) {
                x[k] = ls.x[k - i];
            }
        }

        check();

        out.println(best);

        in.close();
        out.close();
    }

    @Override
    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] s) {
        Locale.setDefault(Locale.US);
        new Thread(new casino_as_wrong2()).start();
    }
}