import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class discuss_as implements Runnable {
    int maxn;
    BigInteger bmaxn;
    BigInteger[][] c;

    BigInteger choose(BigInteger n, int k) {
        if (k <= maxn) {
            if (n.compareTo(bmaxn) <= 0) {
                return c[n.intValue()][k];
            }
        }
        BigInteger r = BigInteger.ONE;
        for (int i = 0; i < k; i++) {
            r = r.multiply(n);
            n = n.subtract(BigInteger.ONE);
        }
        for (int i = 0; i < k; i++) {
            r = r.divide(BigInteger.valueOf(i + 1));
        }
        return r;
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("discuss.in"));
        PrintWriter out = new PrintWriter(new File("discuss.out"));

        maxn = 100;
        c = new BigInteger[maxn + 1][maxn + 1];
        Arrays.fill(c[0], BigInteger.ZERO);
        c[0][0] = BigInteger.ONE;

        for (int i = 1; i <= maxn; i++) {
            c[i][0] = BigInteger.ONE;
            for (int j = 1; j <= maxn; j++) {
                c[i][j] = c[i - 1][j - 1].add(c[i - 1][j]);
            }
        }

        bmaxn = BigInteger.valueOf(maxn);

        BigInteger z = in.nextBigInteger();

        BigInteger topR = z.add(BigInteger.ONE);

        BigInteger bestN = z;

        for (int k = 1; true; k++) {
//            System.out.println(k);
            BigInteger l = BigInteger.valueOf(k);
            BigInteger r = topR;
            while (r.subtract(l).compareTo(BigInteger.ONE) > 0) {
                BigInteger m = l.add(r).shiftRight(1);
                BigInteger v = choose(m, k);
                if (v.compareTo(z) <= 0) {
                    l = m;
                } else {
                    r = m;
                }
            }

            if (choose(l, k).equals(z)) {
                if (l.compareTo(bestN) < 0) {
                    bestN = l;
                }
            }

            if (l.compareTo(BigInteger.valueOf(2 * k)) < 0) {
                break;
            }
            topR = l.add(BigInteger.ONE);
        }

        out.println(bestN);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new discuss_as()).start();
    }
}
