import java.util.*;
import java.io.*;

public class game_as_wrong implements Runnable {
    int[][] next;
    int[] suf;
    int[] par;
    int[] via;
    ArrayList<Integer>[] dsuf;
    boolean[] term;
    int[] win;
    int nc;

    void insert(String s, int f, boolean makeTerm) {
        int c = 0;
        for (int i = f; i < s.length(); i++) {
            int v = s.charAt(i) - 33;
            if (next[c][v] == -1) {
                next[c][v] = nc;
                par[nc] = c;
                via[nc] = v;
                Arrays.fill(next[nc], -1);
                nc++;
            }
            c = next[c][v];
        }

        if (makeTerm) {
            term[c] = true;
        }
    }

    int winner(int v) {
        if (term[v]) {
            return win[v] = 1;
        } else {
            if (win[v] != 0) {
                return win[v];
            }

            for (int i = 0; i < next[v].length; i++) {
                if (next[v][i] != -1) {
                    if (winner(next[v][i]) == -1) {
                        return win[v] = 1;
                    }
                }
            }
            if (dsuf[v] != null) {
                for (int x : dsuf[v]) {
                    if (winner(x) == -1) {
                        return win[v] = 1;
                    }
                }
            }
            return win[v] = -1;
        }
    }

    void dfs(int v) {
        if (suf[v] != -1) {
            return;
        }

        if (v != 0) {
            int p = par[v];
            if (p == 0) {
                suf[v] = 0;
            } else {
                int sl = next[suf[p]][via[v]];
                suf[v] = sl;
                if (dsuf[sl] == null) {
                    dsuf[sl] = new ArrayList<Integer>();
                }
                dsuf[sl].add(v);
            }
        }

        for (int c = 0; c < 126 - 32; c++) {
            if (next[v][c] != -1) {
                dfs(next[v][c]);
            }
        }
    }



    public void solve() throws IOException {
        Scanner in = new Scanner(new File("game.in"));
        PrintWriter out = new PrintWriter("game.out");

        int n = in.nextInt();
        long time = System.currentTimeMillis();
        String[] w = new String[n];
        int l = 1;
        for (int i = 0; i < n; i++) {
            w[i] = in.next();
            l += w[i].length() * (w[i].length() + 1) / 2;
        }
        
        time = System.currentTimeMillis() - time;
        System.out.println(time);
        time = System.currentTimeMillis();

        nc = 1;
        next = new int[l][126 - 32];
        Arrays.fill(next[0], -1);
        term = new boolean[l];
        par = new int[l];
        via = new int[l];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < w[i].length(); j++) {
                insert(w[i], j, true);
            }
        }

        time = System.currentTimeMillis() - time;
        System.out.println(time);
        time = System.currentTimeMillis();

        System.out.println(nc);

        suf = new int[l];
        Arrays.fill(suf, -1);
        dsuf = new ArrayList[l];
        dfs(0);

        time = System.currentTimeMillis() - time;
        System.out.println(time);
        time = System.currentTimeMillis();

        win = new int[l];
        int p = winner(0);
        if (p == 1) {
            out.println("First");
            for (int x = 0; x < next[0].length; x++) {
                if (next[0][x] != -1 && winner(next[0][x]) == -1) {
                    out.print((char) (x + 33));
                }
            }
            out.println();
        } else {
            out.println("Second");
        }
        time = System.currentTimeMillis() - time;
        System.out.println(time);
        time = System.currentTimeMillis();

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new game_as_wrong()).start();
    }
}
