import java.io.*;
import java.math.*;
import java.util.*;

public class battle3_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new battle3_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("battle3.in"));
			out = new PrintWriter("battle3.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int n = nextInt();
		myAssert(2 <= n && n <= 100, "n is out of bounds");
		int m = nextInt();
		myAssert(2 <= m && m <= 100, "m is out of bounds");
		char[][] tab = new char[n][];
		for (int i = 0; i < n; i++) {
			tab[i] = br.readLine().toCharArray();
			myAssert(tab[i].length == m, "line " + (i + 2) + " has length " + tab[i].length + " instead of " + m);
			for (int j = 0; j < m; j++) {
				myAssert(tab[i][j] == '.' || tab[i][j] == '#', "Unknow symbol " + tab[i][j] + " at line " + (i + 2) + " at column " + (j + 1));
			}
		}
		int k = nextInt();
		myAssert(1 <= k && k <= 5, "k is out of bounds"); 		
		int ans = 0;
		
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				boolean good = true;
				for (int q = 0; q < k; q++) {
					if (i + q >= n || tab[i + q][j] == '#') {
						good = false;
						break;
					}
				}
				if (good) ++ans;
				good = true;
				for (int q = 0; q < k; q++) {
					if (j + q >= m || tab[i][j + q] == '#') {
						good = false;
						break;
					}
				}
				if (good) ++ans;
			}
		}
		
		out.println(ans);
		
	}
}
