//  ""
// 3- -  2008-2009,  
//  :  
//  :  , melnikov@rain.ifmo.ru

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class quadr_sm extends Thread {
	class Point {
		int x, y;

		public Point(int x, int y) {
			this.x = x;
			this.y = y;
		}

		int dist2(Point p) {
			return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
		}
	}

	class Vector {
		int x, y;

		public Vector(Point a, Point b) {
			x = b.x - a.x;
			y = b.y - a.y;
		}

		int mulVec(Vector v) {
			return x * v.y - y * v.x;
		}

		int mulScalar(Vector v) {
			return x * v.x + y * v.y;
		}
	}

	boolean gen(int s) {
		if (s == 4) {
			int d = points[permut[0]].dist2(points[permut[3]]);
			for (int i = 0; i < 3; i++) {
				if (d != points[permut[i]].dist2(points[permut[i + 1]])) {
					return false;
				}
			}
			for (int i = 0; i < 4; i++) {
				Point a = points[permut[i]];
				Point b = points[permut[(i + 1) % 4]];
				Point c = points[permut[(i + 2) % 4]];
				Vector v1 = new Vector(a, b);
				Vector v2 = new Vector(b, c);
				if (v1.mulScalar(v2) != 0) {
					return false;
				}
				if (v1.mulVec(v2) != d) {
					return false;
				}
			}
			return true;
		}
		fori: for (int i = 0; i < 4; i++) {
			for (int j = 0; j < s; j++) {
				if (permut[j] == i) {
					continue fori;
				}
			}
			permut[s] = i;
			if (gen(s + 1)) {
				return true;
			}
		}
		return false;
	}

	int permut[];
	Point[] points;

	void solve() throws IOException {
		points = new Point[4];
		for (int i = 0; i < 4; i++) {
			String[] s = in.readLine().split(" ");
			myAssert(s.length == 2);
			int x = Integer.parseInt(s[0]);
			myAssert(Math.abs(x) <= 1000);
			int y = Integer.parseInt(s[1]);
			myAssert(Math.abs(y) <= 1000);
			points[i] = new Point(x, y);
		}
		myAssert(in.read() == -1);
		permut = new int[4];
		boolean found = gen(0);
		if (found) {
			out.println("YES");
		} else {
			out.println("NO");
		}
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	BufferedReader in;
	PrintWriter out;

	public void run() {
		try {
			in = new BufferedReader(new FileReader("quadr.in"));
			out = new PrintWriter(new File("quadr.out"));
			solve();
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new quadr_sm().start();
	}

}
