//  ""
// 3- -  2008-2009,  
//  :  
//  :  , melnikov@rain.ifmo.ru
//   -      

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class quadr_sm_heuristic1 extends Thread {
	class Point {
		int x, y;

		public Point(int x, int y) {
			this.x = x;
			this.y = y;
		}

		int dist2(Point p) {
			return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
		}
	}

	
	
	Point[] points;

	void solve() throws IOException {
		points = new Point[4];
		for (int i = 0; i < 4; i++) {
			String[] s = in.readLine().split(" ");
			myAssert(s.length == 2);
			int x = Integer.parseInt(s[0]);
			myAssert(Math.abs(x) <= 1000);
			int y = Integer.parseInt(s[1]);
			myAssert(Math.abs(y) <= 1000);
			points[i] = new Point(x, y);
		}
		myAssert(in.read() == -1);
		int d[] = new int[6];
		int p = 0;
		for (int i = 0; i < 4; i++) {
			for (int j = i+1; j < 4; j++) {
				d[p++] = points[i].dist2(points[j]);
			}
		}
		Arrays.sort(d);
		boolean found = (d[0] == d[1] && d[0] == d[2] && d[0] == d[3]
				&& 2 * d[0] == d[4] && 2 * d[0] == d[5]);
		if (found) {
			out.println("YES");
		} else {
			out.println("NO");
		}
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	BufferedReader in;
	PrintWriter out;

	public void run() {
		try {
			in = new BufferedReader(new FileReader("quadr.in"));
			out = new PrintWriter(new File("quadr.out"));
			solve();
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new quadr_sm_heuristic1().start();
	}

}
