import java.util.*;
import java.io.*;

public class nothingontv_as_good implements Runnable {
    BufferedReader in;
    StringTokenizer st;

    int nextInt() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(in.readLine());
            } catch (IOException e) {
            }
        }
        return Integer.parseInt(st.nextToken());
    }

    class Point {
        final double x;
        final double y;
        final double l;
        int id;

        public Point(double x, double y) {
            this.x = x;
            this.y = y;
            this.l = x * x + y * y;
        }

        @Override
        public String toString() {
            return "(" + x + "," + y + ")";
        }
    }

	
    public void solve() throws IOException {
        in = new BufferedReader(new FileReader("nothingontv.in"));
        PrintWriter out = new PrintWriter("nothingontv.out");

        int n = nextInt();
        Point[] p = new Point[n];
        for (int i = 0; i < n; i++) {
            p[i] = new Point(nextInt(), nextInt());
            p[i].id = i + 1;
        }
        Arrays.sort(p, new Comparator<Point>() {
            public int compare(Point o1, Point o2) {
                return o1.l < o2.l ? -1 : o1.l > o2.l ? 1 : 0;
            }
        });

        ArrayList<Integer> answer = new ArrayList<Integer>();
        boolean[] good = new boolean[n];
        ArrayList<Point> pts = new ArrayList<Point>();
        for (int i = 0; i < n; i++) {
            good[i] = true;
            for (Point q : pts) {
                if ((q.x * q.x + q.y * q.y + (p[i].x - q.x) * (p[i].x - q.x) + (p[i].y - q.y) * (p[i].y - q.y)) <= p[i].x * p[i].x + p[i].y * p[i].y) {
                    good[i] = false;
                    break;
                }
            }
            if (good[i]) {
                answer.add(p[i].id);
                pts.add(p[i]);
            }
        }

        Collections.sort(answer);
        out.println(answer.size());
        for (int i : answer) {
            out.print(i + " ");
        }
        out.println();


        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new nothingontv_as_good()).start();
    }
}