//  " "
//      
//  :  ,  ,  ; <>, argentony@gmail.com, fedor.tsarev@gmail.com
//  :  , nosenkomax@gmail.com
//     - 
//      check-MN =)

import java.util.*;
import java.io.*;

public class alhazen_mn implements Runnable {

	public static void main(String args[]) {
		new Thread(new alhazen_mn()).start();
	}

	Scanner in;
	PrintWriter out;
	private String FNAME = "alhazen";

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new Scanner(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			in.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}

	public void touch(double x, double y, int pMin, int pMax) {
		double d = Math.sqrt(x * x + y * y);
		double phi = Math.acos(r / d);
		double theta = Math.atan2(y, x);
		p[pMin] = theta - phi;
		p[pMax] = theta + phi;
	}

	final double EPS = 1e-9;
	final int bsNum = 10000;

	double phi;
	double p[];
	
	int x[] ,y[];
	int r;

	private void solve() {
		int n = in.nextInt();
		for (int i = 0; i < n; i++) {
		
			x = new int[2];
			y = new int[2];
			r = in.nextInt();
			x[0] = in.nextInt();
			y[0] = in.nextInt();
			x[1] = in.nextInt();
			y[1] = in.nextInt();
			
			My_Assert(1 <= r && r <= 1000, "r out of range: " + r + " test # " + (i + 1));
			My_Assert(-10000 <= x[0] && x[0] <= 10000, "x1 out of range: " + x[0] + " test # " + (i + 1));
			My_Assert(-10000 <= y[0] && y[0] <= 10000, "x1 out of range: " + y[0] + " test # " + (i + 1));
			My_Assert(-10000 <= x[1] && x[1] <= 10000, "x1 out of range: " + x[1] + " test # " + (i + 1));
			My_Assert(-10000 <= y[1] && y[1] <= 10000, "x1 out of range: " + y[1] + " test # " + (i + 1));
			My_Assert(x[0]*x[0] + y[0]*y[0] > r*r, "First point is within circle" + " test # " + (i + 1));
			My_Assert(x[1]*x[1] + y[1]*y[1] > r*r, "Second point is within circle" + " test # " + (i + 1));
			
			p = new double[4];
			touch(x[0], y[0], 0, 2);
			touch(x[1], y[1], 1, 3);
			
			double pMin, pMax;
			pMin = Math.max(p[0], p[1]);
			pMax = Math.min(p[2], p[3]);
			
			if (pMin > pMax + EPS) {
				if (p[0] < p[1]) {
					p[0] += 2*Math.PI;
					p[2] += 2*Math.PI;
				} else {
					p[1] += 2*Math.PI;
					p[3] += 2*Math.PI;
				}
				pMin = Math.max(p[0], p[1]);
				pMax = Math.min(p[2], p[3]);
			}
			My_Assert(pMin <= pMax + EPS, "Bad Input - this point does't exist" + " test # " + (i + 1));
		        
			find(pMin, pMax);
			
			double x = Math.cos(phi) * r;
			double y = Math.sin(phi) * r;
			
			out.println(x + " " + y);
		}
	}

	public double dist(double phi, double x, double y) {
		return Math.sqrt((x - r * Math.cos(phi)) * (x - r * Math.cos(phi))
				+ (y - r * Math.sin(phi)) * (y - r * Math.sin(phi)));
	}
	
	public double diff(int i, double phi) {
		return (x[i] * Math.sin(phi) - y[i] * Math.cos(phi)) / dist(phi, x[i] ,y[i]);
	}
	
	public double sdiff(double phi) {
		return diff(0, phi) + diff(1, phi);
	}
	
	public boolean diffSign(double a, double b) {
		if (Math.abs(a) <= EPS && Math.abs(b) <= EPS)
			return false;
		return Math.signum(a) * Math.signum(b) <= 0;
	}

	private void find(double l, double r) {
		 double dl = sdiff(l);
		 double dr = sdiff(r);
		 if (diffSign(dl, dr)) {
			 for (int i = 0; i < bsNum; i++) {
				 double m = (l + r) / 2;
				 double dm = sdiff(m);
				 if (diffSign(dm, dl)) {
					 r = m;
					 dr = dm;
				 } else {
					 l = m;
					 dl = dm;
				 }
			 }
			 phi =  l;
		 } else {
			 My_Assert(false, "Nothing found");
		 }
			 
	}
}