//  " "
// 5- -  2008-2009,  
//  :  
//  :  , melnikov@rain.ifmo.ru

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class alhazen_sm extends Thread {

	final double K = 500;

	double hypot(double x, double y) {
		return Math.sqrt(x * x + y * y);
	}

void solve() {
	int n = in.nextInt();
	myAssert(1 <= n && n <= 50);
	for (int it = 0; it < n; it++){
		int r = in.nextInt();
		myAssert(1 <= r && r <= 1000);
		int x1 = in.nextInt();
		myAssert(Math.abs(x1) <= 1e4);
		int y1 = in.nextInt();
		myAssert(Math.abs(y1) <= 1e4);
		myAssert(x1 * x1 + y1 * y1 > r * r);

		int x2 = in.nextInt();
		myAssert(Math.abs(x2) <= 1e4);
		int y2 = in.nextInt();
		myAssert(Math.abs(y2) <= 1e4);
		myAssert(x2 * x2 + y2 * y2 > r * r);

		double min = Long.MAX_VALUE;
		double mx = 0;
		double my = 0;
		for (int i = 0; i < K + 1; i++) {
			double la = (2 * Math.PI) / K * (i);
			double ra = (2 * Math.PI) / K * (i + 1);
			for (int j = 0; j < 200; j++) {
				double a1 = la + (ra - la) / 3;
				double a2 = ra - (ra - la) / 3;
				double xa1 = r * Math.cos(a1);
				double ya1 = r * Math.sin(a1);
				double xa2 = r * Math.cos(a2);
				double ya2 = r * Math.sin(a2);
				double l1 = hypot(x1 - xa1, y1 - ya1)
						+ hypot(x2 - xa1, y2 - ya1);
				double l2 = hypot(x1 - xa2, y1 - ya2)
						+ hypot(x2 - xa2, y2 - ya2);
				if (l1 < l2) {
					ra = a2;
				} else {
					la = a1;
				}
			}
			double x = r * Math.cos(la);
			double y = r * Math.sin(la);
			double rr = hypot(x1 - x, y1 - y) + hypot(x2 - x, y2 - y);
			// System.err.println(la+" "+x+" "+y+" "+rr);
			if (rr < min) {
				min = rr;
				mx = x;
				my = y;
			}
		}
		out.printf(Locale.US, " %.10f %.10f", mx, my);
	}
	//System.out.printf(Locale.US, " %.10f %.10f", mx, my);
}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	Scanner in;
	PrintWriter out;

	public void run() {
		try {
			in = new Scanner(new File("alhazen.in"));
			out = new PrintWriter(new File("alhazen.out"));
			solve();
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new alhazen_sm().start();
	}

}
