#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>

typedef long double extended;
typedef long long   ll;

int main()
{
    std::ifstream in("circles.in");
    std::ofstream out("circles.out");
    
    int x1, y1, x2, y2;
    in >> x1 >> y1 >> x2 >> y2;
    
    ll sq = ll(x1) * y2 - ll(x2) * y1;
    if (sq < 0) 
    {
        sq = -sq;
        std::swap(x1, x2);
        std::swap(y1, y2);
    }
    
    ll len1_2 = ll(x1) * x1 + ll(y1) * y1;
    ll len2_2 = ll(x2) * x2 + ll(y2) * y2;
    ll len12_2 = ll(x2 - x1) * (x2 - x1) + ll(y2 - y1) * (y2 - y1);
    
    extended len1 = sqrt(extended(len1_2));
    extended len2 = sqrt(extended(len2_2));
    extended len12 = sqrt(extended(len12_2));
    
    if (sq == 0)
    {
        if (ll(x1) * x2 + ll(y1) * y2 > 0) 
        {
            out << 1 + ll(floor(std::max(len1, len2))) - ll(ceil(std::min(len1, len2)));
        }
        else
        {
            out << ll(floor(len1)) + ll(floor(len2));
        }
    }
    else
    {
        ll smul1 = ll(x1) * (x2 - x1) + ll(y1) * (y2 - y1);
        ll smul2 = ll(x2) * (x2 - x1) + ll(y2) * (y2 - y1);
        
        if (smul1 < 0 && smul2 > 0) 
        {
            extended dist = extended(sq) / len12;
            extended distDown = floor(dist);
            
            ll branch1 = ll(floor(len1)) - ll(distDown);
            ll branch2 = ll(floor(len2)) - ll(distDown);
            
            if (distDown == dist)
            {
                out << 1 + branch1 + branch2;
            }
            else
            {
                out << branch1 + branch2;
            }
        }
        else
        {
            out << 1 + ll(floor(std::max(len1, len2))) - ll(ceil(std::min(len1, len2)));
        }
    }
    
    return 0;
}
