//  " "
// 5- -  2008-2009,  
//  :  
//  :  , melnikov@rain.ifmo.ru

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class roads_sm extends Thread {
	class Claim {
		int u, v, l, c;

		public Claim(int u, int v, int l, int c) {
			this.u = u;
			this.v = v;
			this.l = l;
			this.c = c;
		}
	}

	class Request {
		int a, b, c;

		public Request(int a, int b, int c) {
			this.a = a;
			this.b = b;
			this.c = c;
		}

	}

	Request[] requests;
	Claim[] claims;
	long dist[][];

	void solve() {
		int n = nextInt();
		myAssert(1 <= n && n <= 100);
		int m = nextInt();
		myAssert(0 <= m && m <= 10000);
		dist = new long[n][n];
		for (int i = 0; i < n; i++) {
			Arrays.fill(dist[i], Integer.MAX_VALUE);
		}
		for (int i = 0; i < m; i++) {
			int u = nextInt();
			myAssert(1 <= u && u <= n);
			int v = nextInt();
			myAssert(1 <= v && v <= n);
			myAssert(u != v);
			int l = nextInt();
			myAssert(0 <= l && l <= 10000);
			v--;
			u--;
			myAssert(dist[u][v] == Integer.MAX_VALUE);
			dist[u][v] = dist[v][u] = l;
		}
		int k = nextInt();
		myAssert(1 <= k && k <= 10000);
		claims = new Claim[k];
		for (int i = 0; i < k; i++) {
			int u = nextInt();
			myAssert(1 <= u && u <= n);
			int v = nextInt();
			myAssert(1 <= v && v <= n);
			myAssert(v != u);
			int l = nextInt();
			myAssert(1 <= l && l <= 10000);
			int c = nextInt();
			myAssert(1 <= c && c <= 1e9);
			v--;
			u--;
			myAssert(dist[u][v] == Integer.MAX_VALUE);
			//          
			// ,     .
			claims[i] = new Claim(u, v, l, c);
		}

		int p = nextInt();
		myAssert(1 <= p && p <= 1000);
		requests = new Request[p];
		for (int i = 0; i < p; i++) {
			int a = nextInt();
			myAssert(1 <= a && a <= n);
			int b = nextInt();
			myAssert(1 <= b && b <= n);
			myAssert(a != b);
			a--;
			b--;
			int c = nextInt();
			myAssert(1 <= c && c <= 1e8);
			requests[i] = new Request(a, b, c);
		}
		pp = new long[dist.length][dist.length];
		if (!can((long) 1e9)) {
			out.println(-1);
			return;
		}
		if (can(0)) {
			out.println(0);
			//out.println(0); // only for checker purpose
			return;
		}
		long max = (long) 1e9;
		long min = 0;
		while (min + 1 < max) {
			long mid = (min + max) / 2;
			if (can(mid)) {
				max = mid;
			} else {
				min = mid;
			}
		}
		int cnt = 0;
		for (int i = 0; i < claims.length; i++) {
			if (claims[i].c <= max) {
				cnt++;
			}
		}
		out.println(cnt);
		for (int i = 0; i < claims.length; i++) {
			if (claims[i].c <= max) {
				out.print((i + 1) + " ");
			}
		}
		//out.println("\n" + max); // only for checker purpose
	}

	long pp[][];

	boolean can(long cost) {

		for (int i = 0; i < pp.length; i++) {
			for (int j = 0; j < pp[0].length; j++) {
				pp[i][j] = dist[i][j];
			}
		}
		for (int i = 0; i < claims.length; i++) {
			if (claims[i].c <= cost) {
				pp[claims[i].u][claims[i].v] = pp[claims[i].v][claims[i].u] = Math
						.min(pp[claims[i].u][claims[i].v], claims[i].l);
			}
		}
		for (int k = 0; k < pp.length; k++) {
			for (int i = 0; i < pp.length; i++) {
				for (int j = 0; j < pp.length; j++) {
					if (pp[i][j] > pp[i][k] + pp[k][j]) {
						pp[i][j] = pp[i][k] + pp[k][j];
					}
				}
			}
		}
		for (int i = 0; i < requests.length; i++) {
			if (pp[requests[i].a][requests[i].b] > requests[i].c) {
				return false;
			}
		}
		return true;
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	public static void main(String[] args) {
		new Thread(new roads_sm()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	public void run() {

		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader("roads.in"));
			out = new PrintWriter("roads.out");
			solve();
			br.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();

		}

	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

}
