//  "᫮  ᫥⥫쭮⥩"
// 5- ୥- ᥧ 2008-2009, ᫮ ஢.
//  :   ॢ, tsarev@rain.ifmo.ru
//  襭:  ॢ, tsarev@rain.ifmo.ru 

import java.io.*;
import java.util.*;

public class subseq_ft implements Runnable {

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               

	class SegTree {
		int[] a;
		int n;
		int base;
		public SegTree(int m) {
			n = 1;
			while (n < m) {
				n *= 2;
			}
			base = n;
			n *= 2;
			a = new int[n];	
		}

		void put(int pos, int x) {
			pos += base;
			while (pos > 1) {
				a[pos] = Math.max(a[pos], x);
				pos /= 2;
			}
		}

		int get(int l, int r) {
			l += base;
			r += base;
			int res = 0;
			while (l < r) {
				if (l % 2 == 1) {
					res = Math.max(res, a[l]);
				}
				if (r % 2 == 0) {
					res = Math.max(res, a[r]);
				}
				l = (l + 1) / 2;
				r = (r - 1) / 2;
			}
			res = Math.max(res, a[l]);
			return res;
		}
			
	}

	private final static int MOD = (int) 1e9 + 7;

	void solve() throws NumberFormatException, IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 100000, "n is out of range: " + n);
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
			myAssert(Math.abs(a[i]) <= 1000000000, "a[" + i + "] is out of range: " + a[i]);
		}
		HashSet<Integer> set = new HashSet<Integer>();
		for (int x : a) {
			set.add(x);
		}
		ArrayList<Integer> list = new ArrayList<Integer>();
		for (int x : set) {
			list.add(x);
		}
		Collections.sort(list);
		HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
		for (int i = 0; i < list.size(); i++) {
			map.put(list.get(i), i);
		}
		for (int i = 0; i < n; i++) {
			a[i] = map.get(a[i]);
		}
		for (int i = 0; i < n; i++) {
			System.out.print(a[i] + " ");
		}
		SegTree st = new SegTree(list.size());
		int[] len = new int[n];
		int maxLen = -1;
		for (int i = 0; i < n; i++) {
			if (a[i] == 0) {
				len[i] = 1;
			} else {
				len[i] = st.get(0, a[i] - 1) + 1;
			}
			st.put(a[i], len[i]);
			maxLen = Math.max(maxLen, len[i]);
		}
		int[] cnt = new int[n + 1];
		cnt[0] = 1;
		for (int i = 0; i < n; i++) {
			cnt[len[i]] += cnt[len[i] - 1];
			cnt[len[i]] %= MOD;
		}
		out.println(cnt[maxLen]);
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new Thread(new subseq_ft("subseq")).start();
	}

	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;
	
	public subseq_ft(String fname) throws IOException {
		in = new BufferedReader(new FileReader(fname + ".in"));
		st = new StringTokenizer("");
		out = new PrintWriter(new FileWriter(fname + ".out"));
	}
	
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			apstenu(e);
		} finally {
			out.close();
		}
	}

	private void apstenu(Exception e) {
		e.printStackTrace();
		System.exit(1);
	}
	
}
