// " "
//5- -  2008-2009,  .
//  -  , buzdalov@rain.ifmo.ru
//  -  , buzdalov@rain.ifmo.ru

//,        abcd00000...abcd99999
//   : O(N^3),  N -  

import java.io.*;
import java.util.*;
import java.math.*;

public class tickets_mb {
    private static long[] costs;
    private static long answer;
    private static char d;
    private static long[][] C;
    private static long[] ninePow;

    private static void count(char[] left, char[] right, int suffixStart, int happyDigitsInPrefix) {
        if (Arrays.equals(left, right)) {
            int happyAdd = happyDigitsInPrefix;
            for (int i = suffixStart; i < left.length; ++i) {
                if (left[i] == d) {
                    ++happyAdd;
                }
            }
            answer += costs[happyAdd];
        } else {
            char start = left[suffixStart];
            for (int i = suffixStart + 1; i < left.length; ++i) {
                if (left[i] != '0') {
                    start++;
                    break;
                }
            }
            char finish = right[suffixStart];
            for (int i = suffixStart + 1; i < right.length; ++i) {
                if (right[i] != '9') {
                    finish--;
                    break;
                }
            }
            for (char mid = start; mid <= finish; ++mid) {
                int happyAdd = happyDigitsInPrefix + (mid == d ? 1 : 0);
                int suffixLength = left.length - suffixStart - 1;
                for (int i = 0; i <= suffixLength; ++i) {
                    long count = C[suffixLength][i] * ninePow[suffixLength - i];
                    answer += count * costs[i + happyAdd];
                }
            }

            if (left[suffixStart] == right[suffixStart] && start != finish) {
                count(left, right, suffixStart + 1, happyDigitsInPrefix + (left[suffixStart] == d ? 1 : 0));
            } else {
                char[] tmp;
                if (start != left[suffixStart]) {
                    tmp = left.clone();
                    for (int i = suffixStart + 1; i < tmp.length; ++i) {
                        tmp[i] = '9';
                    }
                    count(left, tmp, suffixStart + 1, happyDigitsInPrefix + (left[suffixStart] == d ? 1 : 0));
                }
                if (finish != right[suffixStart]) {
                    tmp = right.clone();
                    for (int i = suffixStart + 1; i < tmp.length; ++i) {
                        tmp[i] = '0';
                    }
                    count(tmp, right, suffixStart + 1, happyDigitsInPrefix + (right[suffixStart] == d ? 1 : 0));
                }
            }
        }
    }

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("tickets.in"));
        PrintWriter out = new PrintWriter("tickets.out");

        int nn = in.nextInt();
        int c = in.nextInt();
        d = in.next().charAt(0);
        int p = in.nextInt();

        final int maxn = 13;

        C = new long[maxn + 1][];
        for (int i = 0; i <= maxn; ++i) {
            C[i] = new long[i + 1];
            C[i][0] = C[i][i] = 1;
            for (int j = 1; j < i; ++j) {
                C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
            }
        }

        ninePow = new long[maxn + 1];
        ninePow[0] = 1;
        for (int i = 1; i <= maxn; ++i) {
            ninePow[i] = ninePow[i - 1] * 9;
        }

        costs = new long[maxn + 1];
        for (int i = 0; i <= maxn; ++i) {
            costs[i] = (int) (c * Math.pow(1 - p / 100.0, i));
        }

        for (int tt = 0; tt < nn; ++tt) {
            char[] start = in.next().toCharArray();
            char[] finish = in.next().toCharArray();

            assert start.length == finish.length : "Lengths differ";
            assert 1 <= start.length && start.length <= maxn : "Lengths are out of bounds";
            assert 1 <= c && c <= 10000 : "C is out of bounds";
            assert '0' <= d && d <= '9' : "d is out of bounds";
            assert 0 <= p && p <= 100 : "p is out of bounds";

            int n = start.length;

            for (int i = 0; i < n; ++i) {
                char cs = start[i];
                char ce = finish[i];
                assert '0' <= cs && cs <= '9': "Illegal character \"" + cs + "\" in first number";
                assert '0' <= ce && ce <= '9': "Illegal character \"" + ce + "\" in second number";
            }

            answer = 0;

            count(start, finish, 0, 0);

            out.println(answer);
        }

        in.close();
        out.close();
    }
}
