// " "
//3- -  2008-2009,  
// :  , ulyantsev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class point_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new point_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	long inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
		return x;
	}

	String FNAME = "point_aa_tri".substring(0, "point_aa_tri".indexOf('_'));

	private void solve() throws IOException {
		long bound = 1000000000;
		long x1 = inBounds(nextLong(), -bound, bound, "x1");
		long y1 = inBounds(nextLong(), -bound, bound, "y1");
		long x2 = inBounds(nextLong(), -bound, bound, "x2");
		long y2 = inBounds(nextLong(), -bound, bound, "y2");
		long x0 = inBounds(nextLong(), -bound, bound, "x0");
		long y0 = inBounds(nextLong(), -bound, bound, "y0");
		long dx = inBounds(nextLong(), -bound, bound, "x01") - x0;
		long dy = inBounds(nextLong(), -bound, bound, "x01") - y0;
		// System.out.println(Math.sqrt((x1 - x0) * (x1 - x0) + (y1 - y0)
		// * (y1 - y0))
		// + Math.sqrt((x2 - x0) * (x2 - x0) + (y2 - y0) * (y2 - y0)));
		// System.out.println(Math.sqrt((x1 - x0 - dx) * (x1 - x0 - dx)
		// + (y1 - y0 - dy) * (y1 - y0 - dy))
		// + Math.sqrt((x2 - x0 - dx) * (x2 - x0 - dx) + (y2 - y0 - dy)
		// * (y2 - y0 - dy)));
		long l = Math.min(dx == 0 ? 0 : (-bound - x0) / Math.abs(dx),
				dy == 0 ? 0 : (-bound - y0) / Math.abs(dy)) - 3;
		long r = Math.max(dx == 0 ? 0 : (bound - x0) / Math.abs(dx),
				dy == 0 ? 0 : (bound - y0) / Math.abs(dy)) + 3;
		while (r - l > 2) {
			long m1 = (2 * l + r) / 3;
			long m2 = (l + 2 * r) / 3;
			BigInteger xn1 = BigInteger.valueOf(x0 + dx * m1);
			BigInteger yn1 = BigInteger.valueOf(y0 + dy * m1);
			BigInteger xn2 = BigInteger.valueOf(x0 + dx * m2);
			BigInteger yn2 = BigInteger.valueOf(y0 + dy * m2);
			if (cmp(xn1.subtract(BigInteger.valueOf(x1)).pow(2).add(
					yn1.subtract(BigInteger.valueOf(y1)).pow(2)), xn1.subtract(
					BigInteger.valueOf(x2)).pow(2).add(
					yn1.subtract(BigInteger.valueOf(y2)).pow(2)), xn2.subtract(
					BigInteger.valueOf(x1)).pow(2).add(
					yn2.subtract(BigInteger.valueOf(y1)).pow(2)), xn2.subtract(
					BigInteger.valueOf(x2)).pow(2).add(
					yn2.subtract(BigInteger.valueOf(y2)).pow(2))) < 0) {
				r = m2;
			} else {
				l = m1;
			}
		}
		long ans = l;
		while (l < r) {
			BigInteger xn1 = BigInteger.valueOf(x0 + dx * ans);
			BigInteger yn1 = BigInteger.valueOf(y0 + dy * ans);
			BigInteger xn2 = BigInteger.valueOf(x0 + dx * l);
			BigInteger yn2 = BigInteger.valueOf(y0 + dy * l);
			if (cmp(xn1.subtract(BigInteger.valueOf(x1)).pow(2).add(
					yn1.subtract(BigInteger.valueOf(y1)).pow(2)), xn1.subtract(
					BigInteger.valueOf(x2)).pow(2).add(
					yn1.subtract(BigInteger.valueOf(y2)).pow(2)), xn2.subtract(
					BigInteger.valueOf(x1)).pow(2).add(
					yn2.subtract(BigInteger.valueOf(y1)).pow(2)), xn2.subtract(
					BigInteger.valueOf(x2)).pow(2).add(
					yn2.subtract(BigInteger.valueOf(y2)).pow(2))) < 0) {

			} else {
				ans = l;
			}
			l++;
		}
		// System.out.println(Math.sqrt((x1 - x0 - dx * ans)
		// * (x1 - x0 - dx * ans) + (y1 - y0 - dy * ans)
		// * (y1 - y0 - dy * ans))
		// + Math.sqrt((x2 - x0 - dx * ans) * (x2 - x0 - dx * ans)
		// + (y2 - y0 - dy * ans) * (y2 - y0 - dy * ans)));
		out.println((x0 + dx * ans) + " " + (y0 + dy * ans));
	}

	private int cmp(BigInteger a, BigInteger b, BigInteger c, BigInteger d) {
		BigInteger tmp = a.add(b).subtract(c).subtract(d);
		if (tmp.compareTo(BigInteger.ZERO) >= 0) {
			if ((c.multiply(d)).compareTo(a.multiply(b)) < 0) {
				return 1;
			} else if (c.multiply(d).compareTo(a.multiply(b)) == 0) {
				return a.add(b).subtract(c).subtract(d).compareTo(
						BigInteger.ZERO);
			} else {
				BigInteger e = a.add(b).subtract(c).subtract(d).pow(2);
				BigInteger p = BigInteger.valueOf(4).multiply(a).multiply(b);
				BigInteger q = BigInteger.valueOf(4).multiply(c).multiply(d);
				BigInteger f = p.add(q).subtract(e);
				if (f.compareTo(BigInteger.ZERO) < 0) {
					return 1;
				} else if (f.compareTo(BigInteger.ZERO) == 0) {
					return a.equals(BigInteger.ZERO)
							|| b.equals(BigInteger.ZERO)
							|| c.equals(BigInteger.ZERO)
							|| d.equals(BigInteger.ZERO) ? 0 : 1;
				} else {
					return BigInteger.valueOf(64).multiply(a).multiply(b)
							.multiply(c).multiply(d).compareTo(f.pow(2));
				}
			}
		} else {
			return -cmp(c, d, a, b);
		}
	}
}
