/*
 * Trying to deal with precision loss.
 */
import java.io.*;
import java.math.*;
import java.util.*;

public class point_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new point_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("point.in"));
			out = new PrintWriter("point.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	final int MAX = (int)1e+9;
	
	BigDecimal sqRoot(BigDecimal x) {
		BigDecimal l = BigDecimal.ZERO;
		BigDecimal r = BigDecimal.valueOf(1e+22);
		for (int i = 0; i < 130; ++i) {
			BigDecimal m = l.add(r).divide(BigDecimal.valueOf(2));
			if (m.multiply(m).compareTo(x) <= 0) {
				l = m;
			} else {
				r = m;
			}
		}
		return l;
	}
	
	
	BigDecimal len(double x, double y) {
		BigDecimal bX = BigDecimal.valueOf(x); 
		BigDecimal bY = BigDecimal.valueOf(y); 
		BigDecimal ans = bX.multiply(bX).add(bY.multiply(bY));
		return sqRoot(ans);
	}
	
	BigDecimal getDist(double t) {
	//	System.out.println(1);
		double x = px + t * vx;
		double y = py + t * vy;
		return len(x1 - x, y1 - y).add(len(x2 - x, y2 - y));
	}
	
	double x1, y1, x2, y2, px, py, vx, vy;
	
	void solve() throws IOException {
		x1 = nextInt();
		myAssert(-MAX <= x1 && x1 <= MAX, "x1 out of bounds exception");
		y1 = nextInt();
		myAssert(-MAX <= y1 && y1 <= MAX, "y1 out of bounds exception");
		x2 = nextInt();
		myAssert(-MAX <= x2 && x2 <= MAX, "x2 out of bounds exception");
		y2 = nextInt();
		myAssert(-MAX <= y2 && y2 <= MAX, "y2 out of bounds exception");
		
		px = nextInt();
		myAssert(-MAX <= px && px <= MAX, "x1 out of bounds exception");
		py = nextInt();
		myAssert(-MAX <= py && py <= MAX, "y1 out of bounds exception");
		double px2 = nextInt();
		myAssert(-MAX <= px2 && px2 <= MAX, "x2 out of bounds exception");
		double py2 = nextInt();
		myAssert(-MAX <= py2 && py2 <= MAX, "y2 out of bounds exception");
		
		
		vx = px2 - px;
		vy = py2 - py;
		double l = Integer.MIN_VALUE * 3L;
		double r = Integer.MAX_VALUE * 3L;
		
		while (r - l > 0.3) {
			double ll = (2 * l + r) / 3;
			double rr = (l + 2 * r) / 3;
			if (getDist(ll).compareTo(getDist(rr)) < 0) {
				r = rr;
			} else {
				l = ll;
			}
		}
		BigDecimal down = getDist(Math.floor(l));
		BigDecimal up = getDist(Math.ceil(l));
		long t = Math.round(down.compareTo(up) < 0 ? Math.floor(l) : Math.ceil(l));
		out.printf("%.0f %.0f\n", px + vx * t, py + vy * t);
	}
}
