/*
 * Precision loss. Example:
 * 0 1000000000
 * 0 -1000000000
 * 5 0
 * 10 0
 */
import java.io.*;
import java.math.*;
import java.util.*;

public class point_af_wrong implements Runnable {
	public static void main(String[] args) {
		new Thread(new point_af_wrong()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("point.in"));
			out = new PrintWriter("point.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	final int MAX = (int)1e+9;
	
	double len(double x, double y) {
		return Math.sqrt(x * x + y * y);
	}
	
	double getDist(double t) {
		double x = px + t * vx;
		double y = py + t * vy;
		return len(x1 - x, y1 - y) + len(x2 - x, y2 - y);
	}
	
	double x1, y1, x2, y2, px, py, vx, vy;
	
	void solve() throws IOException {
		x1 = nextInt();
		myAssert(-MAX <= x1 && x1 <= MAX, "x1 out of bounds exception");
		y1 = nextInt();
		myAssert(-MAX <= y1 && y1 <= MAX, "y1 out of bounds exception");
		x2 = nextInt();
		myAssert(-MAX <= x2 && x2 <= MAX, "x2 out of bounds exception");
		y2 = nextInt();
		myAssert(-MAX <= y2 && y2 <= MAX, "y2 out of bounds exception");
		
		px = nextInt();
		myAssert(-MAX <= px && px <= MAX, "x1 out of bounds exception");
		py = nextInt();
		myAssert(-MAX <= py && py <= MAX, "y1 out of bounds exception");
		double px2 = nextInt();
		myAssert(-MAX <= px2 && px2 <= MAX, "x2 out of bounds exception");
		double py2 = nextInt();
		myAssert(-MAX <= py2 && py2 <= MAX, "y2 out of bounds exception");
		
		
		vx = px2 - px;
		vy = py2 - py;
		double l = Long.MIN_VALUE / 3;
		double r = Long.MAX_VALUE / 3;
		
		for (int i = 0; i < 1000; ++i) {
			double ll = (2 * l + r) / 3;
			double rr = (l + 2 * r) / 3;
			if (getDist(ll) < getDist(rr)) {
				r = rr;
			} else {
				l = ll;
			}
		}
	//	System.out.println(l + " " + r);
		long t = Math.round(getDist(Math.floor(l)) < getDist(Math.ceil(l)) ? Math.floor(l) : Math.ceil(l));
		out.printf("%.0f %.0f\n", px + vx * t, py + vy * t);
	}
}
