import java.io.*;
import java.math.*;
import java.util.*;

public class quadro_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new quadro_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("quadro.in"));
			out = new PrintWriter("quadro.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 50, "n out of bounds exception");
		int m = nextInt();
		myAssert(1 <= m && m <= 50, "m out of bounds exception");
		char[][] a = new char[n][];
		for (int i = 0; i < n; i++) {
			a[i] = nextToken().toCharArray();
			for (int j = 0; j < m; j++) {
				myAssert('a' <= a[i][j] && a[i][j] <= 'z', "a[i][j] out of bounds exception");
			}
		}

		int[][][][] D = new int[n + 1][n][m + 1][m];

		for (int li = 1; li <= n; ++li) {
			for (int i = 0; i + li <= n; ++i) {
				for (int lj = 1; lj <= m; ++lj) {
					for (int j = 0; j + lj <= m; ++j) {
						if (li == 1 && lj == 1) {
							D[li][i][lj][j] = 1;
							continue;
						}
						if (a[i][j] == a[i + li - 1][j + lj - 1]) {
							if (lj > 1) {
								D[li][i][lj][j] = 2 + D[li][i][lj - 2][j + 1];
								D[li][i][lj][j] = Math.max(D[li][i][lj][j], 2 + D[li - 1][i][lj - 1][j + 1]);
							}
							if (li > 1) {
								D[li][i][lj][j] = Math.max(D[li][i][lj][j], 2 + D[li - 1][i + 1][lj - 1][j]);
								D[li][i][lj][j] = Math.max(D[li][i][lj][j], 2 + D[li - 2][i + 1][lj][j]);
							}
						}
						if (lj > 1) {
							D[li][i][lj][j] = Math.max(D[li][i][lj][j], D[li][i][lj - 1][j + 1]);
							D[li][i][lj][j] = Math.max(D[li][i][lj][j], D[li][i][lj - 1][j]);
						}
						if (li > 1) {
							D[li][i][lj][j] = Math.max(D[li][i][lj][j], D[li - 1][i + 1][lj][j]);
							D[li][i][lj][j] = Math.max(D[li][i][lj][j], D[li - 1][i][lj][j]);
						}
					}
				}
			}
		}
		out.println(D[n][0][m][0]);
		ArrayList<Pair> stF = new ArrayList<Pair>();
		ArrayList<Pair> stB = new ArrayList<Pair>();
		{
			int li = n;
			int lj = m;
			int i = 0;
			int j = 0;
			while (li > 0 && lj > 0) {
				if (li == 1 && lj == 1) {
					stF.add(new Pair(i, j));
					li = 0;
				} else {
					if (a[i][j] == a[i + li - 1][j + lj - 1]) {
						if (lj > 1) {
							if (D[li][i][lj][j] == 2 + D[li][i][lj - 2][j + 1]) {
								stF.add(new Pair(i, j));
								stB.add(new Pair(i + li - 1, j + lj - 1));
								lj -= 2;
								++j;
								continue;
							}
							if (D[li][i][lj][j] == 2 + D[li - 1][i][lj - 1][j + 1]) {
								stF.add(new Pair(i, j));
								stB.add(new Pair(i + li - 1, j + lj - 1));
								--li;
								--lj;
								++j;
								continue;
							}
						}
						if (li > 1) {

							if (D[li][i][lj][j] == 2 + D[li - 1][i + 1][lj - 1][j]) {
								stF.add(new Pair(i, j));
								stB.add(new Pair(i + li - 1, j + lj - 1));
								--li;
								++i;
								--lj;
								continue;
							}
							if (D[li][i][lj][j] == 2 + D[li - 2][i + 1][lj][j]) {
								stF.add(new Pair(i, j));
								stB.add(new Pair(i + li - 1, j + lj - 1));
								li -= 2;
								++i;
								continue;
							}
						}
					}
					if (lj > 1) {
						if (D[li][i][lj][j] == D[li][i][lj - 1][j + 1]) {
							--lj;
							++j;
							continue;
						}
						if (D[li][i][lj][j] == D[li][i][lj - 1][j]) {
							--lj;
							continue;
						}
					}
					if (li > 1) {
						if (D[li][i][lj][j] == D[li - 1][i + 1][lj][j]) {
							--li;
							++i;
							continue;
						}
						if (D[li][i][lj][j] == D[li - 1][i][lj][j]) {
							--li;
							continue;
						}
					}
				}
			}
		}

		Collections.reverse(stB);
		stF.addAll(stB);
		for (Pair p : stF) {
			out.println(p);
		}
	}

	class Pair {
		int x, y;

		public Pair(int i, int j) {
			x = i;
			y = j;
		}

		@Override
		public String toString() {
			return (x + 1) + " " + (y + 1);
		}
	}
}
