// ""
//5-  -  2008-2009
// :  , ulyancev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class game_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new game_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "game_aa".substring(0, "game_aa".indexOf('_'));

	private void solve() throws IOException {
		// long tt = System.currentTimeMillis();
		int n = nextInt();
		inBounds(n, 1, 1000, "n");
		if (n == 1) {
			out.println(8);
			return;
		}
		Point[] a = new Point[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = new Point(nextInt(), nextInt());
			inBounds(a[i].x, -100000, 100000, "x[" + i + "]");
			inBounds(a[i].y, -100000, 100000, "y[" + i + "]");
		}
		Arrays.sort(a);
		long dx = a[n - 1].x - a[0].x;
		long dy = a[n - 1].y - a[0].y;
		long gcd = gcd(Math.abs(dx), Math.abs(dy));
		if (gcd == 0) {
			out.println(8);
		}
		dx /= gcd;
		dy /= gcd;
		boolean onLine = true;
		for (int i = 1; i < a.length; i++) {
			long dx0 = a[i].x - a[0].x;
			long dy0 = a[i].y - a[0].y;
			gcd = gcd(Math.abs(dx0), Math.abs(dy0));
			if (gcd == 0) {
				continue;
			}
			dx0 /= gcd;
			dy0 /= gcd;
			onLine &= dx == dx0 && dy == dy0;
			if (!onLine) {
				break;
			}
		}
		if (onLine) {
			if (Math.abs(dx) <= 1 && Math.abs(dy) <= 1) {
				out.println(7);
			} else {
				out.println(6);
			}
			return;
		}
		// long curtime = System.currentTimeMillis();
		// long build = 0;
		// long find = 0;
		// System.out.println((curtime - tt) / 1000.0);
		int[] dxd = new int[] { -1, -1, -1, 0, 0, 1, 1, 1 };
		int[] dyd = new int[] { -1, 0, 1, -1, 1, -1, 0, 1 };
		q = new boolean[n];
		t = new int[n];
		long[][] bx = new long[n][n];
		long[][] by = new long[n][n];
		for (int i = 0; i < bx.length; i++) {
			for (int j = 0; j < bx.length; j++) {
				bx[i][j] = a[j].x - a[i].x;
				by[i][j] = a[j].y - a[i].y;
			}
		}
		for (int qi = 0; qi < dyd.length; qi++) {
			for (int qj = 0; qj < qi; qj++) {
				int dx1 = dxd[qi];
				int dy1 = dyd[qi];
				int dx2 = dxd[qj];
				int dy2 = dyd[qj];
				// System.out.println(dx1 + " " + dy1 + " " + dx2 + " " + dy2
				// + " "
				// + ((System.currentTimeMillis() - curtime) / 1000.0));
				b = new boolean[n][n];
				int d = dx1 * dy2 - dx2 * dy1;
				if (d == 0)
					continue;
				// build -= System.currentTimeMillis();
				for (int i = 0; i < b.length; i++) {
					for (int j = 0; j < b[i].length; j++) {
						if (d != 0) {
							long a0 = (bx[i][j] * dy2 - by[i][j] * dx2) * d;
							long a1 = (-bx[i][j] * dy1 + by[i][j] * dx1) * d;
							if (a0 >= 0 && a1 >= 0) {
								b[i][j] = true;
							}
						}
					}
				}
				// build += System.currentTimeMillis();
				// find -= System.currentTimeMillis();
				time = 0;
				Arrays.fill(q, false);
				for (int i = 0; i < q.length; i++) {
					if (!q[i]) {
						dfs(i);
					}
				}
				// find += System.currentTimeMillis();
				boolean good = true;
				for (int i = 1; i < t.length; i++) {
					good &= b[t[i]][t[i - 1]];
					if (!good) {
						break;
					}
				}
				if (good) {
					out.println(6);
					return;
				}
			}
		}
		// System.out.println(build / 1000.0);
		// System.out.println(find / 1000.0);
		out.println(5);
		// System.out.println((System.currentTimeMillis() - tt) / 1000.0);
	}

	private void dfs(int x) {
		q[x] = true;
		for (int i = 0; i < b[x].length; i++) {
			if (b[x][i] && !q[i]) {
				dfs(i);
			}
		}
		t[time++] = x;
	}

	boolean[][] b;

	int[] t;

	int time;

	boolean[] q;

	private long gcd(long a, long b) {
		while (b != 0) {
			long tmp = a % b;
			a = b;
			b = tmp;
		}
		return a;
	}

	class Point implements Comparable<Point> {
		public Point(int i, int j) {
			x = i;
			y = j;
		}

		long x, y;

		public int compareTo(Point p) {
			return x < p.x ? -1 : x > p.x ? 1 : y < p.y ? -1 : y > p.y ? 1 : 0;
		}
	}

}
