import java.io.*;
import java.math.*;
import java.util.*;

public class game_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new game_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("game.in"));
			out = new PrintWriter("game.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	final int MAX_N = 1000;

	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= MAX_N, "n out of bounds exception");
		Point[] a = new Point[n];
		for (int i = 0; i < n; ++i) {
			a[i] = new Point(nextInt(), nextInt());
		}
		Arrays.sort(a);
		for (int i = 1; i < a.length; ++i) {
			myAssert(!a[i - 1].equals(a[i]), "Equal points!!! (" + a[i].x + ", " + a[i].y + ")");
		}
		int ans = 3;
		if (n == 1) {
			ans = 0;
		} else {
			long va = a[0].y - a[1].y;
			long vb = a[1].x - a[0].x;
			boolean ol = true;
			for (int i = 2; i < n; ++i) {
				if (va * (a[i].x - a[0].x) + vb * (a[i].y - a[0].y) != 0) {
					ol = false;
					break;
				}
			}
			if (ol) {
				long d = gcd(Math.abs(va), Math.abs(vb));
				if ((Math.abs(va) == d || Math.abs(va) == 0) && (Math.abs(vb) == d || Math.abs(vb) == 0)) {
					ans = 1;
				} else {
					ans = 2;
				}
			} else {

				for (Point p : a) {
					p.x = p.x * 2;
					p.y = p.y * 2;
				}
				bt: for (int mask = 0; mask < (1 << 8); ++mask) {
					if (Integer.bitCount(mask) != 2)
						continue;
					final long[] tdx = { dx[Integer.numberOfTrailingZeros(mask)],
							dx[Integer.numberOfTrailingZeros(mask - Integer.lowestOneBit(mask))] };
					final long[] tdy = { dy[Integer.numberOfTrailingZeros(mask)],
							dy[Integer.numberOfTrailingZeros(mask - Integer.lowestOneBit(mask))] };

					if (tdx[0] * tdy[1] - tdx[1] * tdy[0] == 0) {
						continue;
					}

					Comparator<Point> cmp = new Comparator<Point>() {
						@Override
						public int compare(Point a, Point b) {
							long d = tdx[0] * tdy[1] - tdx[1] * tdy[0];
							long ax = (tdy[1] * a.x - tdx[1] * a.y) / d;
							long bx = (tdy[1] * b.x - tdx[1] * b.y) / d;
							long ay = (tdx[0] * a.y - tdy[0] * a.x) / d;
							long by = (tdx[0] * b.y - tdy[0] * b.x) / d;
							return ax < bx ? -1 : ax > bx ? 1 : ay < by ? -1 : ay > by ? 1 : 0;
						}
					};

					Arrays.sort(a, cmp);

					long[] b = { Long.MIN_VALUE, Long.MIN_VALUE };
					for (Point p : a) {
						long d = tdx[0] * tdy[1] - tdx[1] * tdy[0];
						long px = (tdy[1] * p.x - tdx[1] * p.y) / d;
						long py = (tdx[0] * p.y - tdy[0] * p.x) / d;

						if (px < b[0]) {
							continue bt;
						} else {
							b[0] = px;
						}
						if (py < b[1]) {
							continue bt;
						} else {
							b[1] = py;
						}
					}
					ans = 2;
					break;
				}
			}
		}

		out.println(8 - ans);

	}

	int[] dx = { 1, 1, 0, -1, -1, -1, 0, 1 };
	int[] dy = { 0, 1, 1, 1, 0, -1, -1, -1 };

	long gcd(long a, long b) {
		if (a == 0) return b;
		return gcd(b % a, a);
	}

	final int MAX = (int) (1e+5);

	class Point implements Comparable<Point> {
		int x, y;

		public Point(int x, int y) {
			this.x = x;
			myAssert(-MAX <= x && x <= MAX, "x out of bounds exception");
			this.y = y;
			myAssert(-MAX <= y && y <= MAX, "y out of bounds exception");
		}

		@Override
		public String toString() {
			return x + " " + y;
		}

		@Override
		public boolean equals(Object o) {
			return (o instanceof Point) && this.compareTo((Point) o) == 0;
		}

		@Override
		public int compareTo(Point o) {
			return x < o.x ? -1 : x > o.x ? 1 : y < o.y ? -1 : y > o.y ? 1 : 0;
		}
	}
}
