// "-"
//5-  -  2008-2009
// :  , ulyancev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class gomoku_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new gomoku_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "gomoku_aa".substring(0, "gomoku_aa".indexOf('_'));

	private void solve() throws IOException {
		int n = nextInt();
		inBounds(n, 0, 10000, "n");
		HashSet<Long> hsx = new HashSet<Long>();
		HashSet<Long> hso = new HashSet<Long>();
		for (int move = 0; move < n; move++) {
			long x = nextLong();
			inBounds(x, -1000000000, 1000000000, "x[" + move + "]");
			long y = nextLong();
			inBounds(y, -1000000000, 1000000000, "y[" + move + "]");
			int[][] a = new int[9][9];
			for (int j = 0; j < a.length; j++) {
				Arrays.fill(a[j], -1);
			}
			long codexy = (x << 32L) + y;
			if (hsx.contains(codexy) || hso.contains(codexy)) {
				out.println("Inconsistent");
				return;
			}
			if (move % 2 == 0) {
				hsx.add(codexy);
			} else {
				hso.add(codexy);
			}
			x -= 4;
			y -= 4;
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					long code = ((x + i) << 32L) + (y + j);
					if (hsx.contains(code)) {
						a[i][j] = 0;
					}
					if (hso.contains(code)) {
						a[i][j] = 1;
					}
				}
			}
			// for (int i = 0; i < a.length; i++) {
			// for (int j = 0; j < a.length; j++) {
			// out.print(a[i][j] + " ");
			// }
			// out.println();
			// }
			// out.println();
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					if (a[i][j] >= 0) {
						boolean win = false;
						if (i + 4 < a.length) {
							boolean wint = true;
							for (int k = 0; k < 5; k++) {
								wint &= a[i + k][j] == a[i][j];
							}
							win |= wint;
						}
						if (j + 4 < a.length) {
							boolean wint = true;
							for (int k = 0; k < 5; k++) {
								wint &= a[i][j + k] == a[i][j];
							}
							win |= wint;
						}
						if (i + 4 < a.length && j + 4 < a.length) {
							boolean wint = true;
							for (int k = 0; k < 5; k++) {
								wint &= a[i + k][j + k] == a[i][j];
							}
							win |= wint;
						}
						if (i + 4 < a.length && j - 4 >= 0) {
							boolean wint = true;
							for (int k = 0; k < 5; k++) {
								wint &= a[i + k][j - k] == a[i][j];
							}
							win |= wint;
						}
						if (win) {
							if (move + 1 != n) {
								out.println("Inconsistent");
								return;
							}
							if (n % 2 == 1) {
								out.print("First ");
							} else {
								out.print("Second ");
							}
							out.println("player won");
							return;
						}
					}
				}
			}
		}
		out.println("Draw");
	}
}
