import java.util.*;
import java.io.*;

public class points_as implements Runnable {
    int n;
    boolean[][] a;
    int[] u;

    int dfs(int x, int c) {
        u[x] = c;
        int r = 1;
        for (int y = 0; y < n; y++) {
            if (u[y] == -1 && a[x][y]) {
                r ^= dfs(y, c);
            }
        }
        return r;
    }

    Map<Long, Boolean> memo;

    int[][] merge;

    long BASE = 501;

    String debug(int[] a, boolean v, int i, int j, int k) {
        return a[0] + " " + a[1] + " " + a[2] + " " + a[3] + ": " + (v ? 'A' : 'B') + " (" + i + (j == -1 ? "" : " " + j) + " -> " + k + ")";
    }

    boolean search(int[] a) {
        int[] c = a.clone();
        if (c[0] + c[1] + c[2] + c[3] == 1) {
            return false;
        }
        long v = c[0] + BASE * (c[1] + BASE * (c[2] + BASE * c[3]));
        if (v < 0) {
            System.out.println("!");
        }
        if (memo.containsKey(v)) {
            return memo.get(v);
        }

        if (c[2] > 0) {
            c[2]--;
            c[0]++;
            if (!search(c)) {
                memo.put(v, true);
//                System.out.println(debug(a, true, 2, -1, 0));
                return true;
            }
            c[2]++;
            c[0]--;
        }
        if (c[3] > 0) {
            c[3]--;
            c[1]++;
            if (!search(c)) {
                memo.put(v, true);
//                System.out.println(debug(a, true, 3, -1, 1));
                return true;
            }
            c[3]++;
            c[1]--;
        }
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (c[i] > 0 && c[j] > 0 && (i != j || c[i] > 1)) {
                    int k = merge[i][j];
                    c[i]--;
                    c[j]--;
                    c[k]++;
                    if (!search(c)) {
                        memo.put(v, true);
//                        System.out.println(debug(a, true, i, j, k));
                        return true;
                    }
                    c[i]++;
                    c[j]++;
                    c[k]--;
                }
            }
        }
        memo.put(v, false);
//        System.out.println(debug(a, false, 0, -1, 0));
        return false;
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("points.in"));
        PrintWriter out = new PrintWriter("points.out");

        n = in.nextInt();
        int m = in.nextInt();
        a = new boolean[n][n];
        for (int i = 0; i < m; i++) {
            int x = in.nextInt() - 1;
            int y = in.nextInt() - 1;
            assert !a[x][y];
            assert x != y;
            a[x][y] = a[y][x] = true;
        }

        u = new int[n];
        Arrays.fill(u, -1);
        int nc = 0;
        int[] cnt = new int[4];
        for (int i = 0; i < n; i++) {
            if (u[i] == -1) {
                int v = dfs(i, nc++);
                for (int j = 0; j < n; j++) {
                    for (int k = j + 1; k < n; k++) {
                        if (u[j] == nc - 1 && u[k] == nc - 1 && !a[j][k]) {
                            v ^= 2;
                        }
                    }
                }
                cnt[v]++;
            }
        }

        for (int i = 0; i < 4; i++) {
            System.out.print(cnt[i] + " ");
        }
        System.out.println();
        memo = new HashMap<Long, Boolean>();

        merge = new int[4][4];
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                merge[i][j] = ((i & 1) ^ (j & 1)) + ((((i & 1) & (j & 1)) ^ 1 ^ (i >> 1) ^ (j >> 1)) << 1);
            }
        }

        boolean win = search(cnt);
        if (win) {
            out.println("Theodor");
        } else {
            out.println("Maxim");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new points_as()).start();
    }
}