import java.io.*;
import java.math.*;
import java.util.*;

public class garland_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new garland_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("garland.in"));
			out = new PrintWriter("garland.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	int xc(String a, String b) {
		int ans = 0;
		for (int i = 0; i < a.length(); ++i) {
			if (a.charAt(i) != b.charAt(i)) {
				++ans;
			}
		}
		return ans;
	}
	
	void checkStr(String s, int n) {
		myAssert(s.length() == n, "Length incorrect");
		for (int i = 0; i < n; ++i) {
			myAssert('0' <= s.charAt(i) && s.charAt(i) <= '1', "s.charAt(i) out of bounds exception");
		}
	}
	
	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 1000, "n out of bounds exception");
		int m = nextInt();
		myAssert(1 <= m && m <= 17, "m out of bounds exception");
		String[] tab = new String[m];
		String st = "";
		for (int i = 0; i < n; ++i) {
			st += "0";
		}
		for (int i = 0; i < m; ++i) {
			tab[i] = nextToken();
			checkStr(tab[i], n);
		}
		int[][] g = new int[m][m];
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < m; ++j) {
				g[i][j] = xc(tab[i], tab[j]);
			}
		}
		
		int[][] D = new int[1 << m][m];
		for (int[] td : D) Arrays.fill(td, INF);
		for (int i = 0; i < m; ++i) {
			D[1 << i][i] = xc(st, tab[i]);
		}
		for (int mask = 0; mask < (1 << m); ++mask) {
			for (int l = 0; l < m; ++l) {
				int cur = D[mask][l];
				if (cur == INF) continue;
				int t = 1;
				for (int j = 0; j < m; ++j) {
					if ((t & mask) == 0) {
						if (D[t | mask][j] > cur + g[l][j]) {
							D[t | mask][j] = cur + g[l][j];
						}
					}
					t <<= 1;
				}
			}
		}
		int ans = INF;
		for (int l = 0; l < m; ++l) {
			ans = Math.min(D[(1 << m) - 1][l], ans);
		}
		out.println(ans);
	}
	
	final int INF = Integer.MAX_VALUE / 4;
}
