import java.io.*;
import java.math.*;
import java.util.*;

public class perm_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new perm_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("perm.in"));
			out = new PrintWriter("perm.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void checkString(String s) {
		BigInteger b = new BigInteger(s);
		myAssert(BigInteger.ONE.compareTo(b) <= 0 && BigInteger.TEN.pow(100000).compareTo(b) >= 0, "Number too big");
		myAssert(s.charAt(0) != '0', "Number starts with zero");
		char[] cs = s.toCharArray();
		for (char c : cs) {
			myAssert('0' <= c && c <= '9', "c out of bounds exception");
		}
	}
	String c;
	boolean less = false;
	int[] ans, cnt;
	
	
	boolean dfs(int i) {
		if (i == c.length()) return less;
		if (less) {
			for (int j = 9; j >= 0; --j) {
				if (cnt[j] > 0) {
					ans[i] = j;
					--cnt[j];
					return dfs(i + 1);
				}
			}
		} else {
			int k = c.charAt(i) - '0';
			if (cnt[k] > 0) {
				--cnt[k];
				ans[i] = k;
				if (dfs(i + 1)) return true;
				++cnt[k];
			}
			for (int j = k - 1; j >= 0; --j) {
				if (cnt[j] > 0) {
					--cnt[j];
					ans[i] = j;
					less = true;
					return dfs(i + 1);
				}
			}
		}
		return false;
	}
	
		
	void solve() throws IOException {
		String n = br.readLine();
		checkString(n);
		c = br.readLine();
		checkString(c);
		
		char[] ns = n.toCharArray();
		cnt = new int[10];
		for (int i = 0; i < ns.length; ++i) {
			++cnt[ns[i] - '0'];
		}
		if (n.length() > c.length()) {
			cnt[0] -= n.length() - c.length();
			if (cnt[0] < 0) {
				out.println(-1);
				return;
			}
		}
		ans = new int[Math.min(c.length(), n.length())];
		if (n.length() < c.length()) {
			int j = 0;
			for (int i = 9; i >= 0; --i) {
				while (cnt[i]-- > 0) {
					ans[j++] = i;
				}
			}
		} else {
			if (!dfs(0)) {
				out.println(-1);
				return;
			}
		}
		boolean st = false;
		for (int i : ans) {
			st |= i != 0;
			if (i == 0 && st || i != 0) {
				out.print(i);
			}
		}
		out.println();		
	}
}
