import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class poker_as implements Runnable {
    int r;
    int s;
    int d;
    int c;

    BigInteger[][] ch;
    BigInteger[] fact;

    BigInteger countFlushes() {
        BigInteger[][] a = new BigInteger[d + 1][s + 1];
        for (BigInteger[] z : a) {
            Arrays.fill(z, BigInteger.ZERO);
        }
        BigInteger[][] b = new BigInteger[d + 1][s + 1];
        for (BigInteger[] z : b) {
            Arrays.fill(z, BigInteger.ZERO);
        }
        a[0][0] = BigInteger.ONE;

        for (int j = 1; j <= s; j++) {
            for (int i = 0; i <= d; i++) {
                for (int k = 0; k < c && k <= i && k <= r; k++) {
                    a[i][j] = a[i][j].add(ch[r][k].multiply(ch[i][k].multiply(fact[k]).multiply(a[i - k][j - 1])));
                    b[i][j] = b[i][j].add(ch[r][k].multiply(ch[i][k].multiply(fact[k]).multiply(b[i - k][j - 1])));
                }
                for (int k = c; k <= d && k <= i && k <= r; k++) {
                    b[i][j] = b[i][j].add(ch[r][k].multiply(ch[i][k].multiply(fact[k]).multiply(a[i - k][j - 1].add(b[i - k][j - 1]))));
                }
            }
        }

        return b[d][s];
    }

    BigInteger countStraights() {
        BigInteger[][][] a = new BigInteger[d + 1][r + 1][r + 1];
        BigInteger[][][] b = new BigInteger[d + 1][r + 1][r + 1];
        for (int i = 0; i <= d; i++) {
            for (int j = 0; j <= r; j++) {
                Arrays.fill(a[i][j], BigInteger.ZERO);
                Arrays.fill(b[i][j], BigInteger.ZERO);
            }
        }
        a[0][0][0] = BigInteger.ONE;

        for (int i = 1; i <= d; i++) {
            for (int j = 1; j <= r; j++) {
                a[i][j][1] = BigInteger.ZERO;
                b[i][j][1] = BigInteger.ZERO;
                for (int k = 1; k <= s && k <= i; k++) {
                    for (int p = 0; p == 0 || p <= j - 2; p++) {
                        for (int l = 0; l <= c - 1 && l <= r; l++) {
                            a[i][j][1] = a[i][j][1].add(ch[s][k].multiply(a[i - k][p][l]));
                            b[i][j][1] = b[i][j][1].add(ch[s][k].multiply(b[i - k][p][l]));
                        }
                        for (int l = c; l <= r; l++) {
                            b[i][j][1] = b[i][j][1].add(ch[s][k].multiply(b[i - k][p][l]));
                        }
                    }
                }
                for (int z = 2; z <= r; z++) {
                    a[i][j][z] = BigInteger.ZERO;
                    b[i][j][z] = BigInteger.ZERO;
                    for (int k = 1; k <= i && k <= s; k++) {
                        if (z < c) {
                            a[i][j][z] = a[i][j][z].add(ch[s][k].multiply(a[i - k][j - 1][z - 1]));
                        } else {
                            b[i][j][z] = b[i][j][z].add(ch[s][k].multiply(a[i - k][j - 1][z - 1]));
                        }
                        b[i][j][z] = b[i][j][z].add(ch[s][k].multiply(b[i - k][j - 1][z - 1]));
                    }
                }
            }
        }

        BigInteger straights = BigInteger.ZERO;
        for (int i = 0; i <= r; i++) {
            for (int j = 0; j <= r; j++) {
                straights = straights.add(b[d][i][j]);
            }
        }
        return straights.multiply(fact[d]);
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("poker.in"));
        PrintWriter out = new PrintWriter(new File("poker.out"));

        int sumrs = 0;
        while (true) {
            r = in.nextInt();
            s = in.nextInt();
            d = in.nextInt();
            c = in.nextInt();
            if (r == 0) {
                break;
            }
            sumrs += r * s * r * s;
            assert d <= s * r;
            assert c <= d;

            if (c == 1) {
                out.println("1/1");
                out.println("1/1");
                out.println();
                continue;
            }

            int sz = Math.max(Math.max(r, d), s);
            ch = new BigInteger[sz + 1][sz + 1];
            for (BigInteger[] z : ch) {
                Arrays.fill(z, BigInteger.ZERO);
            }
            ch[0][0] = BigInteger.ONE;
            for (int i = 1; i <= sz; i++) {
                ch[i][0] = BigInteger.ONE;
                for (int j = 1; j <= sz; j++) {
                    ch[i][j] = ch[i - 1][j - 1].add(ch[i - 1][j]);
                }
            }

            fact = new BigInteger[sz + 1];
            fact[0] = BigInteger.ONE;
            for (int i = 1; i <= sz; i++) {
                fact[i] = fact[i - 1].multiply(BigInteger.valueOf(i));
            }

            BigInteger total = BigInteger.ONE;
            for (int i = 0; i < d; i++) {
                total = total.multiply(BigInteger.valueOf(r * s - i));
            }

            BigInteger straights = countStraights();
            BigInteger tmp = straights.gcd(total);
            out.println(straights.divide(tmp) + "/" + total.divide(tmp));
            BigInteger flushes = countFlushes();
            tmp = flushes.gcd(total);
            out.println(flushes.divide(tmp) + "/" + total.divide(tmp));
            out.println();
        }

        System.err.println(sumrs);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new poker_as()).start();
    }
}