import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class poker_as_dumb implements Runnable {
    int r;
    int s;
    int d;
    int c;
    int[] k;

    BigInteger[][] ch;
    BigInteger[] fact;

    BigInteger flushes;

    void count(int j, int left, boolean hasF) {
        if (j == s) {
            if (left == 0 && hasF) {
                BigInteger t = BigInteger.ONE;
                int v = d;
                for (int i = 0; i < s; i++) {
                    t = t.multiply(ch[v][k[i]]);
                    t = t.multiply(ch[r][k[i]]);
                    t = t.multiply(fact[k[i]]);
                    v -= k[i];
                }
                flushes = flushes.add(t);
            }
            return;
        }

        for (k[j] = 0; k[j] <= r && k[j] <= left; k[j]++) {
            count(j + 1, left - k[j], hasF || k[j] >= c);
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("poker.in"));
        PrintWriter out = new PrintWriter(new File("poker.out"));

        r = in.nextInt();
        s = in.nextInt();
        d = in.nextInt();
        c = in.nextInt();
        assert d <= s * r;
        assert c <= d;

        int sz = Math.max(r, d);
        ch = new BigInteger[sz + 1][sz + 1];
        for (BigInteger[] z : ch) {
            Arrays.fill(z, BigInteger.ZERO);
        }
        ch[0][0] = BigInteger.ONE;
        for (int i = 1; i <= sz; i++) {
            ch[i][0] = BigInteger.ONE;
            for (int j = 1; j <= sz; j++) {
                ch[i][j] = ch[i - 1][j - 1].add(ch[i - 1][j]);
            }
        }

        fact = new BigInteger[sz + 1];
        fact[0] = BigInteger.ONE;
        for (int i = 1; i <= sz; i++) {
            fact[i] = fact[i - 1].multiply(BigInteger.valueOf(i));
        }

        BigInteger total = BigInteger.ONE;
        for (int i = 0; i < d; i++) {
            total = total.multiply(BigInteger.valueOf(r * s - i));
        }

        flushes = BigInteger.ZERO;
        k = new int[s];
        count(0, d, false);

        BigInteger tmp = flushes.gcd(total);

        out.println(flushes.divide(tmp) + "/" + total.divide(tmp));

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new poker_as_dumb()).start();
    }
}
