import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class poker_as_superdumb implements Runnable {
    int r;
    int s;
    int d;
    int c;

    int total;
    int straights;
    int flushes;

    int[] st;
    int[] rk;

    int[] card;

    int[] suits;
    boolean[] ex;

    boolean isFlush() {
        Arrays.fill(suits, 0);
        for (int i = 0; i < d; i++) {
            int j = st[card[i]];
            suits[j]++;
            if (suits[j] >= c) {
                return true;
            }
        }
        return false;
    }

    boolean isStraight() {
        Arrays.fill(ex, false);
        for (int i = 0; i < d; i++) {
            int j = rk[card[i]];
            ex[j] = true;
        }
        int l = 0;
        for (int i = 0; i < r; i++) {
            if (ex[i]) {
                l++;
                if (l >= c) {
                    return true;
                }
            } else {
                l = 0;
            }
        }
        return false;
    }

    void bt(int p, int f) {
        if (p == d) {
            total++;
            if (isStraight()) {
                straights++;
            }
            if (isFlush()) {
                flushes++;
            }
            return;
        }

        for (int i = f; i < r * s; i++) {
            card[p] = i;
            bt(p + 1, i + 1);
        }
    }

    int gcd(int x, int y) {
        while (y != 0) {
            int t = x % y;
            x = y;
            y = t;
        }
        return x;
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("poker.in"));
        PrintWriter out = new PrintWriter(new File("poker.out"));

        while (true) {
            r = in.nextInt();
            s = in.nextInt();
            d = in.nextInt();
            c = in.nextInt();
            if (r == 0) {
                break;
            }
            assert d <= s * r;
            assert c <= d;

            st = new int[r * s];
            rk = new int[r * s];

            int k = 0;
            for (int i = 0; i < r; i++) {
                for (int j = 0; j < s; j++) {
                    rk[k] = i;
                    st[k] = j;
                    k++;
                }
            }

            card = new int[d];
            suits = new int[s];
            ex = new boolean[r];
            total = straights = flushes = 0;
            bt(0, 0);

            int d = gcd(straights, total);
            out.println((straights / d) + "/" + (total / d));
            d = gcd(flushes, total);
            out.println((flushes / d) + "/" + (total / d));
            out.println();
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new poker_as_superdumb()).start();
    }
}